/*
 * logique.2.h
 * Copyright (C) 2006-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene0fa_logique_2_H__
#define __Mylene0fa_logique_2_H__

#define UPDATE_LOSS(context_data, size, state, status) \
    {									      \
	unsigned loss_index;						      \
									      \
	loss_index = (context_data)->loss_index;			      \
	if ((status) < (context_data)->flush_loss) {			      \
	    (context_data)->flush_loss -= (status);			      \
	} else {							      \
	    loss_index += (status);					      \
	    loss_index -= (context_data)->flush_loss;			      \
	    (context_data)->flush_loss = 0;				      \
	}								      \
	if (loss_index < (size)) {					      \
	} else {							      \
	    loss_index -= (size);					      \
	}								      \
	(state)[1] = loss_index;					      \
	(context_data)->loss_index = loss_index;			      \
    }

#endif				/* __Mylene0fa_logique_2_H__ */
