/*
 * logique.3.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene0fa_logique_3_H__
#define __Mylene0fa_logique_3_H__

#include <config.h>

#include <logique.1.h>

extern int Mylene0fa_break_mylene(struct context_state *, int *, int);
#if !__Mylene0fa_LINE_INTER__
extern int Mylene0fa_catch_stream(struct context_state *);
#endif				/* !__Mylene0fa_LINE_INTER__ */
#if HERE_UNDERFLOW == EXIT_UNDERFLOW
extern int Mylene0fa_class_device(struct context_state *);
#endif				/* HERE_UNDERFLOW == EXIT_UNDERFLOW */
extern int Mylene0fa_class_mylene(struct context_state *);
#if WAIT_SLEEP == Mylene0fa_SLEEP
extern int Mylene0fa_class_stream(struct context_state *, unsigned *);
#endif				/* WAIT_SLEEP == Mylene0fa_SLEEP */
extern int Mylene0fa_clear_device(struct context_state *);
extern int Mylene0fa_clear_stream(struct context_state *);
extern int Mylene0fa_cycle_device(struct context_state *);
extern int Mylene0fa_flush_device(struct context_state *, int);
extern int Mylene0fa_flush_stream(struct context_state *, int);
extern int Mylene0fa_index_stream(struct context_state *, unsigned *);
#if !__SYNCRONIZE_STREAMS__
extern int Mylene0fa_merge_device(struct context_state *);
#endif				/* !__SYNCRONIZE_STREAMS__ */
extern int Mylene0fa_merge_stream(struct context_state *);
extern int Mylene0fa_pause_mylene(struct context_state *);
extern int Mylene0fa_queue_mylene(struct context_state *, unsigned, void *);
extern int Mylene0fa_reset_stream(struct context_state *, int);
extern int Mylene0fa_setup_device(struct context_state *);
extern int Mylene0fa_setup_stream(struct context_state *);
extern int Mylene0fa_shift_device(struct context_state *, int);
extern int Mylene0fa_shift_stream(struct context_state *);
extern int Mylene0fa_space_stream(struct context_state *);
extern int Mylene0fa_stamp_mylene(struct context_state *);
#if __Mylene0fa_LINE_INTER__
extern int Mylene0fa_trail_stream(struct context_state *);
#endif				/* __Mylene0fa_LINE_INTER__ */
extern int Mylene0fa_trans_mylene(struct context_state *);
extern int Mylene0fa_write_mylene(struct context_state *);

#endif				/* __Mylene0fa_logique_3_H__ */
