/*
 * tsxx.m.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tsnode(tsnode)			((struct fpnode_type *) (tsnode))

#define tslist(tslist)			((struct tslist_type *) (tslist))

int
_libx1f4l2_case_tslist(void *tslist, unsigned index, void *fast, void **seek)
{
    struct fpnode_type *fpnode_data, *fqnode_data;
    unsigned tilt = 0;

    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
    fqnode_data = &tslist(tslist)->link_a.fplist.fplink;

    while (1) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		if (!index) {
		    break;
		} else {
		    if (0) {
		    } else {
			index--;
			tilt = 1;
		    }
		}
	    } else {
		struct fpnode_type *fpnode_miss;
		unsigned Class;

		fpnode_miss = fpnode_data->fpnode_data[0];
		Class = fpnode_miss->fqnode.size;
		if (Class == index) {
		    break;
		} else {
		    if (index < Class) {
			tilt = 0;
		    } else {
			index -= Class + 1;
			tilt = 1;
		    }
		}
	    }
	}

	fqnode_data = fpnode_data;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    if (1) {
	void *f0node, *f1node;

	if (_libx1f4l2_back_tslist(&f0node, fpnode_data)) {
	} else {
	    f0node = NULL;
	}
	if (_libx1f4l2_lock_tslist(&f1node, fpnode_data)) {
	} else {
	    f1node = NULL;
	}
	if (f0node) {
	    if (tsnode(f0node)->fqnode.fbnode.bits & NEXT_T) {
		tsnode(f0node)->fpnode_data[1] = fqnode_data;
	    }
	}
	if (f1node) {
	    if (tsnode(f1node)->fqnode.fbnode.bits & LAST_T) {
		tsnode(f1node)->fpnode_data[0] = fqnode_data;
	    }
	}
    }

    *seek = fpnode_data;

    fqnode_data->fpnode_data[tilt] = fast;

    fqnode_data = fast;
    *fqnode_data = *fpnode_data;

    return 0;
}
