/*
 * 1f44.9.c
 * Copyright (C) 2004-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <unistd.h>

#include <defs.h>
#include <inter.h>
#include <types.h>

int
seek_1f44_fini(struct x1f44v_type *x1f44v_data)
{
    int status = -1;
    void *data;

    data = x1f44v_data->data;

    switch (x1f44v_data->type) {
    case X1f440_DATA:
	status = close(((struct x1f440_type *) data)->fd);
	break;
    case X1f441_DATA:
	_seek_1f44_free_entries
	    (((struct x1f441_type *) data)->record_data,
	     ((struct x1f441_type *) data)->count);
	if (1) {
	    int fd;

	    fd = ((struct x1f441_type *) data)->fd;
	    if (fd != -1) {
		status = close(fd);
	    } else {
		status = 0;
	    }
	}
    }

    free(data);

    return status;
}
