/*
 * 1f44.e.c
 * Copyright (C) 2004-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <lcard.h>
#include <types.h>

int
seek_1f44_rail(struct x1f44v_type *x1f44v_data, void *offset)
{
    struct x1f441_type *x1f441_data;

    x1f441_data = x1f44v_data->data;

    x1f441_data->index = 0;
    x1f441_data->fd = -1;
    if (!offset) {
	LCARD_SET_CARD1(x1f441_data->offset, 0);
    } else {
	LCARD_SET_CARD2(x1f441_data->offset, *(lcard_type *) offset);
    }

    return 0;
}
