m4_define([A0], [AC_DEFUN([$1], [$2])])
m4_define([A1], [AC_CACHE_CHECK([$1], [$2], [$3])])

A0([LL_SET_PATH],
   [if test "${prefix}" = "NONE"; then
	AC_DEFINE(__install_prefix, "/usr/local", [None])
	AC_DEFINE(__install_prefix_length, 10, [None])
    else
	if false; then
	    ll_prefix_length=`expr length "${prefix}"`
	else
	    ll_prefix_length_f=`echo -n "${prefix}" | wc -c`
	    ll_prefix_length=`echo ${ll_prefix_length_f}`
	fi
	AC_DEFINE_UNQUOTED(__install_prefix, "${prefix}")
	AC_DEFINE_UNQUOTED(__install_prefix_length, ${ll_prefix_length})
    fi])

A0([MX_SEE_HALF],
   [Mylene1f4_have_e1f4_h="no"
    AC_CHECK_HEADER(e1f4.h, Mylene1f4_have_e1f4_h="yes")
    Mylene1f4_have_h262_h="no"
    AC_CHECK_HEADER(h262.h, Mylene1f4_have_h262_h="yes")
    Mylene1f4_have_aime_h="no"
    AC_CHECK_HEADER(aime.h, Mylene1f4_have_aime_h="yes")
    Mylene1f4_have_libaime="no"
    AC_CHECK_LIB(aime, x1f4_dset_lxlist, Mylene1f4_have_libaime="yes")
    Mylene1f4_have_libseek_mpeg="no"
    Mylene1f4_have_libMylene1f4="cannot-say"
    Mylene1f4_have_libseek_h262="cannot-say"
    AC_CHECK_LIB(seek.mpeg, Mylene1f4_init_tables,
		 Mylene1f4_have_libseek_mpeg="yes")
    if test $Mylene1f4_have_libseek_mpeg = "yes"; then
	true
    else
	AC_CHECK_LIB(Mylene1f4, Mylene1f4_init_tables,
		     Mylene1f4_have_libMylene1f4="yes",
		     Mylene1f4_have_libMylene1f4="no")
	AC_CHECK_LIB(seek.h262, seek_h262_iso11172_stream,
		     Mylene1f4_have_libseek_h262="yes",
		     Mylene1f4_have_libseek_h262="no")
    fi

    Mylene1f4_fatal="no"
    if test $Mylene1f4_have_e1f4_h = "no"; then
	Mylene1f4_fatal="yes"
    elif test $Mylene1f4_have_h262_h = "no"; then
	Mylene1f4_fatal="yes"
    elif test $Mylene1f4_have_libseek_mpeg = "no"; then
	if test $Mylene1f4_have_libMylene1f4 = "no"; then
	    Mylene1f4_fatal="yes"
	elif test $Mylene1f4_have_libseek_h262 = "no"; then
	    Mylene1f4_fatal="yes"
	fi
    fi

    if test $Mylene1f4_fatal = "yes"; then
	here_m0="\n\nI cannot build Mylene1f4 for I am missing the seek-h262"
	half_m0="${here_m0} MPEG decoder.\n"
	here_m1="${half_m0}These were the missing or unavailable"
	here_m2="${here_m1} bits of the decoder:\n"
	if test $Mylene1f4_have_e1f4_h = "no"; then
	    here_m3="${here_m2}\tthe e1f4.h header\n"
	else
	    here_m3="${here_m2}"
	fi
	if test $Mylene1f4_have_h262_h = "no"; then
	    here_m4="${here_m3}\tthe h262.h header\n"
	else
	    here_m4="${here_m3}"
	fi
	if test $Mylene1f4_have_libseek_mpeg = "no"; then
	    if test $Mylene1f4_have_libMylene1f4 = "no"; then
		here_m5="${here_m4}\tthe Mylene1f4 library\n"
	    else
		here_m5="${here_m4}"
	    fi
	    if test $Mylene1f4_have_libseek_h262 = "no"; then
		here_m6="${here_m5}\tthe seek.h262 library\n"
	    else
		here_m6="${here_m5}"
	    fi
	else
	    here_m6="${here_m4}"
	fi
	if test $Mylene1f4_have_aime_h = "no"; then
	    complain_bout_i0="yes"
	elif test $Mylene1f4_have_libaime = "no"; then
	    complain_bout_i0="yes"
	else
	    complain_bout_i0="no"
	fi
	if test $complain_bout_i0 = "yes"; then
	    here_m7="${here_m6}\n"
	    half_m7="${here_m7}aime also seems missing or unavailable.\n"
	    here_m8="${half_m7}I can build Mylene1f4 without aime,"
	    here_m9="${here_m8} though half of Mylene1f4 is there.\n"
	else
	    here_m9="${here_m6}"
	fi
	here_message="$here_m9"
	AC_ERROR($here_message)
    fi])
