/*
 * e1f4.0.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <e1f4.h>

#define SIZE(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->size)
#define SYNCWORD_OFFSET(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->syncword_offset)

void
mylene1f4_reset_state(void *e1f4)
{
    Mylene1f4_clear_state(e1f4);

    SIZE(e1f4) = 0;
    SYNCWORD_OFFSET(e1f4) = 0;
}
