/*
 * pcardinal.n-b.c
 * Copyright (C) 2002-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <pnon.h>

void
x1f4_nprint_bpcardinal(unsigned *put, unsigned b, unsigned base,
		       unsigned major, unsigned minor)
{
    pnon_type c;
    unsigned f = 0;

    PNON_SET_PAIR(c, major, minor);

    do {
	f++;
	PNON_VLX_CARD(c, base);
    } while (PNON_DAY_DATA(c));

    if (b) {
	f += (f - 1) / b;
    }

    *put += f;
}
