/*
 * pcardinal.v-b.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <config.h>

#if !defined LIBx1f4i0
# include <pcardinal.p-b.h>
#endif				/* !LIBx1f4i0 */
#if defined LIBx1f4i0
# include <inter.h>
#endif				/* LIBx1f4i0 */

#define BASE_SIZE		(SIZEOF_UNSIGNED << 3)
#define DATE_SIZE		(BASE_SIZE << 1)
#define THIS_SIZE		(DATE_SIZE << 1)

int
x1f4_vprint_bpcardinal(void *data,
		       int (*this) (void *, const char *, unsigned), int big,
		       unsigned b, unsigned base, unsigned major,
		       unsigned minor)
{
    char aime[THIS_SIZE], *mode;

    mode = aime + THIS_SIZE;
    x1f4_xprint_bpcardinal(&mode, big, b, base, major, minor);

    return this(data, mode, aime + THIS_SIZE - mode);
}
