/*
 * pnon_0.1.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <config.h>

#include <stddef.h>

#include <pnon.h>

#if PNON_DEFINITION == PNON_STRUCT_DEFINITION
static void deck_this_2_0(void *, void *);
#endif				/* PNON_DEFINITION == PNON_STRUCT_DEFINITION */

void (*const __libx1f4i0_pnon_0_1_2[]) (void *, void *) = {
/* *INDENT-OFF* */
#if PNON_DEFINITION == PNON_STRUCT_DEFINITION
    deck_this_2_0
#else
    NULL
#endif				/* PNON_DEFINITION == PNON_STRUCT_DEFINITION */
/* *INDENT-ON* */
};

#if PNON_DEFINITION == PNON_STRUCT_DEFINITION
static void
deck_this_2_0(void *data, void *text)
{
    PNON_C_TYPE a, b, c, d, i;
    pnon_type *pnon_data;

    i = *(unsigned *) text;

    pnon_data = data;

    b = pnon_data->a;
    d = pnon_data->b;

    a = b >> PNON_C_HALF;
    c = d >> PNON_C_HALF;

    b &= PNON_C_MASK;
    d &= PNON_C_MASK;

    a *= i;
    b *= i;
    c *= i;
    d *= i;

    c += d >> PNON_C_HALF;
    b += c >> PNON_C_HALF;
    a += b >> PNON_C_HALF;

    pnon_data->a = a << PNON_C_HALF | (b & PNON_C_MASK);
    pnon_data->b = c << PNON_C_HALF | (d & PNON_C_MASK);
}
#endif				/* PNON_DEFINITION == PNON_STRUCT_DEFINITION */
