/*
 * back3.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__
# include <inter.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_fast_back(void *context, unsigned track)
{
    int status;
    unsigned miss;
    unsigned char *lift, size[4];

    miss = track;
    lift = size + 3;
    if (!(miss & ~127)) {
	*lift = miss;
    } else {
	*lift = miss & 127;
	lift--;
	miss >>= 7;
	*lift = 128 | (miss & 127);
	miss >>= 7;
	miss &= (1 << 14) - 1;
	while (miss) {
	    lift--;
	    *lift = 128 | (miss & 127);
	    miss >>= 7;
	}
    }

    status = Mylene1f4_pipe_back(context, (char *) lift, size + 4 - lift);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
