/*
 * list5.c
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_TAGGED_LIST__
# include <list.h>
# include <types.h>
#endif				/* __ENABLE_TAGGED_LIST__ */

#if __ENABLE_TAGGED_LIST__
int
Mylene1f4_wind_list(void *id3tag, void *list29)
{
    char **data, *line;
    unsigned i, record, *size, *tags;

    tags = ((struct list29_type *) list29)->shift;
    line = list29;

    record = *tags;
    tags += 2;

    data = ((struct id3tag_type *) id3tag)->data;
    size = ((struct id3tag_type *) id3tag)->size;

    for (i = 0; i < 6; i++) {
	if ((1 << i) & record) {
	    *data++ = line + *tags;
	    *size++ = tags[-1] - *tags - 1;
	} else {
	    *data++ = line + *tags - 1;
	    *size++ = 0;
	}

	tags++;
    }

    return 0;
}
#endif				/* __ENABLE_TAGGED_LIST__ */
