/*
 * misc4.c
 * Copyright (C) 2007-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__
# include <access.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_lock_i144(void *context, unsigned c, unsigned deck, unsigned size)
{
    int delete;

    do {
	struct frame4_type *frame4_data;
	unsigned list;

	frame4_data = Frame4(context);

	list = EXCESS(context).e1.list87.count;

	if (deck) {
	    if (!size) {
		delete = 1;

		break;
	    } else {
		if (list < size) {
		    delete = 1;

		    break;
		}
	    }
	} else {
	    if (size < list) {
	    } else {
		delete = 1;

		break;
	    }
	}

	if (c == 0x34) {
	    if (deck) {
		size = list - size;
	    } else {
	    }
	} else {
	    if (deck) {
		size = size - 1;
	    } else {
		size = list - 1 - size;
	    }
	}

	delete = 0;

	Mylene1f4_fix_index(context, &list);

	if (size < list) {
	    frame4_data->i144.post = list - size;
	    frame4_data->i144.sign = Mylene1f4_LOAD_LAST;
	} else {
	    frame4_data->i144.post = size - list;
	    frame4_data->i144.sign = Mylene1f4_LOAD_NEXT;
	}
    } while (0);

    return delete;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_swap_last(void *context, unsigned order)
{
    unsigned Order;

    Order = LOAD_ORDER(context);
    if ((Order == Mylene1f4_LOAD_LAST && order != Mylene1f4_LOAD_LAST)
	|| (Order != Mylene1f4_LOAD_LAST && order == Mylene1f4_LOAD_LAST)) {
	Mylene1f4_half_list(context);
    }

    LOAD_ORDER(context) = order;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
