/*
 * record2.c
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <access.h>
#include <types.h>

int
Mylene1f4_fix_record(void *context, int (*data) (void *))
{
    int false = 1;
    struct record_type *record_data;

    record_data = RECORD(context);
    while (record_data) {
	if (record_data->data == data) {
	    false = 0;

	    break;
	}

	record_data = record_data->record_data;
    }

    return false;
}
