/*
 * source3.c
 * Copyright (C) 2006-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <access.h>
#include <inter.h>
#include <types.h>

int
Mylene1f4_stat_source(void *context)
{
    struct x1f42a_type *x1f42a_data;

    x1f42a_data = X1f42(context);
    if (!x1f42a_data) {
	/*
	 * FEATURES
	 *
	 * will wrongly assume that the source is the context source
	 */
	Mylene1f4_fprintf_error(context, "`%s'", SOURCE(context)._.s1.path);
    } else {
	if (!x1f42a_data->nentries) {
	    Mylene1f4_fprintf_error(context, "`%s'", x1f42a_data->source.path);
	} else {
	    Mylene1f4_fprintf_error(context, "%s", "hell knows what");
	    /*
	     * TODO
	     *
	     * hell does know, and so should I...
	     */
	}
    }

    return 0;
}
