/*
 * sc0.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <inter.h>

int
Mylene200_sand_reflex(void *context, unsigned track)
{
    int status;
    unsigned aime, miss;
    unsigned char *lift, size[4];

    aime = track;
    lift = size + 3;
    miss = aime;
    if (!(miss & ~127)) {
	*lift = miss;
    } else {
	*lift = miss & 127;
	lift--;
	miss >>= 7;
	*lift = 128 | (miss & 127);
	miss >>= 7;
	miss &= (1 << 14) - 1;
	while (miss) {
	    lift--;
	    *lift = 128 | (miss & 127);
	    miss >>= 7;
	}
    }

    status = Mylene200_push_reflex(context, size + 4 - lift, lift);

    return status;
}
