/*
 * sc3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <string.h>

#include <access.h>
#include <inter.h>

int
Mylene200_fail_reflex(void *context)
{
    Mylene200_fprintf_error
	(context, "%s: cannot write Mylene1f4\n", Mylene200(context));

    return 0;
}


int
Mylene200_land_reflex(void *context)
{
    Mylene200_fprintf_error
	(context, "%s: cannot read Mylene1f4: %s\n", Mylene200(context),
	 strerror(errno));

    return 0;
}


int
Mylene200_lose_reflex(void *context)
{
    Mylene200_fprintf_error
	(context, "%s: cannot write Mylene1f4: %s\n", Mylene200(context),
	 strerror(errno));

    return 0;
}


int
Mylene200_miss_reflex(void *context)
{
    Mylene200_fprintf_error
	(context, "%s: cannot read Mylene1f4 (connection closed)\n",
	 Mylene200(context));

    return 0;
}
