/*
 * ss0.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
# include <stdlib.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_push_thread(void *context, void *client)
{
    int status;
    struct thread_type *near_thread, *thread_data;
    unsigned deck = 2;

    near_thread = THREAD(context);

    if (near_thread) {
	if (2 < near_thread->deck) {
	} else {
	    while (1) {
		struct thread_type *next_thread;

		deck++;
		next_thread = near_thread->thread_data;
		if (!next_thread) {
		    break;
		} else {
		    if (next_thread->deck == deck) {
			near_thread = next_thread;
		    } else {
			break;
		    }
		}
	    }
	}
    }

    thread_data = (struct thread_type *) malloc(sizeof(struct thread_type));
    if (!thread_data) {
	Mylene200_stat_system(context);

	status = -1;
    } else {
	unsigned miss;

	status = 0;

	miss = client(client)->post;

	thread_data->client_data = client;

	thread_data->deck = deck;
	thread_data->miss = miss;

	client(client)->delete = thread_data;

	if (!near_thread) {
	    THREAD(context) = thread_data;

	    thread_data->fast_thread = NULL;
	    thread_data->thread_data = NULL;
	} else {
	    if (!near_thread->fast_thread && 2 < near_thread->deck) {
		THREAD(context) = thread_data;

		thread_data->fast_thread = NULL;
		thread_data->thread_data = near_thread;

		near_thread->fast_thread = thread_data;
	    } else {
		struct thread_type *next_thread;

		next_thread = near_thread->thread_data;

		near_thread->thread_data = thread_data;

		thread_data->fast_thread = near_thread;

		if (!next_thread) {
		    thread_data->thread_data = NULL;
		} else {
		    thread_data->thread_data = next_thread;

		    next_thread->fast_thread = thread_data;
		}
	    }
	}

	near_thread = client(client)->shrews;
	if (!near_thread) {
	    client(client)->shrews = thread_data;

	    thread_data->last_thread = NULL;
	    thread_data->miss_thread = NULL;
	} else {
	    if (miss < near_thread->miss) {
		client(client)->shrews = thread_data;

		thread_data->last_thread = NULL;
		thread_data->miss_thread = near_thread;

		near_thread->last_thread = thread_data;
	    } else {
		while (1) {
		    struct thread_type *next_thread;

		    next_thread = near_thread->miss_thread;
		    if (!next_thread) {
			near_thread->miss_thread = thread_data;

			thread_data->last_thread = near_thread;

			thread_data->miss_thread = NULL;

			break;
		    } else {
			if (next_thread->miss < miss) {
			    near_thread = next_thread;
			} else {
			    near_thread->miss_thread = thread_data;

			    thread_data->last_thread = near_thread;

			    thread_data->miss_thread = next_thread;

			    next_thread->last_thread = thread_data;

			    break;
			}
		    }
		}
	    }
	}

# if __ENABLE_DEBUG__
	Mylene200_type_debug(context, " -- [thread   added]\n");
	Mylene200_dump_channels(context);
# endif				/* __ENABLE_DEBUG__ */
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
