/*
 * ss1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_peek_thread(void *context, void **thread, unsigned deck)
{
    struct thread_type *thread_data;

    thread_data = THREAD(context);
    while (thread_data) {
	if (thread_data->deck == deck) {
	    break;
	} else {
	    thread_data = thread_data->thread_data;
	}
    }

    *thread = thread_data;

    return 0;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
