/*
 * ss3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <defs.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_post_thread(void *context, void *client)
{
    struct window_type *last_window, *miss_window, *window_data;

    window_data = &SHREWS(context);

    window_data->client_data = client;
    window_data->type = 0017;
    window_data->last_window = NULL;

    miss_window = client(client)->window;
    if (miss_window) {
	miss_window->last_window = window_data;
    }

    window_data->miss_window = miss_window;
    client(client)->window = window_data;

    last_window = WINDOW(context);

    WINDOW(context) = window_data;

    FLAGS(context) |= Mylene200_MISS_SHREWS;

    window_data->window_data = last_window;

    if (!last_window) {
	CLASS9(context) = window_data;
    }
 
    return 0;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
