/*
 * ss4.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_lose_thread(void *client, void **thread, unsigned deck)
{
    struct thread_type *thread_data;

    thread_data = client(client)->shrews;

    if (thread_data) {
	if (thread_data->miss == deck) {
	    struct thread_type *miss_thread;

	    miss_thread = thread_data->miss_thread;
	    if (!miss_thread) {
		client(client)->shrews = NULL;
	    } else {
		miss_thread->last_thread = NULL;
		client(client)->shrews = miss_thread;
	    }
	} else {
	    struct thread_type *last_thread;

	    last_thread = thread_data;
	    while (1) {
		thread_data = thread_data->miss_thread;
		if (!thread_data) {
		    break;
		} else {
		    if (thread_data->miss != deck) {
			last_thread = thread_data;
		    } else {
			struct thread_type *miss_thread;

			miss_thread = thread_data->miss_thread;
			if (!miss_thread) {
			    last_thread->miss_thread = NULL;
			} else {
			    miss_thread->last_thread = last_thread;
			    last_thread->miss_thread = miss_thread;
			}

			break;
		    }
		}
	    }
	}
    }

    *thread = thread_data;

    return 0;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
