/*
 * a1-defs.h
 * Copyright (C) 2006-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_a1_DEFS_H__
#define __LIBx1f4_a1_DEFS_H__

/*
 * error definitions
 */
#define ALLOC_ERROR			1
#define PARSE_ERROR			2

/*
 * generation flag definitions
 * not used: 0x1
 */
#define COMPOSER_LINK			(1L << 0x2)
#define ERROR_STORAGE			(1L << 0x0)
#define DIRECT_ACCESS			(1L << 0x3)
#define EELOOKUP_LINK			(1L << 0x4)
#define IMPLICIT_LINK			(1L << 0x6)
#define LEAD_FLATTEXT			(1L << 0x7)
#define LINE_OPTIMIZE			(1L << 0x8)
#define RELATION_LINK			(1L << 0x9)
#define RESOURCE_LINK			(1L << 0xa)
#define SIDELIST_LINK			(1L << 0xc)
#define SKIP_SCOMMENT			(1L << 0xb)
#define TEXTFLAT_LINK			(1L << 0xd)
#define TRANSFER_LINK			(1L << 0xe)
#define TYPELIST_LINK			(1L << 0xf)

/*
 * record definitions
 */
#define HINT_MASK			(1L << 0x0)

#endif				/* __LIBx1f4_a1_DEFS_H__ */
