/*
 * a1-errors.h
 * Copyright (C) 2007-2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_a1_ERRORS_H__
#define __LIBx1f4_a1_ERRORS_H__

#define C_SYNTAX			-129
#define FAILLINK			-130
/* not used */
#define FAILNAME			-132
/* not used */
#define FAILTYPE			-134
#define FLATTYPE			-135
#define HIGHEROF			-136
/* not used */
#define LESSLINK			-138
/* not used */
#define LOSELIST			-140
#define LOSETEXT			-141
#define MAINLIST			-142
#define MAINTYPE			-143
#define MISSLEAD			-144
#define MISSLINE			-145
#define MISSLINK			-146
#define MISSLIST			MISSTYPE
#define MISSMAIN			-147
#define MISSNAME			-148
#define MISSPOST			MISSTYPE
#define MISSTYPE			-149
#define NEARTYPE			-150
#define OPENLIST			-151
#define OPENTEXT			-152
#define POSTFEAT			-153
#define RESERVED			-154
#define SIDELINE			-155
#define VOIDPOST			-156
#define XDEFINED			-157

#define INTERNAL			-896

#define NAMECALL			-129
#define NAMETYPE			-130
#define SLIPTYPE			-131

#define DEFINITE			-896

#endif				/* __LIBx1f4_a1_ERRORS_H__ */
