/*
 * lxflat-inter.h
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxflat_inter_H__
#define __LIBx1f4_lxflat_inter_H__

#include <e4.h>
#include <lxflat-types.h>
#include <lxwide.h>
#include <nt.h>

#define _libx1f4i0_lxflat_bset_flat	x1f4_bset_lxflat
#define _libx1f4i0_lxflat_clip_flat	x1f4_clip_lxflat
#define _libx1f4i0_lxflat_copy_flat	x1f4_copy_lxflat
#define _libx1f4i0_lxflat_dset_flat	x1f4_dset_lxflat
#define _libx1f4i0_lxflat_fini_flat	x1f4_fini_lxflat
#define _libx1f4i0_lxflat_flat_flat	x1f4_flat_lxflat
#define _libx1f4i0_lxflat_free_flat	x1f4_free_lxflat
#define _libx1f4i0_lxflat_fset_flat	x1f4_fset_lxflat
#define _libx1f4i0_lxflat_init_flat	x1f4_init_lxflat
#define _libx1f4i0_lxflat_lead_flat	x1f4_lead_lxflat
#define _libx1f4i0_lxflat_line_flat	x1f4_line_lxflat
#define _libx1f4i0_lxflat_link_flat	x1f4_link_lxflat
#define _libx1f4i0_lxflat_near_flat	x1f4_near_lxflat
#define _libx1f4i0_lxflat_node_flat	x1f4_node_lxflat
#define _libx1f4i0_lxflat_post_flat	x1f4_post_lxflat
#define _libx1f4i0_lxflat_push_flat	x1f4_push_lxflat
#define _libx1f4i0_lxflat_seek_flat	x1f4_seek_lxflat
#define _libx1f4i0_lxflat_slip_flat	x1f4_slip_lxflat
#define _libx1f4i0_lxflat_tile_flat	x1f4_tile_lxflat
#define _libx1f4i0_lxflat_type_flat	x1f4_type_lxflat

extern int _libx1f4i0_lxflat_bset_flat
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxflat_clip_flat
    (const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxflat_copy_flat
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxflat_dset_flat
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxflat_fini_flat(void **);
extern int _libx1f4i0_lxflat_flat_flat(void *, void **);
extern int _libx1f4i0_lxflat_free_flat
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxflat_fset_flat
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxflat_init_flat
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxflat_lead_flat(void *, void **);
extern int _libx1f4i0_lxflat_line_flat(void *, void **);
extern int _libx1f4i0_lxflat_link_flat(void *, void **);
extern int _libx1f4i0_lxflat_near_flat(void *);
extern int _libx1f4i0_lxflat_node_flat
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxflat_post_flat
    (void *, void **, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxflat_push_flat
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxflat_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxflat_seek_flat(const void *);
extern int _libx1f4i0_lxflat_side_flat(void *, void *);
extern int _libx1f4i0_lxflat_slip_flat(void *, void **);
extern int _libx1f4i0_lxflat_stat_free(void *, int);
extern int _libx1f4i0_lxflat_stat_link(void *);
extern int _libx1f4i0_lxflat_tile_flat
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxflat_type_flat
    (const void *, struct x1f4_nodetype_type *, int);

#endif				/* __LIBx1f4_lxflat_inter_H__ */
