/*
 * x1f4i2.c.c
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <defs.h>
#include <types.h>

int
x1f4_mode_xaudio(void *xaudio, unsigned rate, unsigned channels,
		 unsigned format, unsigned flags)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = xaudio;

    status = 0;
    if (status) {
	status <<= SELF_SHIFT;
    } else {
	xaudio_data->rate = rate * channels << 1;
	xaudio_data->size = 0;
	xaudio_data->size2 = 0;

	xaudio_data->c = channels;
	xaudio_data->e = rate;

	xaudio_data->ordered = 0;
	xaudio_data->started = 0;
    }

    return status;
}
