/*
 * setup.c
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>

#include <defs.h>
#include <types.h>

extern int _aapple_audio_open(void *);

int
_apple_audio_setup(void *xaudio)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = xaudio;

    status = _aapple_audio_open(xaudio);
    if (status) {
	status <<= SELF_SHIFT;
    } else {
	xaudio_data->started = 1;
    }

    return status;
}

