/*
 * x1f4i2.4.c
 * Copyright (C) 2005-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/time.h>

#include <inter.h>
#include <trace.h>

int
x1f4_fini_xaudio(void **xaudio, int now)
{
    int excess, status;
    struct timeval time;

    METHOD_ENTER();

    status = x1f4_clip_xaudio(*xaudio, now, &time);

    excess = x1f4_lose_xaudio(xaudio);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    METHOD_LEAVE(status);

    return status;
}
