/*
 * types.h
 * Copyright (C) 2005-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_TYPES_H__
#define __LIBx1f4i2_TYPES_H__

#include <config.h>

typedef struct aerror_type {
    int excess;
} aerror_type;

typedef struct xaudio_type {
    unsigned rate;
#if __REAL_ACCELERATION__ == 1
    double size;
#elif 7 < SIZEOF_UNSIGNED_LONG
    unsigned long size;
#else
    unsigned long long size;
#endif				/* __REAL_ACCELERATION__ == 1 */
    void *xaudio;
} xaudio_type;

#endif				/* __LIBx1f4i2_TYPES_H__ */
