/*
 * x1f4i2.c.c
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <libxaudio.h>
#include <stdlib.h>

#include <class.h>
#include <defs.h>
#include <types.h>

int
x1f4_mode_xaudio(void *xaudio, unsigned rate, unsigned channels,
		 unsigned format, unsigned flags)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = xaudio;

    FIX_CLASS(format, format);

    status = libxaudio_mode_xaudio
	(xaudio_data->xaudio, rate, channels, format, flags);
    if (status) {
	status <<= SELF_SHIFT;
    } else {
	xaudio_data->rate = rate * channels << 1;
	xaudio_data->size = 0;
    }

    return status;
}
