/*
 * e1f4.1.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_1_H__
#define __Mylene1f4_1_H__

#include <e1f4.3.h>

extern void _Mylene1f4_abort_decoding(struct Mylene1f4_whatever *, unsigned);
extern void _Mylene1f4_break_section(struct Mylene1f4_audio *, unsigned);
extern void _Mylene1f4_class_section(struct Mylene1f4_audio *, unsigned);
extern void _Mylene1f4_do_time
    (struct Mylene1f4_audio *, Mylene1f4_real *, Mylene1f4_real *, unsigned,
     struct Mylene1f4_granule *);
extern void _Mylene1f4_init_AnnexB(void);
extern void _Mylene1f4_intensity_stereo
    (Mylene1f4_real *, unsigned *, struct Mylene1f4_granule *, unsigned,
     unsigned, unsigned);
extern void _Mylene1f4_ms_stereo(Mylene1f4_real *, struct Mylene1f4_granule *);
extern void _Mylene1f4_part3
    (struct Mylene1f4_audio *, unsigned char **, unsigned *, unsigned *,
     unsigned *, unsigned *, unsigned *, Mylene1f4_real *,
     struct Mylene1f4_granule *, unsigned);
extern void _Mylene1f4_set_11172_audio_attributes(struct Mylene1f4_audio *);
extern void _Mylene1f4_set_13818_audio_attributes(struct Mylene1f4_audio *);
extern void _Mylene1f4_set_buffer(struct Mylene1f4_audio *, unsigned char *);

extern void Mylene1f4_11172_frame(struct Mylene1f4_audio *);
extern void Mylene1f4_correct_underflow(struct Mylene1f4_audio *);
extern void Mylene1f4_dct64_0
    (Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *);
extern void Mylene1f4_polyphase_synthesis_0
    (struct Mylene1f4_audio *, Mylene1f4_real *, void *, unsigned);
extern void Mylene1f4_polyphase_synthesis_1
    (struct Mylene1f4_audio *, Mylene1f4_real *, unsigned, void *, unsigned);
extern void Mylene1f4_syncword_offset(unsigned, unsigned *);

#endif				/* __Mylene1f4_1_H__ */
