/*
 * e1f4.2.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_2_H__
#define __Mylene1f4_2_H__

#include <e1f4.0.h>

/*
 * ID definitions
 */
#if WORDS_BIGENDIAN
# define ID_mask			0x00080000
#else
# define ID_mask			0x00000800
#endif				/* WORDS_BIGENDIAN */

/*
 * layer definitions
 */
#define Layer_I				3
#define Layer_II			2
#define Layer_III			1

/*
 * mode definitions
 */
#define joint_stereo			1
#define single_channel			3

/*
 * mode definitions (continued)
 */
#if WORDS_BIGENDIAN
# define mode_mask			0x000000c0
#else
# define mode_mask			0xc0000000
#endif				/* WORDS_BIGENDIAN */

#endif				/* __Mylene1f4_2_H__ */
