/*
 * e1f4.5.h
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_5_H__
#define __Mylene1f4_5_H__

#if 0
# define MAX_CFRAMES \
    ((320000 * 144 / 32000 * 8) / (32000 * 144 / 48000 * 8))
#else
# define MAX_CFRAMES			15
#endif

#define MAX_NFRAMES			16
#if MAX_NFRAMES < MAX_CFRAMES
# undef MAX_NFRAMES
# define MAX_NFRAMES			32
#endif				/* MAX_NFRAMES < MAX_CFRAMES */
#if MAX_NFRAMES < MAX_CFRAMES
# undef MAX_NFRAMES
# define MAX_NFRAMES			64
#endif				/* MAX_NFRAMES < MAX_CFRAMES */

#define MAX_XFRAMES			((MAX_NFRAMES) - 1)

#define ADVANCE_FRAME(frame) \
    {									      \
	(frame)++;							      \
	(frame) &= MAX_XFRAMES;						      \
    }

#define RESTORE_FRAME(frame) \
    {									      \
	(frame) += MAX_XFRAMES;						      \
	(frame) &= MAX_XFRAMES;						      \
    }

#endif				/* __Mylene1f4_5_H__ */
