/*
 * e1f4.a.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_A_H__
#define __Mylene1f4_A_H__

/*
 * audio errors definitions
 */
#define AUDIO_AUDIO_DATA_FAULT		0x01
#define AUDIO_BAD_IMPLEMENTATION	0x02
#define AUDIO_FORBIDDEN_BITRATE_INDEX	0x03
#define AUDIO_FUCKED_UP_AUDIO_HEADER	0x04
#define AUDIO_INVALID_BACKWARD_SEEK	0x05
#define AUDIO_NULL_BLOCK_TYPE		0x06
#define AUDIO_RESERVED_SAMPLING_FREQUENCY \
					0x07
#define AUDIO_SHORT_SAMPLES_SECTION	0x08
#define AUDIO_UNSUPPORTED_BITRATE_INDEX	0x09

#define AUDIO_NUMBER_OF_ERROR_CODES	0x0a

#endif				/* __Mylene1f4_A_H__ */
