/*
 * h262.1.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_1_H__
#define __SEEK_H262_1_H__

#include <h262.0.h>
#include <h262.3.h>

extern void _seek_h262_GRAYSCALE_x10_macroblocks(struct seek_h262_video *);
extern void _seek_h262_GRAYSCALE_x08_11172_slices(struct seek_h262_video *);
extern void _seek_h262_GRAYSCALE_x20_11172_slices(struct seek_h262_video *);
extern void _seek_h262_GRAYSCALE_x___11172_slicEs(struct seek_h262_video *);
extern void _seek_h262_GRAYSCALE_x___11172_slices(struct seek_h262_video *);
extern void _seek_h262_GRAYSCALE_x___13818_slices(struct seek_h262_video *);
extern void _seek_h262_SKIP______x_________slices(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x10_macroblocks(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x08_11172_slices(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x20_11172_slices(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x___11172_slicEs(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x___11172_slices(struct seek_h262_video *);
extern void _seek_h262_YCbCr_____x___13818_slices(struct seek_h262_video *);
extern void _seek_h262___________macroblocks(struct seek_h262_video *);
extern void _seek_h262___________x08_11172_slices(struct seek_h262_video *);
extern void _seek_h262___________x18_macroblocks(struct seek_h262_video *);
extern void _seek_h262___________x20_11172_slices(struct seek_h262_video *);
extern void _seek_h262___________x___11172_slices(struct seek_h262_video *);
extern void _seek_h262___________x___13818_slices(struct seek_h262_video *);
extern void _seek_h262_abort_decoding(struct seek_h262_whatever *, unsigned);
extern void _seek_h262_abort_divergent_decoding
    (struct seek_h262_whatever *, unsigned char *, unsigned, unsigned);
extern void _seek_h262_alloc_storage
    (struct seek_h262_video *, unsigned, unsigned);
extern void _seek_h262_artificial_extension_or_user_data
    (struct seek_h262_video *);
extern void _seek_h262_compute_11172_motion_limit(struct seek_h262_video *);
extern void _seek_h262_compute_13818_motion_limit(struct seek_h262_video *);
extern void _seek_h262_copy_quantiser
    (seek_h262_scan_index *, seek_h262_scan_index *);
extern void _seek_h262_changed_sequence_extension(struct seek_h262_video *);
extern void _seek_h262_changed_sequence_header(struct seek_h262_video *);
extern void _seek_h262_detail_x08_f_codes
    (struct seek_h262_video *, unsigned *);
extern void _seek_h262_detail_x10_f_codes
    (struct seek_h262_video *, unsigned *);
extern void _seek_h262_detail_x18_f_codes
    (struct seek_h262_video *, unsigned *);
extern void _seek_h262_dump_quantiser(seek_h262_scan_index *, unsigned char *);
extern void _seek_h262_init_AnnexB(void);
extern void _seek_h262_motion_component
    (unsigned, unsigned *, unsigned *, unsigned *, unsigned char **);
extern void _seek_h262_next_11172_x00000100(struct seek_h262_video *);
extern void _seek_h262_reset_quantiser(seek_h262_scan_index *);
extern void _seek_h262_set_11172_video_attributes(struct seek_h262_video *);
extern void _seek_h262_set_13818_slice_blocks(struct seek_h262_video *);
extern void _seek_h262_set_GRAYSCALE_11172_blocks(struct seek_h262_video *);
extern void _seek_h262_set_GRAYSCALE_13818_blocks(struct seek_h262_video *);
extern void _seek_h262_set_YCbCr_____11172_blocks(struct seek_h262_video *);
extern void _seek_h262_set_YCbCr_____13818_blocks(struct seek_h262_video *);
extern void _seek_h262_set_quantiser_matrices
    (struct seek_h262_video *, seek_h262_scan_index *(*)[12]);
extern void _seek_h262_set_quantiser
    (const unsigned char *, seek_h262_scan_index *);
extern void _seek_h262_set_quantisers(struct seek_h262_video *);
extern void _seek_h262_set_references(struct seek_h262_video *);
extern void _seek_h262_system_header(struct seek_h262_system *);
extern void _seek_h262_video_sequence_11172(struct seek_h262_video *);
#if __ENABLE_X00000100___HACK_2__
extern void _seek_h262_x00000100___hack_2(struct seek_h262_video *);
#endif				/* __ENABLE_X00000100___HACK_2__ */
extern void _seek_h262_xprogram_stream_map(struct seek_h262_system *);

extern void seek_h262_PES_packet(struct seek_h262_system *);
extern void seek_h262_aspect_ratio_information
    (unsigned, unsigned *, unsigned *, unsigned *);
extern void seek_h262_artificial_pack_header(struct seek_h262_system *);
extern void seek_h262_frame_rate_code_to_frame_rate_value
    (unsigned, unsigned *, unsigned *);
extern void seek_h262_get_colorspace(void *, unsigned *);
extern void seek_h262_matrix_coefficients(unsigned, const int **);
extern void seek_h262_neXt_start_code(struct seek_h262_whatever *);
extern void seek_h262_next_11172_x00000100(struct seek_h262_video *);
extern void seek_h262_next_13818_x00000100(struct seek_h262_video *);
extern void seek_h262_next_start_code(struct seek_h262_whatever *);
extern void seek_h262_pack_header(struct seek_h262_system *);
extern void seek_h262_packet(struct seek_h262_system *);
extern void seek_h262_pel_aspect_ratio(unsigned, unsigned *, unsigned *);
extern void seek_h262_quant_matrix_extension(struct seek_h262_video *);
extern void seek_h262_reset_video_motion_attributes(void *, unsigned);
extern void seek_h262_seek_start_code(struct seek_h262_whatever *);
extern void seek_h262_set_colorspace(void *, unsigned);
extern void seek_h262_subsequent_sequence_header(struct seek_h262_video *);

#endif				/* __SEEK_H262_1_H__ */
