/*
 * h262.3.l7.h
 * Copyright (C) 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_3_L7_H__
#define __SEEK_H262_3_L7_H__

#include <h262.0.h>
#include <h262.3.h>
#include <h262.6.d4.h>

#if !__FIX_ALIGN_COEFFICIENTS__
# define __11172_MACROBLOCK_decls \
    struct seek_h262_11172_macroblock macroblock
#else
# define __11172_MACROBLOCK_decls \
    seek_h262_coefficient __fix_aligned_coefficients[ALIGNED_BLOCK_SIZEx006]; \
    struct seek_h262_11172_macroblock macroblock
#endif				/* !__FIX_ALIGN_COEFFICIENTS__ */

#if !__FIX_ALIGN_COEFFICIENTS__
# define __13818_MACROBLOCK_decls \
    struct seek_h262_13818_macroblock macroblock
#else
# define __13818_MACROBLOCK_decls \
    seek_h262_coefficient __fix_aligned_coefficients[ALIGNED_BLOCK_SIZEx014]; \
    struct seek_h262_13818_macroblock macroblock
#endif				/* !__FIX_ALIGN_COEFFICIENTS__ */

#if !__FIX_ALIGN_COEFFICIENTS__
# define __MACROBLOCK_setup()
#else
# define __MACROBLOCK_setup() \
    macroblock.coefficients = (seek_h262_coefficient *) \
	((char *) __fix_aligned_coefficients				      \
	 + ((BLOCK_ALIGNMENT						      \
	     - ((integral_q) __fix_aligned_coefficients			      \
		& (BLOCK_ALIGNMENT - 1))) & (BLOCK_ALIGNMENT - 1)))
#endif				/* !__FIX_ALIGN_COEFFICIENTS__ */

#endif				/* __SEEK_H262_3_L7_H__ */
