/*
 * h262.8.part3.c
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.3.h>

void
seek_h262_video_matrix_coefficients(struct seek_h262_video *video,
				    unsigned *matrix_coefficients)
{
    unsigned coefficients = 0;

    if (((integral_q) video->slices[0] & 65535) == 11172) {
    } else {
	if (video->sequence_display_extension_seen) {
	    if (video->sequence_display_extension[0] & 1) {
		coefficients = video->sequence_display_extension[3];
	    }
	}
    }

    *matrix_coefficients = coefficients;
}
