/*
 * h262.b.h
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_B_H__
#define __SEEK_H262_B_H__

#define LOWER_LEVEL(value, step) \
    ((value) % (step))
#define NEXT_LEVEL(value, step) \
    ((value) + ((step) - (value) % (step)) % (step))
#define PREVIOUS_LEVEL(value, step) \
    ((value) - (value) % (step))
#define UPPER_LEVEL(value, step) \
    (((step) - (value) % (step)) % (step))

#endif				/* __SEEK_H262_B_H__ */
