/*
 * h262.f.part3.c
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.2.h>
#include <h262.3.h>

#if __ENABLE_X000001AF___HACK_0__
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code				      \
     && video->start_code < video->break_code)
#elif WORDS_BIGENDIAN
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0x000001b0)
#else
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0xb0010000)
#endif				/* __ENABLE_X000001AF___HACK_0__ */

void
_seek_h262_SKIP______x_________slices(struct seek_h262_video *video)
{
    do {
	seek_h262_seek_start_code((struct seek_h262_whatever *) video);
    } while (MAMAN_A_TORT(video));
}
