/*
 * logique.0.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene0fa_logique_0_H__
#define __Mylene0fa_logique_0_H__

/*
 * error definitions
 */
#define Mylene0fa_data_error		001
#define Mylene0fa_flow_error		002
#define Mylene0fa_head_error		003
#define Mylene0fa_miss_error		004
#define Mylene0fa_post_error		005
#define Mylene0fa_read_error		006
#define Mylene0fa_tail_error		007

/*
 * state definitions
 */
#define Mylene0fa_B1st_STATE		003
#define Mylene0fa_REAL_STATE		002

/*
 * state indexed 3 definitions
 */
#define Mylene0fa_B1st_PLAYING		(1L << 0x0)
#define Mylene0fa_B1st_DELAYED		(1L << 0x1)

#endif				/* __Mylene0fa_logique_0_H__ */
