/*
 * fsvv.h.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <fsvv-types.h>
#include <tslist.h>

#define fslist(fslist)			((struct fslist_type *) (fslist))

int
_libx1f4l2_pipe_fslist(void *fslist, const char *data, unsigned size,
		       void *node)
{
    int status;
    unsigned base, miss;
    void *push;

    base = fslist(fslist)->link_0.base;

    miss = base + size + 1;

    status = x1f4_push_tslist
	(fslist(fslist) + 1, fslist(fslist)->link_2.spin,
	 sizeof(void *) + miss + fslist(fslist)->link_2.link, &push);
    if (status) {
    } else {
	void **f1st;

	f1st = push;

	*f1st = node;

	push = f1st + 1;

	*fslist(fslist)->link_1.miss = miss;
	*fslist(fslist)->link_1.push = push;

	push = (char *) push + base;

	memcpy(push, data, size);
	if (1) {
	    char *flat;

	    flat = (char *) push + size;
	    *flat = 0;
	}
    }

    return status;
}
