/*
 * fsxx.c.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fsxx-types.h>
#include <trans.h>

#define fspost(fspost)			((struct fspost_type *) (fspost))

int
x1f4_aime_fspost(void *fspost, void *trans)
{
    ((struct trans_type *) trans)->data = fspost(fspost)->link_m.data;
    ((struct trans_type *) trans)->free = fspost(fspost)->link_m.free;
    ((struct trans_type *) trans)->link = fspost(fspost)->link_m.link;
    ((struct trans_type *) trans)->mode = fspost(fspost)->link_m.mode;

    return 0;
}
