/*
 * fsxx.e.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fsxx-defs.h>
#include <fsxx-types.h>

static int fini_list(struct fspost_type *);

static int
fini_list(struct fspost_type *fspost_data)
{
    int excess, (*free) (void *, void *), status;
    struct fsnode_type **fsdata;
    void *text;

    free = fspost_data->link_m.free;
    text = fspost_data->link_m.data;

    fsdata = fspost_data->link_a.fsmiss.fsnode.fslist.fslist;

    status = free(text, *fsdata);
    if (status) {
	status = FREE_ERROR;
    }
    excess = free(text, fsdata);
    if (excess) {
	if (status) {
	} else {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
x1f4_flat_fspost(void *fspost)
{
    int status;

    if (1) {
	status = fini_list(fspost);
    }

    return status;
}
