/*
 * tsxx.q.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-names.h>
#include <tsxx-types.h>

int
_libx1f4l2_back_tslist(void **back, void *data)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = data;

    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[0];
	if (!fqnode_data) {
	    delete = 0;
	} else {
	    delete = 1;

	    *back = fqnode_data;
	}
    } else {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[0];
	while (1) {
	    if (fqnode_data->fqnode.fbnode.bits & NEXT_T) {
		*back = fqnode_data;

		delete = 1;

		break;
	    } else {
		fpnode_data = fqnode_data->fpnode_data[1];
		if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
		    *back = fpnode_data;

		    delete = 1;

		    break;
		} else {
		    fqnode_data = fpnode_data->fpnode_data[1];
		}
	    }
	}
    }

    return delete;
}
