/*
 * tsxy.0.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-names.h>
#include <tsxx-types.h>

#define class_break(fbnode_data, fsnode_data, tslist) \
    {									      \
	if (0) {							      \
	} else {							      \
	    struct fpnode_type *f1node_data, *f2node_data;		      \
									      \
	    f1node_data = (fsnode_data);				      \
	    f2node_data = (fsnode_data);				      \
									      \
	    while (1) {							      \
		if (GET_N(f2node_data)) {				      \
		    if (1) {						      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f2node_data->fpnode_data[1];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[0]		      \
				    == (fsnode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_L(f1node_data)) {		      \
				f1node_data = f1node_data->fpnode_data[0];    \
			    }						      \
									      \
			    (fbnode_data) = f1node_data->fpnode_data[0];      \
			} while (0);					      \
									      \
			break;						      \
		    }							      \
		} else {						      \
		    if (GET_L(f1node_data)) {				      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f1node_data->fpnode_data[0];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[1]		      \
				    == (fsnode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_N(f2node_data)) {		      \
				f2node_data = f2node_data->fpnode_data[1];    \
			    }						      \
									      \
			    (fbnode_data) = f2node_data->fpnode_data[1];      \
			} while (0);					      \
									      \
			break;						      \
		    } else {						      \
			f1node_data = f1node_data->fpnode_data[0];	      \
			f2node_data = f2node_data->fpnode_data[1];	      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }

#define GET_L(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & LAST_T)
#define GET_N(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & NEXT_T)

int
x1f4_tile_tslist(unsigned *index, void *data)
{
    struct fpnode_type *fpnode_data;
    unsigned class;

    fpnode_data = (struct fpnode_type *) data - 1;

    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	class = 0;
    } else {
	class = fpnode_data->fpnode_data[0]->fqnode.size;
    }

    while (1) {
	struct fpnode_type *fqnode_data;

	class_break(fqnode_data, fpnode_data, tslist);
	if (!fqnode_data) {
	    break;
	} else {
	    if (fpnode_data == fqnode_data->fpnode_data[1]) {
		class++;
		if (fqnode_data->fqnode.fbnode.bits & LAST_T) {
		} else {
		    class += fqnode_data->fpnode_data[0]->fqnode.size;
		}
	    }

	    class_break(fpnode_data, fqnode_data, tslist);
	    if (!fpnode_data) {
		break;
	    } else {
		if (fqnode_data == fpnode_data->fpnode_data[1]) {
		    class++;
		    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		    } else {
			class += fpnode_data->fpnode_data[0]->fqnode.size;
		    }
		}
	    }
	}
    }

    *index = class;

    return 0;
}
