/*
 * 1f44.1.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <defs.h>
#include <lcard.h>
#include <types.h>

int
seek_1f44_size(struct x1f44v_type *x1f44v_data, void *offset)
{
    if (x1f44v_data->type == X1f441_DATA) {
#if 0
	lcard_type Offset, *output;
	struct record_type *record_data;
	struct x1f441_type *x1f441_data;

	x1f441_data = x1f44v_data->data;
	record_data = x1f441_data->record_data + x1f441_data->count - 1;
	LCARD_SET_CARD2(Offset, record_data->deck);
	LCARD_ADD_CARD2(Offset, record_data->size);

	output = offset;
	LCARD_SET_CARD2(*output, Offset);
#else
	lcard_type *output;
	struct x1f441_type *x1f441_data;

	x1f441_data = x1f44v_data->data;
	output = offset;
	LCARD_SET_CARD2(*output, x1f441_data->size);
#endif				/* 0 */
    }

    return 0;
}
