/*
 * sshell.e.h
 * Copyright (C) 2007-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4_SSHELL_E_H__
#define __LIBx1f4_SSHELL_E_H__

#define CELL_ERROR			-32
#define FLOW_ERROR			-33
#define FORK_ERROR			-34
#define LINE_ERROR			-35
#define LOCK_ERROR			-36
#define NEAR_ERROR			-37
#define PIPE_ERROR			-38
#define POLL_ERROR			-39
#define READ_ERROR			-40
#define WAIT_ERROR			-41

#endif				/* __LIBx1f4_SSHELL_E_H__ */
