/*
 * aime2.h
 * Copyright (C) 2007-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#if __ENABLE_EQUEUE__
# define nonsense_081027_0_logique(context, output, input, status) \
    {									      \
	(status) = x1f4_vprint_dlintegral				      \
	    (becca((context))[1], inter2line(*becca((context))),	      \
	     I_MODE((input)[0]));					      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081027_7_logique_i(context, b, f, x, input, status) \
    {									      \
	(status) = x1f4_vprint_fblintegral				      \
	    (becca((context))[1], inter2line(*becca((context))), 0, (f), (b), \
	     (x), I_MODE((input)[3]));					      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081027_7_logique(context, output, input, status) \
    {									      \
	X1f4_E4_C_MODE b;						      \
									      \
	b = I_MODE((input)[0]);						      \
	if (b < 0) {							      \
	    (status) = 0;						      \
	} else {							      \
	    X1f4_E4_C_MODE f;						      \
									      \
	    f = I_MODE((input)[1]);					      \
	    if (f < 0) {						      \
		(status) = 0;						      \
	    } else {							      \
		X1f4_E4_C_MODE x;					      \
									      \
		x = I_MODE((input)[2]);					      \
		if (x < 2) {						      \
		    (status) = 0;					      \
		} else {						      \
		    if (36 < x) {					      \
			(status) = 0;					      \
		    } else {						      \
			nonsense_081027_7_logique_i			      \
			    ((context), (b), (f), (x), (input), (status));    \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081027_f_logique_i(context, b, f, x, input, status) \
    {									      \
	X1f4_E4_C_MODE w;						      \
									      \
	w = I_MODE((input)[0]);						      \
	if (!(w < 0)) {							      \
	    (status) = x1f4_vprint_wfblintegral				      \
		(becca((context))[1], inter2line(*becca((context))), 0, w,    \
		 (f), (b), (x), I_MODE((input)[4]));			      \
	} else {							      \
	    (status) = x1f4_vprint_fblintegral				      \
		(becca((context))[1], inter2line(*becca((context))), 0, (f),  \
		 (b), (x), I_MODE((input)[4]));				      \
	    if ((status)) {						      \
	    } else {							      \
		unsigned v = 0;						      \
									      \
		x1f4_nprint_fblintegral					      \
		    (&v, (f), (b), (x), I_MODE((input)[4]));		      \
		w = -w;							      \
		if (v < w) {						      \
		    (status) = x1f4_vprint_space			      \
			(becca((context))[1], inter2line(*becca((context))),  \
			 w - v);					      \
		}							      \
	    }								      \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081027_f_logique(context, output, input, status) \
    {									      \
	X1f4_E4_C_MODE b;						      \
									      \
	b = I_MODE((input)[1]);						      \
	if (b < 0) {							      \
	    (status) = 0;						      \
	} else {							      \
	    X1f4_E4_C_MODE f;						      \
									      \
	    f = I_MODE((input)[2]);					      \
	    if (f < 0) {						      \
		(status) = 0;						      \
	    } else {							      \
		X1f4_E4_C_MODE x;					      \
									      \
		x = I_MODE((input)[3]);					      \
		if (x < 2) {						      \
		    (status) = 0;					      \
		} else {						      \
		    if (36 < x) {					      \
			(status) = 0;					      \
		    } else {						      \
			nonsense_081027_f_logique_i			      \
			    ((context), (b), (f), (x), (input), (status));    \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081028_1_logique_i(context, p, input, status) \
    {									      \
	(status) = x1f4_vprint_float					      \
	    (becca((context))[1], inter2line(*becca((context))), (p),	      \
	     I_REAL((input)[1]));					      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081028_1_logique(context, output, input, status) \
    {									      \
	X1f4_E4_C_MODE p;						      \
									      \
	p = I_MODE((input)[0]);						      \
	if (p < 0) {							      \
	    (status) = 0;						      \
	} else {							      \
	    nonsense_081028_1_logique_i((context), (p), (input), (status));   \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081028_7_logique_i(context, P, p, input, status) \
    {									      \
	X1f4_E4_C_MODE w;						      \
	int a;								      \
									      \
	w = I_MODE((input)[0]);						      \
	if (w < 0) {							      \
	    w = -w;							      \
	    a = 1;							      \
	} else {							      \
	    a = 0;							      \
	}								      \
	(status) = x1f4_vprint_pwfloat					      \
	    (becca((context))[1], inter2line(*becca((context))), a, w, (P),   \
	     (p), I_REAL((input)[3]));					      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_081028_7_logique(context, output, input, status) \
    {									      \
	X1f4_E4_C_MODE p;						      \
									      \
	p = I_MODE((input)[1]);						      \
	if (p < 0) {							      \
	    (status) = 0;						      \
	} else {							      \
	    X1f4_E4_C_MODE P;						      \
									      \
	    P = I_MODE((input)[2]);					      \
	    if (P < 0) {						      \
		(status) = 0;						      \
	    } else {							      \
		nonsense_081028_7_logique_i				      \
		    ((context), (P), (p), (input), (status));		      \
	    }								      \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_090606_0_logique(Context, output, input, status) \
    {									      \
	struct logic9_type logic9;					      \
									      \
	logic9.context = (Context);					      \
	logic9.size = 0;						      \
									      \
	(status) = x1f4_vprint_sstring					      \
	    (&logic9, copy_text, I_TEXT((input)[0]), _Mylene1f4_c_type_s);    \
	if ((status)) {							      \
	} else {							      \
	    if (logic9.size) {						      \
		(status) = inter2line(*becca((Context)))		      \
		   (becca((Context))[1], logic9.data, logic9.size); 	      \
	    }								      \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_090706_0_logique_i(context, f, input, status) \
    {									      \
	(status) = x1f4_vprint_space					      \
	    (becca((context))[1], inter2line(*becca((context))), (f));	      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define nonsense_090706_0_logique(context, output, input, status) \
    {									      \
	X1f4_E4_C_MODE f;						      \
									      \
	f = I_MODE((input)[0]);						      \
	if (f < 0) {							      \
	    (status) = 0;						      \
	} else {							      \
	    nonsense_090706_0_logique_i((context), (f), (input), (status));   \
	}								      \
    }
#endif				/* __ENABLE_EQUEUE__ */
