/*
 * c213.h
 * Copyright (C) 2005-2006, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_c213_H__
#define __Mylene1f4_c213_H__

#include <config.h>

#define ALIGN_ABUFFER(bp) \
    ((char *) (bp)							      \
     + ((sizeof(unsigned long)						      \
	 - ((integral_q) (bp) & (sizeof(unsigned long) - 1)))		      \
	& (sizeof(unsigned long) - 1)))

#define ALIGN_AMALLOC(md) \
    ((md) + sizeof(unsigned long) - 1)

#define ALIGN_ASTRIDE(sl) \
    ((unsigned) (sl)							      \
     + ((sizeof(unsigned long)						      \
         - ((unsigned) (sl) & (sizeof(unsigned long) - 1)))		      \
	& (sizeof(unsigned long) - 1)))

#define ALIGN_ZBUFFER(bp) \
    ((char *) (bp)							      \
     + ((sizeof(union __x1f4_c213_aligned_stride)			      \
	 - ((integral_q) (bp)						      \
	    & (sizeof(union __x1f4_c213_aligned_stride) - 1)))		      \
	& (sizeof(union __x1f4_c213_aligned_stride) - 1)))

#define ALIGN_Z_PITCH \
    sizeof(union __x1f4_c213_aligned_stride)

#define ALIGN_ZMALLOC(md) \
    ((md) + sizeof(union __x1f4_c213_aligned_stride) - 1)

#define ALIGN_ZSTRIDE(sl) \
    ((unsigned) (sl)							      \
     + ((sizeof(union __x1f4_c213_aligned_stride)			      \
         - ((unsigned) (sl)						      \
	    & (sizeof(union __x1f4_c213_aligned_stride) - 1)))		      \
	& (sizeof(union __x1f4_c213_aligned_stride) - 1)))

union __x1f4_c213_aligned_stride {
    double o;
    int a;
    long b;
    void *c;
};

#endif				/* __Mylene1f4_c213_H__ */
