/*
 * excess7.h
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__

#include <excess4.h>

#define __FIX_0fa_WAIT__		1

#if __ENABLE_TAGGED_LIST__
# define __PLAY_TILE__			1
#else
# define __PLAY_TILE__			0
#endif				/* __ENABLE_TAGGED_LIST__ */

#if __ENABLE_TAGGED_LIST__
# define __PLAY_CEIL__			1
#else
# define __PLAY_CEIL__			0
#endif				/* __ENABLE_TAGGED_LIST__ */

typedef struct class7_type {
    int (*pipe_clip) (void *, void *);
} class7_type;

typedef struct frame7_type {
#if __FIX_0fa_WAIT__
    struct {
	unsigned wait;
    } _0;
#endif				/* __FIX_0fa_WAIT__ */
    struct {
	struct frame4_type frame4;
    } _1;
#if __PLAY_CEIL__ || __PLAY_TILE__
    struct {
#endif				/* __PLAY_CEIL__ || __PLAY_TILE__ */
#if __PLAY_CEIL__
	int (*ceil) (void *);
#endif				/* __PLAY_CEIL__ */
#if __PLAY_TILE__
	int (*play) (void *);
#endif				/* __PLAY_TILE__ */
#if __PLAY_CEIL__ || __PLAY_TILE__
    } _2;
#endif				/* __PLAY_CEIL__ || __PLAY_TILE__ */
    struct {
	void *line;
    } _3;
    struct {
	unsigned cell, seek;
    } _4;
} frame7_type;

#endif				/* __ENABLE_CONTROLLING_SERVER__ */
