/*
 * progress.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_PROGRESS_H__
#define __Mylene1f4_PROGRESS_H__

#define Mylene1f4_tags_HEAD_LINK_PROGRESS__ \
    "%A(A%:2:A\\0)%a(a%:2:a\\0)%c(c%:2:c\\0)"
#define Mylene1f4_tags_TAIL_LINK_PROGRESS__ \
    "%g(g%:2:g\\0)%t(t%:2:t\\0)%y(y%:2:y\\0)"

#define Mylene1f4_tags_DATA_LINK_PROGRESS__ \
    Mylene1f4_tags_HEAD_LINK_PROGRESS__					      \
    Mylene1f4_tags_TAIL_LINK_PROGRESS__

#define Mylene1f4_tags_NODE_LINK_PROGRESS__ \
    "%G(%z("								      \
    Mylene1f4_tags_DATA_LINK_PROGRESS__					      \
    "))"

#define Mylene1f4_tags_PROGRESS_PROGRESS1__ \
    Mylene1f4_tags_NODE_LINK_PROGRESS__					      \
    "N%N\\0\\0"

#define Mylene1f4_x1f4_PROGRESS_HMSFTIME1__ \
    "%<0>2H:%<0>2M:%<0>2S:%<0>2F"
#undef Mylene1f4_x1f4_PROGRESS_HMSFTIME1__
#define Mylene1f4_x1f4_PROGRESS_HMSFTIME1__ \
    "%x"
#define Mylene1f4_x1f4_PROGRESS_MPEGINFO1__ \
    "%S, layer %3l, %3B kbits/s, %:2:5s Hz,  %14m, %M\n"

#define Mylene1f4_x1f4_PROGRESS_PROGRESS1_0 \
    "%b"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS1_1 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS1_0					      \
    "%x( \\(%l("							      \
    Mylene1f4_x1f4_PROGRESS_HMSFTIME1__					      \
    "), %7F frames\\))"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS1_2 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS1_1					      \
    "\n"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS1_3 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS1_2					      \
    "%G(%a\n%t\n)"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS1_4 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS1_3					      \
    "%v(%m("								      \
    Mylene1f4_x1f4_PROGRESS_MPEGINFO1__					      \
    "))"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS1__ \
    Mylene1f4_x1f4_PROGRESS_PROGRESS1_4

#define Mylene1f4_x1f4_PROGRESS_PROGRESS2_0 \
    "\r"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS2_1 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS2_0					      \
    "frame, %11(%t(time,) cache):"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS2_2 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS2_1					      \
    " %12f, %35(    %t("						      \
    Mylene1f4_x1f4_PROGRESS_HMSFTIME1__					      \
    ",) %#18e)"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS2__ \
    Mylene1f4_x1f4_PROGRESS_PROGRESS2_2

#define Mylene1f4_x1f4_PROGRESS_PROGRESS3_0 \
    "\r"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS3_1 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS3_0					      \
    "frames, %10(%t(time,) _EOF):"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS3_2 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS3_1					      \
    " %12f, %35(    %t("						      \
    Mylene1f4_x1f4_PROGRESS_HMSFTIME1__					      \
    ",) %#18z)"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS3_3 \
    Mylene1f4_x1f4_PROGRESS_PROGRESS3_2					      \
    "\n"
#define Mylene1f4_x1f4_PROGRESS_PROGRESS3__ \
    Mylene1f4_x1f4_PROGRESS_PROGRESS3_3

#endif				/* __Mylene1f4_PROGRESS_H__ */
