/*
 * ss5.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_flat_thread(void *context, void *client, unsigned deck)
{
    int status;
    void *thread;

    Mylene200_lose_thread(client, &thread, deck);
    if (!thread) {
	status = 0;
    } else {
	status = Mylene200_mind_thread(context, thread);
	if (status) {
	} else {
	    struct window_type *window_data;

	    window_data = client(client)->window;
	    if (!window_data) {
		status = Mylene200_push_client(context, client, 2, "\0\176");
	    } else {
		status = Mylene200_lock_thread(context, client, window_data);
	    }
	}
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
