/*
 * su1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <defs.h>
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_fast_thread(void *context, void *client)
{
    int status;

    if (!(client(client)->bits & Mylene200_MIND_CLIENT)) {
	status = 0;
    } else {
	if (0) {
	} else {
	    do {
		struct thread_type *thread_data;

		thread_data = client(client)->delete;
		if (thread_data) {
		    if (thread_data == JUDITH(context)) {
			status = 0;

			break;
		    } else {
		    }
		} else {
		    Mylene200_rail_thread(client);
		    thread_data = client(client)->delete;
		    if (thread_data) {
		    } else {
			status = Mylene200_push_thread(context, client);
			if (status) {
			    break;
			} else {
			    thread_data = client(client)->delete;
			}
		    }
		}

# if __ENABLE_DEBUG__
		Mylene200_type_debug
		    (context, " -- [thread changed] (server side %u, client "
		     "side %u, client is %d)\n", thread_data->deck,
		     thread_data->miss, client(client)->fd);
# endif				/* __ENABLE_DEBUG__ */

		status = Mylene200_push_reflex(context, 1, "\133");
		if (status) {
		} else {
		    status = Mylene200_sand_reflex(context, thread_data->deck);
		    if (status) {
		    } else {
			JUDITH(context) = thread_data;
		    }
		}
	    } while (0);
	}
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
