/*
 * su3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
# include <stdlib.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define client(client) \
    ((struct client_type *) (client))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define window(window) \
    ((struct window_type *) (window))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_lock_thread(void *context, void *client, void *window)
{
    int status;
    struct window_type *window_data;

    window_data = (struct window_type *) malloc(sizeof(struct window_type));
    if (!window_data) {
	Mylene200_stat_system(context);
	status = -1;
    } else {
	struct window_type *last_window;

	status = 0;

	window_data->client_data = client;
	window_data->type = 0576;

	last_window = window(window)->last_window;
	if (!last_window) {
	    client(client)->window = window_data;

	    window_data->last_window = NULL;
	} else {
	    last_window->miss_window = window_data;

	    window_data->last_window = last_window;
	}

	window_data->miss_window = window;

	window(window)->last_window = window_data;

	last_window = window(window)->window_data;
	if (!last_window) {
	    CLASS9(context) = window_data;

	    window_data->window_data = NULL;
	} else {
	    window_data->window_data = last_window;
	}

	window(window)->window_data = window_data;
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
