/*
 * su4.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define window(window) \
    ((struct window_type *) (window))
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_0576_thread(void *context, void *window)
{
    int status;
    struct client_type *client_data;

    client_data = window(window)->client_data;
    if (!client_data) {
	status = 0;
    } else {
	status = Mylene200_push_client(context, client_data, 2, "\0\176");
	if (status) {
	} else {
	    struct window_type *back_window;

	    back_window = window(window)->last_window;
	    if (back_window) {
		back_window->miss_window = window(window)->miss_window;
	    } else {
		client_data->window = window(window)->miss_window;
	    }
	}
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
