/*
 * akeylist.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4_AKEYLIST_H__
#define __LIBx1f4_AKEYLIST_H__

#if !__x1f4_akeytree_type_defined__
typedef struct x1f4_akeytree_type {
    char *string;
    const struct x1f4_akeytree_type *children;
} x1f4_akeytree_type;
#endif				/* !__x1f4_akeytree_type_defined__ */

#if !__x1f4_akeytree_type_defined__
# define __x1f4_akeytree_type_defined__
#endif				/* !__x1f4_akeytree_type_defined__ */

extern int x1f4_list_atkey
    (void *, int (*) (void *, const char *, unsigned),
     const struct x1f4_akeytree_type *);

#endif				/* __LIBx1f4_AKEYLIST_H__ */
