/*
 * types.h
 * Copyright (C) 2005-2008, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4i2_TYPES_H__
#define __LIBx1f4i2_TYPES_H__

#include <config.h>

typedef struct aerror_type {
    int excess;
} aerror_type;

typedef struct xaudio_type {
    int ordered, started;
    unsigned rate;
#if __REAL_ACCELERATION__ == 1
    double size, size2;
#elif 7 < SIZEOF_UNSIGNED_LONG
    unsigned long size, size2;
#else
    unsigned long long size, size2;
#endif				/* __REAL_ACCELERATION__ == 1 */
    unsigned c, class, count, e, index, m, n, *state, trail;
    void *audio;
} xaudio_type;

#endif				/* __LIBx1f4i2_TYPES_H__ */
