/*
 * inter.h
 * Copyright (C) 2006-2008, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_INTER_H__
#define __LIBx1f4i2_INTER_H__

#include <sys/time.h>

#include <types.h>

extern int _1f4_alsa_xaudio(void *, int);
extern int _1f4_fail_xaudio(void *, int, int);
extern int _1f4_long_xaudio(void *, int);
extern int _1f4_mind_xaudio(void *, unsigned *);
extern int _1f4_miss_xaudio(void *);
extern int x1f4_clip_xaudio(void *, int, struct timeval *);
extern int x1f4_deck_xaudio(void *, int);
extern int x1f4_lose_xaudio(void **);
extern int x1f4_mode_xaudio(void *, unsigned, unsigned, unsigned, unsigned);
extern int x1f4_open_xaudio(void **, const char *, struct aerror_type *);
extern int x1f4_slip_xaudio(void *, unsigned *, int, struct timeval *);
extern int x1f4_vset_xaudio(void *, unsigned *, struct timeval *);

#endif				/* __LIBx1f4i2_INTER_H__ */
