/*
 * x1f4i2.e.c
 * Copyright (C) 2006-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <libxaudio.h>

#include <defs.h>
#include <types.h>

int
x1f4_deck_xaudio(void *xaudio, int now)
{
    int status;

    status = libxaudio_deck_xaudio
	(((struct xaudio_type *) xaudio)->xaudio, now);
    if (status) {
	status <<= SELF_SHIFT;
    }

    return status;
}
