/*
 * e1f4.1.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.2.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.5.h>
#include <e1f4.a.h>

#define __RUN_FUTILE__			0

#define RIGHT_STEREO(granule) \
    {									      \
	if (granule[0].maxb < granule[1].maxb) {			      \
	    granule[0].maxb = granule[1].maxb;				      \
	} else {							      \
	    granule[1].maxb = granule[0].maxb;				      \
	}								      \
    }									      \

extern Mylene1f4_real _Mylene1f4_break_0[];
extern unsigned _Mylene1f4_table_3_B_7__0[], _Mylene1f4_table_3_B_7__1[],
    *_Mylene1f4_table_3_B_7__2[];
extern const unsigned _Mylene1f4_table_3_B_7__3[], _Mylene1f4_table_3_B_7__4[];

Mylene1f4_real III_break_0[8207], III_break_1[378];
const unsigned _Mylene1f4_table_3_B_8x_0[][25] = {
/* *INDENT-OFF* */
    {	0,    4,    8,   12,   16,   20,   24,   30,
       36,   44,   52,   62,   74,   90,  110,  134,
      162,  196,  238,  288,  342,  418,  576,  576,
      576						},
    {	0,    4,    8,   12,   16,   20,   24,   30,
       36,   42,   50,   60,   72,   88,  106,  128,
      156,  190,  230,  276,  330,  384,  576,  576,
      576						},
    {	0,    4,    8,   12,   16,   20,   24,   30,
       36,   44,   54,   66,   82,  102,  126,  156,
      194,  240,  296,  364,  448,  550,  576,  576,
      576						},
    {	0,    6,   12,   18,   24,   30,   36,   44,
       54,   66,   80,   96,  116,  140,  168,  200,
      238,  284,  336,  396,  464,  522,  576,  576,
      576						},
    {	0,    6,   12,   18,   24,   30,   36,   44,
       54,   66,   80,   96,  114,  136,  162,  194,
      232,  278,  332,  394,  464,  540,  576,  576,
      576						},
    {	0,    6,   12,   18,   24,   30,   36,   44,
       54,   66,   80,   96,  116,  140,  168,  200,
      238,  284,  336,  396,  464,  522,  576,  576,
      576						}
/* *INDENT-ON* */
}, _Mylene1f4_table_3_B_8x_1[][22] = {
/* *INDENT-OFF* */
    {	2,    2,    2,    2,    2,    2,    3,    3,
	4,    4,    5,    6,    8,   10,   12,   14,
       17,   21,   25,   27,   38,   79			},
    {	2,    2,    2,    2,    2,    2,    3,    3,
	3,    4,    5,    6,    8,    9,   11,   14,
       17,   20,   23,   27,   27,   96			},
    {	2,    2,    2,    2,    2,    2,    3,    3,
	4,    5,    6,    8,   10,   12,   15,   19,
       23,   28,   34,   42,   51,   13			},
    {	3,    3,    3,    3,    3,    3,    4,    5,
	6,    7,    8,   10,   12,   14,   16,   19,
       23,   26,   30,   34,   29,   27			},
    {	3,    3,    3,    3,    3,    3,    4,    5,
	6,    7,    8,    9,   11,   13,   16,   19,
       23,   27,   31,   35,   38,   18			},
    {	3,    3,    3,    3,    3,    3,    4,    5,
	6,    7,    8,   10,   12,   14,   16,   19,
       23,   26,   30,   34,   29,   27			}
/* *INDENT-ON* */
}, _Mylene1f4_table_3_B_8x_2[][14] = {
/* *INDENT-OFF* */
    {	0,   12,   24,   36,   48,   66,   90,  120,
      156,  198,  252,  318,  408,  576			},
    {	0,   12,   24,   36,   48,   66,   84,  114,
      150,  192,  240,  300,  378,  576			},
    {	0,   12,   24,   36,   48,   66,   90,  126,
      174,  234,  312,  414,  540,  576			},
    {	0,   12,   24,   36,   54,   72,   96,  126,
      168,  222,  300,  396,  522,  576			},
    {	0,   12,   24,   36,   54,   78,  108,  144,
      186,  240,  312,  408,  540,  576			},
    {	0,   12,   24,   36,   54,   78,  108,  144,
      186,  240,  312,  402,  522,  576			}
/* *INDENT-ON* */
}, _Mylene1f4_table_3_B_8x_3[][13] = {
/* *INDENT-OFF* */
    {	4,    4,    4,    4,    6,    8,   10,   12,
       14,   18,   22,   30,   56			},
    {   4,    4,    4,    4,    6,    6,   10,   12,
       14,   16,   20,   26,   66			},
    {   4,    4,    4,    4,    6,    8,   12,   16,
       20,   26,   34,   42,   12			},
    {	4,    4,    4,    6,    6,    8,   10,   14,
       18,   26,   32,   42,   18			},
    {	4,    4,    4,    6,    8,   10,   12,   14,
       18,   24,   32,   44,   12			},
    {	4,    4,    4,    6,    8,   10,   12,   14,
       18,   24,   30,   40,   18			}
/* *INDENT-ON* */
};

static void audio_data_0(struct Mylene1f4_audio *);
static void audio_data_1(struct Mylene1f4_audio *);
static void audio_data_d(struct Mylene1f4_audio *);

void (*_Mylene1f4_4294967291_audio_data_III[]) (struct Mylene1f4_audio *) = {
/* *INDENT-OFF* */
    audio_data_1, audio_data_1, audio_data_1, audio_data_d, audio_data_0
/* *INDENT-ON* */
};

static int run_frame(struct Mylene1f4_audio *);

static void desenchantee(struct Mylene1f4_audio *, unsigned char **,
			 unsigned *, unsigned *);
static void optimistique_moi(struct Mylene1f4_audio *, unsigned char **,
			     unsigned *, unsigned *);
static void part2(struct Mylene1f4_audio *, unsigned char **, unsigned *,
		  unsigned *, unsigned *, unsigned *, unsigned *,
		  Mylene1f4_real *, struct Mylene1f4_granule *, unsigned);

static const unsigned part2_length_01_3[] = {
/* *INDENT-OFF* */
	0,   10,   20,   30,   33,   21,   31,   41,
       32,   42,   52,   43,   53,   63,   64,   74,
	0,    5,   10,   15,   33,   16,   21,   26,
       27,   32,   37,   38,   43,   48,   54,   59,
	0,    5,   10,   15,   33,   16,   21,   26,
       27,   32,   37,   38,   43,   48,   54,   59,
	0,    0,    0,    0,   33,   11,   11,   11,
       22,   22,   22,   33,   33,   33,   44,   44,
	0,   10,   20,   30,   18,   16,   26,   36,
       22,   32,   42,   28,   38,   48,   44,   54,
	0,    5,   10,   15,   18,   11,   16,   21,
       17,   22,   27,   23,   28,   33,   34,   39,
	0,    5,   10,   15,   18,   11,   16,   21,
       17,   22,   27,   23,   28,   33,   34,   39,
	0,    0,    0,    0,   18,    6,    6,    6,
       12,   12,   12,   18,   18,   18,   24,   24,
	0,   10,   20,   30,   15,   15,   25,   35,
       20,   30,   40,   25,   35,   45,   40,   50,
	0,    5,   10,   15,   15,   10,   15,   20,
       15,   20,   25,   20,   25,   30,   30,   35,
	0,    5,   10,   15,   15,   10,   15,   20,
       15,   20,   25,   20,   25,   30,   30,   35,
	0,    0,    0,    0,   15,    5,    5,    5,
       10,   10,   10,   15,   15,   15,   20,   20,
	0,   10,   20,   30,    0,   10,   20,   30,
       10,   20,   30,   10,   20,   30,   20,   30,
	0,    5,   10,   15,    0,    5,   10,   15,
	5,   10,   15,    5,   10,   15,   10,   15,
	0,    5,   10,   15,    0,    5,   10,   15,
	5,   10,   15,    5,   10,   15,   10,   15,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0
/* *INDENT-ON* */
}, part2_length___2_[] = {
/* *INDENT-OFF* */
	0,   18,   36,   54,   51,   35,   53,   71,
       52,   70,   88,   69,   87,  105,  104,  122,
	0,   18,   36,   54,   54,   36,   54,   72,
       54,   72,   90,   72,   90,  108,  108,  126
/* *INDENT-ON* */
}, scalefac_compress_to_slen1[] = {
/* *INDENT-OFF* */
	0,    0,    0,    0,    3,    1,    1,    1,
	2,    2,    2,    3,    3,    3,    4,    4
/* *INDENT-ON* */
}, scalefac_compress_to_slen2[] = {
/* *INDENT-OFF* */
	0,    1,    2,    3,    0,    1,    2,    3,
	1,    2,    3,    1,    2,    3,    2,    3
/* *INDENT-ON* */
}, table_3_B_6__0[] = {
/* *INDENT-OFF* */
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    1,    1,    1,    1,    2,
	2,    3,    3,    3,    2,    0
/* *INDENT-ON* */
}, table_3_B_6__1[] = {
/* *INDENT-OFF* */
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0
/* *INDENT-ON* */
}, table_3_B_8x__0[][23] = {
/* *INDENT-OFF* */
    {	1,    1,    1,    2,    2,    2,    2,    3,
	3,    3,    4,    4,    5,    6,    7,    8,
       10,   12,   14,   17,   20,   24,   32		},
    {	1,    1,    1,    2,    2,    2,    2,    3,
	3,    3,    4,    4,    5,    6,    7,    8,
       10,   11,   14,   16,   19,   22,   32		},
    {	1,    1,    1,    2,    2,    2,    2,    3,
	3,    3,    4,    5,    5,    7,    8,   10,
       12,   14,   17,   21,   26,   31,   32		},
    {	1,    1,    2,    2,    2,    3,    3,    3,
	4,    5,    5,    6,    7,    9,   10,   12,
       14,   17,   20,   23,   27,   30,   32		},
    {	1,    1,    2,    2,    2,    3,    3,    3,
	4,    5,    5,    6,    7,    8,   10,   12,
       14,   16,   19,   23,   27,   31,   32		},
    {	1,    1,    2,    2,    2,    3,    3,    3,
	4,    5,    5,    6,    7,    9,   10,   12,
       14,   17,   20,   23,   27,   30,   32		}
/* *INDENT-ON* */
}, table_3_B_8x__1[][14] = {
/* *INDENT-OFF* */
    {	1,    1,    2,    2,    3,    4,    5,    7,
	9,   11,   14,   18,   23,   32			},
    {	1,    1,    2,    2,    3,    4,    5,    7,
	9,   11,   14,   17,   21,   32			},
    {	1,    1,    2,    2,    3,    4,    5,    7,
       10,   13,   18,   23,   30,   32			},
    {	1,    1,    2,    2,    3,    4,    6,    7,
       10,   13,   17,   22,   29,   32			},
    {	1,    1,    2,    2,    3,    5,    6,    8,
       11,   14,   18,   23,   30,   32			},
    {	1,    1,    2,    2,    3,    5,    6,    8,
       11,   14,   18,   23,   29,   32			}
/* *INDENT-ON* */
};

static void
audio_data_0(struct Mylene1f4_audio *audio)
{
    run_frame(audio);
}


static void
audio_data_1(struct Mylene1f4_audio *audio)
{
    /*
     * if (mode == single_channel) {                                    
     *     main_data_end                                             9  uimsbf
     *     private_bits                                              5  bslbf
     *     for (scfsi_band = 0; scfsi_band < 4; scfsi_band++) {         
     *         scfsi[scfsi_band]                                     1  bslbf
     *     }                                                            
     *     for (gr = 0; gr < 2; gr++) {                                 
     *         part2_3_length[gr]                                   12  uimsbf
     *         big_values[gr]                                        9  uimsbf
     *         global_gain[gr]                                       8  uimsbf
     *         scalefac_compress[gr]                                 4  bslbf
     *         blocksplit_flag[gr]                                   1  bslbf
     *         if (blocksplit_flag[gr]) {                               
     *             block_type[gr]                                    2  bslbf
     *             switch_point[gr]                                  1  uimsbf
     *             for (region = 0; region < 2; region++) {             
     *                 table_select[region][gr]                      5  bslbf
     *             }                                                    
     *             for (window = 0; window < 3; window++) {             
     *                  subblock_gain[window][gr]                    3  uimsbf
     *             }                                                    
     *         } else {                                                 
     *             for (region = 0; region < 3; region++) {             
     *                 table_select[region][gr]                      5  bslbf
     *             }                                                    
     *             region_address1[gr]                               4  bslbf
     *             region_address2[gr]                               3  bslbf
     *         }                                                        
     *         preflag[gr]                                           1  bslbf
     *         scalefac_scale[gr]                                    1  bslbf
     *         count1table_select[gr]                                1  bslbf
     *     }                                                            
     *     for (gr = 0; gr < 2; gr++) {                                 
     *         if (blocksplit_flag[gr] == 1 && block_type[gr] == 2) {   
     *             for (cb = 0; cb < switch_point_1[gr]; cb++) {        
     *                 if (scfsi[cb] == 0 || gr == 0) {                 
     *                     scalefac[cb][gr]                       0..4  uimsbf
     *                 }                                                
     *             }                                                    
     *             for (cb = switch_point_s[gr]; cb < cblimit_short; cb++) {
     *                 for (window = 0; window < 3; window++) {         
     *                     if (scfsi[cb] == 0 || gr == 0) {             
     *                         scalefac[cb][window][gr]           0..4  uimsbf
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         } else {                                                 
     *             for (cb = 0; cb < cblimit; cb++) {                   
     *                 if (scfsi[cb] == 0 || gr == 0) {                 
     *                     scalefac[cb][gr]                       0..4  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *         Huffmancodebits          part_2_3_length - part2_length  bslbf
     *     }                                                            
     *     while (position != main_data_end) {                          
     *         ancillary_bit                                         1  bslbf
     *     }                                                            
     * }                                                                
     * if (mode == stereo || mode == dual_channel || mode == ms_stereo) {
     *     main_data_end                                             9  uimsbf
     *     private_bits                                              3  bslbf
     *     for (ch = 0; ch < 2; ch++) {                                 
     *         for (scfsi_band = 0; scfsi_band < 4; scfsi_band++) {     
     *             scfsi[scfsi_band][ch]                             1  bslbf
     *         }                                                        
     *     }                                                            
     *     for (gr = 0; gr < 2; gr++) {                                 
     *         for (ch = 0; ch < 2; ch++) {                             
     *             part2_3_length[gr][ch]                           12  uimsbf
     *             big_values[gr][ch]                                9  uimsbf
     *             global_gain[gr][ch]                               8  uimsbf
     *             scalefac_compress[gr][ch]                         4  bslbf
     *             blocksplit_flag[gr][ch]                           1  bslbf
     *             if (blocksplit_flag[gr][ch]) {                       
     *                 block_type[gr][ch]                            2  bslbf
     *                 switch_point[gr][ch]                          1  uimsbf
     *                 for (region = 0; region < 2; region++) {         
     *                     table_select[region][gr][ch]              5  bslbf
     *                 }                                                
     *                 for (window = 0; window < 3; window++) {         
     *                      subblock_gain[window][gr][ch]            3  uimsbf
     *                 }                                                
     *             } else {                                             
     *                 for (region = 0; region < 3; region++) {         
     *                     table_select[region][gr][ch]              5  bslbf
     *                 }                                                
     *                 region_address1[gr][ch]                       4  bslbf
     *                 region_address2[gr][ch]                       3  bslbf
     *             }                                                        
     *             preflag[gr][ch]                                   1  bslbf
     *             scalefac_scale[gr][ch]                            1  bslbf
     *             count1table_select[gr][ch]                        1  bslbf
     *         }                                                            
     *     }                                                            
     *     for (gr = 0; gr < 2; gr++) {                                 
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (blocksplit_flag[gr][ch] == 1 && block_type[gr][ch] == 2) {
     *                 for (cb = 0; cb < switch_point_1[gr][ch]; cb++) {
     *                     if (scfsi[cb] == 0 || gr == 0) {             
     *                         scalefac[cb][gr][ch]               0..4  uimsbf
     *                     }                                            
     *                 }                                                
     *                 for (cb = switch_point_s[gr][ch]; cb < cblimit_short; cb++) {
     *                     for (window = 0; window < 3; window++) {     
     *                         if (scfsi[cb] == 0 || gr == 0) {         
     *                             scalefac[cb][window][gr][ch]   0..4  uimsbf
     *                         }                                        
     *                     }                                            
     *                 }                                                
     *             } else {                                             
     *                 for (cb = 0; cb < cblimit; cb++) {               
     *                     if (scfsi[cb] == 0 || gr == 0) {             
     *                         scalefac[cb][gr][ch]               0..4  uimsbf
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *         Huffmancodebits          part_2_3_length - part2_length  bslbf
     *     }                                                            
     *     while (position != main_data_end) {                          
     *         ancillary_bit                                         1  bslbf
     *     }                                                            
     * }                                                                
     */
    struct Mylene1f4_granule granule_data[2][2], *this_granule;
    unsigned cache_buffer = 0, cache_size = 0, frame, granule = 0,
	joint_stereo_mode = 0, scalefac[2][39], size;
    unsigned char *buffer;

    if (run_frame(audio)) {
	return;
    }

    if (audio->mode == joint_stereo) {
	joint_stereo_mode = audio->mode_extension;
    }

    buffer = audio->layer_data.III.head;

    granule_data[0][0].scfsi = ~0;
    granule_data[0][0].part2_3_length =
	(buffer[0x02] << 8 | buffer[0x03]) & 4095;
    granule_data[0][0].big_values = buffer[0x04] << 1 | buffer[0x05] >> 7;
    granule_data[0][0].pow2gain = III_break_1 + 256
	- ((buffer[0x05] << 1 | buffer[0x06] >> 7) & 255) + 0;
    if (joint_stereo_mode & 2) {
	granule_data[0][0].pow2gain += 2;
    }
    granule_data[0][0].scalefac_compress = (buffer[0x06] >> 3) & 15;
    if (buffer[0x06] & 0004) {
	granule_data[0][0].block_type = buffer[0x06] & 3;
	if (!granule_data[0][0].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[0][0].switch_point = (~buffer[0x07] >> 7) & 1;
	granule_data[0][0].table_select[0] = (buffer[0x07] >> 2) & 31;
	granule_data[0][0].table_select[1] =
	    (buffer[0x07] << 3 | buffer[0x08] >> 5) & 31;
	granule_data[0][0].table_select[2] = 0;
	granule_data[0][0].full_gain[0] = granule_data[0][0].pow2gain
	    + ((buffer[0x08] << 1) & 56);
	granule_data[0][0].full_gain[1] = granule_data[0][0].pow2gain
	    + ((buffer[0x08] << 4 | buffer[0x09] >> 4) & 56);
	granule_data[0][0].full_gain[2] = granule_data[0][0].pow2gain
	    + ((buffer[0x09] >> 1) & 56);
	granule_data[0][0].region_address1 = 18;
	granule_data[0][0].region_address2 = 288;
    } else {
	granule_data[0][0].block_type = 0;
	granule_data[0][0].table_select[0] =
	    (buffer[0x06] << 3 | buffer[0x07] >> 5) & 31;
	granule_data[0][0].table_select[1] = buffer[0x07] & 31;
	granule_data[0][0].table_select[2] = buffer[0x08] >> 3;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x08] << 1 | buffer[0x09] >> 7) & 15;
	    shit = (buffer[0x09] >> 4) & 7;
	    granule_data[0][0].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[0][0].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[0][0].switch_point = 0;
    }
    granule_data[0][0].preflag = (buffer[0x09] >> 3) & 1;
    granule_data[0][0].scalefac_scale = (buffer[0x09] >> 2) & 1;
    granule_data[0][0].count1table_select = buffer[0x09] & 2;
    granule_data[0][1].scfsi = ~0;
    granule_data[0][1].part2_3_length =
	(buffer[0x09] << 11 | buffer[0x0a] << 3 | buffer[0x0b] >> 5) & 4095;
    granule_data[0][1].big_values =
	(buffer[0x0b] << 4 | buffer[0x0c] >> 4) & 511;
    granule_data[0][1].pow2gain = III_break_1 + 256
	- ((buffer[0x0c] << 4 | buffer[0x0d] >> 4) & 255) + 0;
    if (joint_stereo_mode & 2) {
	granule_data[0][1].pow2gain += 2;
    }
    granule_data[0][1].scalefac_compress = buffer[0x0d] & 15;
    if (buffer[0x0e] & 0200) {
	granule_data[0][1].block_type = (buffer[0x0e] >> 5) & 3;
	if (!granule_data[0][1].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[0][1].switch_point = (~buffer[0x0e] >> 4) & 1;
	granule_data[0][1].table_select[0] =
	    (buffer[0x0e] << 1 | buffer[0x0f] >> 7) & 31;
	granule_data[0][1].table_select[1] = (buffer[0x0f] >> 2) & 31;
	granule_data[0][1].table_select[2] = 0;
	granule_data[0][1].full_gain[0] = granule_data[0][1].pow2gain
	    + ((buffer[0x0f] << 4 | buffer[0x10] >> 4) & 56);
	granule_data[0][1].full_gain[1] = granule_data[0][1].pow2gain
	    + ((buffer[0x10] >> 1) & 56);
	granule_data[0][1].full_gain[2] = granule_data[0][1].pow2gain
	    + ((buffer[0x10] << 2) & 56);
	granule_data[0][1].region_address1 = 18;
	granule_data[0][1].region_address2 = 288;
    } else {
	granule_data[0][1].block_type = 0;
	granule_data[0][1].table_select[0] = (buffer[0x0e] >> 2) & 31;
	granule_data[0][1].table_select[1] =
	    (buffer[0x0e] << 3 | buffer[0x0f] >> 5) & 31;
	granule_data[0][1].table_select[2] = buffer[0x0f] & 31;
	{
	    unsigned bull, shit;

	    bull = buffer[0x10] >> 4;
	    shit = (buffer[0x10] >> 1) & 7;
	    granule_data[0][1].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[0][1].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[0][1].switch_point = 0;
    }
    granule_data[0][1].preflag = buffer[0x10] & 1;
    granule_data[0][1].scalefac_scale = (buffer[0x11] >> 7) & 1;
    granule_data[0][1].count1table_select = buffer[0x11] & 64;
    granule_data[1][0].scfsi = buffer[0x01] & 15;
    granule_data[1][0].part2_3_length =
	(buffer[0x11] << 6 | buffer[0x12] >> 2) & 4095;
    granule_data[1][0].big_values =
	(buffer[0x12] << 7 | buffer[0x13] >> 1) & 511;
    granule_data[1][0].pow2gain = III_break_1 + 256
	- ((buffer[0x13] << 7 | buffer[0x14] >> 1) & 255) + 0;
    if (joint_stereo_mode & 2) {
	granule_data[1][0].pow2gain += 2;
    }
    granule_data[1][0].scalefac_compress =
	(buffer[0x14] << 3 | buffer[0x15] >> 5) & 15;
    if (buffer[0x15] & 0020) {
	granule_data[1][0].block_type = (buffer[0x15] >> 2) & 3;
	if (!granule_data[1][0].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[1][0].switch_point = (~buffer[0x15] >> 1) & 1;
	granule_data[1][0].table_select[0] =
	    (buffer[0x15] << 4 | buffer[0x16] >> 4) & 31;
	granule_data[1][0].table_select[1] =
	    (buffer[0x16] << 1 | buffer[0x17] >> 7) & 31;
	granule_data[1][0].table_select[2] = 0;
	granule_data[1][0].full_gain[0] = granule_data[1][0].pow2gain
	    + ((buffer[0x17] >> 1) & 56);
	granule_data[1][0].full_gain[1] = granule_data[1][0].pow2gain
	    + ((buffer[0x17] << 2) & 56);
	granule_data[1][0].full_gain[2] = granule_data[1][0].pow2gain
	    + ((buffer[0x17] << 5 | buffer[0x18] >> 3) & 56);
	granule_data[1][0].region_address1 = 18;
	granule_data[1][0].region_address2 = 288;
    } else {
	granule_data[1][0].block_type = 0;
	granule_data[1][0].table_select[0] =
	    (buffer[0x15] << 1 | buffer[0x16] >> 7) & 31;
	granule_data[1][0].table_select[1] = (buffer[0x16] >> 2) & 31;
	granule_data[1][0].table_select[2] =
	    (buffer[0x16] << 3 | buffer[0x17] >> 5) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x17] >> 1) & 15;
	    shit = (buffer[0x17] << 2 | buffer[0x18] >> 6) & 7;
	    granule_data[1][0].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[1][0].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[1][0].switch_point = 0;
    }
    granule_data[1][0].preflag = (buffer[0x18] >> 5) & 1;
    granule_data[1][0].scalefac_scale = (buffer[0x18] >> 4) & 1;
    granule_data[1][0].count1table_select = buffer[0x18] & 8;
    granule_data[1][1].scfsi = buffer[0x02] >> 4;
    granule_data[1][1].part2_3_length =
	(buffer[0x18] << 9 | buffer[0x19] << 1 | buffer[0x1a] >> 7) & 4095;
    granule_data[1][1].big_values =
	(buffer[0x1a] << 2 | buffer[0x1b] >> 6) & 511;
    granule_data[1][1].pow2gain = III_break_1 + 256
	- ((buffer[0x1b] << 2 | buffer[0x1c] >> 6) & 255) + 0;
    if (joint_stereo_mode & 2) {
	granule_data[1][1].pow2gain += 2;
    }
    granule_data[1][1].scalefac_compress = (buffer[0x1c] >> 2) & 15;
    if (buffer[0x1c] & 0002) {
	granule_data[1][1].block_type =
	    (buffer[0x1c] << 1 | buffer[0x1d] >> 7) & 3;
	if (!granule_data[1][1].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[1][1].switch_point = (~buffer[0x1d] >> 6) & 1;
	granule_data[1][1].table_select[0] = (buffer[0x1d] >> 1) & 31;
	granule_data[1][1].table_select[1] =
	    (buffer[0x1d] << 4 | buffer[0x1e] >> 4) & 31;
	granule_data[1][1].table_select[2] = 0;
	granule_data[1][1].full_gain[0] = granule_data[1][1].pow2gain
	    + ((buffer[0x1e] << 2) & 56);
	granule_data[1][1].full_gain[1] = granule_data[1][1].pow2gain
	    + ((buffer[0x1e] << 5 | buffer[0x1f] >> 3) & 56);
	granule_data[1][1].full_gain[2] = granule_data[1][1].pow2gain
	    + (buffer[0x1f] & 56);
	granule_data[1][1].region_address1 = 18;
	granule_data[1][1].region_address2 = 288;
    } else {
	granule_data[1][1].block_type = 0;
	granule_data[1][1].table_select[0] =
	    (buffer[0x1c] << 4 | buffer[0x1d] >> 4) & 31;
	granule_data[1][1].table_select[1] =
	    (buffer[0x1d] << 1 | buffer[0x1e] >> 7) & 31;
	granule_data[1][1].table_select[2] = (buffer[0x1e] >> 2) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x1e] << 2 | buffer[0x1f] >> 6) & 15;
	    shit = (buffer[0x1f] >> 3) & 7;
	    granule_data[1][1].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[1][1].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[1][1].switch_point = 0;
    }
    granule_data[1][1].preflag = (buffer[0x1f] >> 2) & 1;
    granule_data[1][1].scalefac_scale = (buffer[0x1f] >> 1) & 1;
    granule_data[1][1].count1table_select = buffer[0x1f] & 1;

    RESTORE_FRAME(audio->last_frame);

    frame = audio->left_frame;

    buffer = audio->layer_data.III.data;
    size = audio->layer_data.III.frames[frame].size;

    this_granule = (struct Mylene1f4_granule *) granule_data;
    for (; granule < 2; granule++) {
	Mylene1f4_real hybrid_in[2][576], hybrid_out[2][576];

	part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac[0], hybrid_in[0], this_granule,
	      audio->sampling_frequency);
	part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac[1], hybrid_in[1], this_granule + 1,
	      audio->sampling_frequency);

	if (joint_stereo_mode) {
	    if (joint_stereo_mode & 2) {
#if !__RUN_FUTILE__
		_Mylene1f4_ms_stereo(hybrid_in[0], this_granule);
#endif				/* !__RUN_FUTILE__ */
	    }
	    if (joint_stereo_mode & 1) {
#if !__RUN_FUTILE__
		_Mylene1f4_intensity_stereo
		    (hybrid_in[0], scalefac[1], this_granule + 1,
		     audio->sampling_frequency, joint_stereo_mode & 2, 0);
#endif				/* !__RUN_FUTILE__ */
	    }
	    RIGHT_STEREO(this_granule);
	}

#if !__RUN_FUTILE__
	_Mylene1f4_do_time
	    (audio, hybrid_in[0], hybrid_out[0], 0, this_granule);
	_Mylene1f4_do_time
	    (audio, hybrid_in[1], hybrid_out[1], 1, this_granule + 1);
#endif				/* !__RUN_FUTILE__ */

	{
	    unsigned char *output;

	    output = audio->output;
	    if (granule) {
		output += 1152 << audio->sample_shift;
	    }
#if !__RUN_FUTILE__
	    audio->polyphase_synthesis_1(audio, hybrid_out[0], 0, output, 18);
	    audio->polyphase_synthesis_1(audio, hybrid_out[1], 1, output, 18);
#endif				/* !__RUN_FUTILE__ */
	}

	this_granule += 2;
    }

    ADVANCE_FRAME(audio->last_frame);
}


static void
audio_data_d(struct Mylene1f4_audio *audio)
{
    struct Mylene1f4_granule granule_data[2], *this_granule;
    unsigned cache_buffer = 0, cache_size = 0, frame, granule = 0,
	scalefac[39], size;
    unsigned char *buffer;

    if (run_frame(audio)) {
	return;
    }

    buffer = audio->layer_data.III.head;

    granule_data[0].scfsi = ~0;
    granule_data[0].part2_3_length =
	(buffer[0x02] << 6 | buffer[0x03] >> 2) & 4095;
    granule_data[0].big_values =
	(buffer[0x03] << 7 | buffer[0x04] >> 1) & 511;
    granule_data[0].pow2gain = III_break_1 + 256
	- ((buffer[0x04] << 7 | buffer[0x05] >> 1) & 255) + 0;
    granule_data[0].scalefac_compress =
	(buffer[0x05] << 3 | buffer[0x06] >> 5) & 15;
    if (buffer[0x06] & 0020) {
	granule_data[0].block_type = (buffer[0x06] >> 2) & 3;
	if (!granule_data[0].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[0].switch_point = (~buffer[0x06] >> 1) & 1;
	granule_data[0].table_select[0] =
	    (buffer[0x06] << 4 | buffer[0x07] >> 4) & 31;
	granule_data[0].table_select[1] =
	    (buffer[0x07] << 1 | buffer[0x08] >> 7) & 31;
	granule_data[0].table_select[2] = 0;
	granule_data[0].full_gain[0] = granule_data[0].pow2gain
	    + ((buffer[0x08] >> 1) & 56);
	granule_data[0].full_gain[1] = granule_data[0].pow2gain
	    + ((buffer[0x08] << 2) & 56);
	granule_data[0].full_gain[2] = granule_data[0].pow2gain
	    + ((buffer[0x08] << 5 | buffer[0x09] >> 3) & 56);
	granule_data[0].region_address1 = 18;
	granule_data[0].region_address2 = 288;
    } else {
	granule_data[0].block_type = 0;
	granule_data[0].table_select[0] =
	    (buffer[0x06] << 1 | buffer[0x07] >> 7) & 31;
	granule_data[0].table_select[1] = (buffer[0x07] >> 2) & 31;
	granule_data[0].table_select[2] =
	    (buffer[0x07] << 3 | buffer[0x08] >> 5) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x08] >> 1) & 15;
	    shit = (buffer[0x08] << 2 | buffer[0x09] >> 6) & 7;
	    granule_data[0].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[0].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[0].switch_point = 0;
    }
    granule_data[0].preflag = (buffer[0x09] >> 5) & 1;
    granule_data[0].scalefac_scale = (buffer[0x09] >> 4) & 1;
    granule_data[0].count1table_select = buffer[0x09] & 8;
    granule_data[1].scfsi = (buffer[0x01] << 2 | buffer[0x02] >> 6) & 15;
    granule_data[1].part2_3_length =
	(buffer[0x09] << 9 | buffer[0x0a] << 1 | buffer[0x0b] >> 7) & 4095;
    granule_data[1].big_values =
	(buffer[0x0b] << 2 | buffer[0x0c] >> 6) & 511;
    granule_data[1].pow2gain = III_break_1 + 256
	- ((buffer[0x0c] << 2 | buffer[0x0d] >> 6) & 255) + 0;
    granule_data[1].scalefac_compress = (buffer[0x0d] >> 2) & 15;
    if (buffer[0x0d] & 0002) {
	granule_data[1].block_type =
	    (buffer[0x0d] << 1 | buffer[0x0e] >> 7) & 3;
	if (!granule_data[1].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[1].switch_point = (~buffer[0x0e] >> 6) & 1;
	granule_data[1].table_select[0] = (buffer[0x0e] >> 1) & 31;
	granule_data[1].table_select[1] =
	    (buffer[0x0e] << 4 | buffer[0x0f] >> 4) & 31;
	granule_data[1].table_select[2] = 0;
	granule_data[1].full_gain[0] = granule_data[1].pow2gain
	    + ((buffer[0x0f] << 2) & 56);
	granule_data[1].full_gain[1] = granule_data[1].pow2gain
	    + ((buffer[0x0f] << 5 | buffer[0x10] >> 3) & 56);
	granule_data[1].full_gain[2] = granule_data[1].pow2gain
	    + (buffer[0x10] & 56);
	granule_data[1].region_address1 = 18;
	granule_data[1].region_address2 = 288;
    } else {
	granule_data[1].block_type = 0;
	granule_data[1].table_select[0] =
	    (buffer[0x0d] << 4 | buffer[0x0e] >> 4) & 31;
	granule_data[1].table_select[1] =
	    (buffer[0x0e] << 1 | buffer[0x0f] >> 7) & 31;
	granule_data[1].table_select[2] = (buffer[0x0f] >> 2) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x0f] << 2 | buffer[0x10] >> 6) & 15;
	    shit = (buffer[0x10] >> 3) & 7;
	    granule_data[1].region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency][bull + 1]
		>> 1;
	    granule_data[1].region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[1].switch_point = 0;
    }
    granule_data[1].preflag = (buffer[0x10] >> 2) & 1;
    granule_data[1].scalefac_scale = (buffer[0x10] >> 1) & 1;
    granule_data[1].count1table_select = buffer[0x10] & 1;

    RESTORE_FRAME(audio->last_frame);

    frame = audio->left_frame;

    buffer = audio->layer_data.III.data;
    size = audio->layer_data.III.frames[frame].size;

    this_granule = (struct Mylene1f4_granule *) granule_data;
    for (; granule < 2; granule++) {
	Mylene1f4_real hybrid_in[576], hybrid_out[576];

        part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac, hybrid_in, this_granule, audio->sampling_frequency);

#if !__RUN_FUTILE__
	_Mylene1f4_do_time(audio, hybrid_in, hybrid_out, 0, this_granule);
#endif				/* !__RUN_FUTILE__ */

	{
	    unsigned char *output;

	    output = audio->output;
	    if (granule) {
		output += 576 << audio->sample_shift;
	    }
#if !__RUN_FUTILE__
	    audio->polyphase_synthesis_0(audio, hybrid_out, output, 18);
#endif				/* !__RUN_FUTILE__ */
	}

	this_granule++;
    }

    ADVANCE_FRAME(audio->last_frame);
}


static int
run_frame(struct Mylene1f4_audio *audio)
{
    struct Mylene1f4_frame *frames;
    unsigned audio_data_size, frame;
    unsigned char *buffer;

    audio_data_size = audio->frame_data_size;
    buffer = audio->buffer + (audio->syncword_offset - audio_data_size);

    audio->layer_data.III.head = buffer;

    frames = audio->layer_data.III.frames;

    frame = audio->last_frame;

    if (audio->mode == single_channel) {
	audio_data_size -= 17;
	frames[frame].buffer = buffer + 17;
    } else {
	audio_data_size -= 32;
	frames[frame].buffer = buffer + 32;
    }
    frames[frame].size = audio_data_size;

    ADVANCE_FRAME(frame);
    audio->last_frame = frame;

#if 0
    audio_data_size += audio->frame_size;
    audio->frame_size = audio_data_size;
    {
	unsigned main_data_end;

	main_data_end = *buffer << 1 | buffer[1] >> 7;
	audio_data_size -= main_data_end;
	audio->frame_size = main_data_end;
    }
#else
    {
	unsigned swap;

	swap = audio_data_size;
	audio_data_size = audio->frame_size;
	audio->frame_size = swap;
    }
    {
	unsigned main_data_begin;

	main_data_begin = *buffer << 1 | buffer[1] >> 7;
	if (audio_data_size < main_data_begin) {
	    _Mylene1f4_abort_decoding((struct Mylene1f4_whatever *) audio,
				      AUDIO_INVALID_BACKWARD_SEEK);

	    audio->frame_size += audio_data_size;

	    return 1;
	}
	audio_data_size -= main_data_begin;
	audio->frame_size += main_data_begin;
    }
#endif				/* 0 */

    frame = audio->left_frame;

    while (audio_data_size) {
	struct Mylene1f4_frame *frame_data;

	frame_data = frames + frame;
	if (audio_data_size < frame_data->size) {
	    frame_data->buffer += audio_data_size;
	    frame_data->size -= audio_data_size;
	    audio_data_size = 0;
	} else {
	    audio_data_size -= frame_data->size;
	    ADVANCE_FRAME(frame);
	}
    }

    audio->left_frame = frame;

    buffer = frames[frame].buffer;

    audio->layer_data.III.data = buffer;

    audio->syncword_offset -= buffer - audio->buffer;
    if (audio->syncword_offset < audio->frame_data_size) {
	buffer += audio->syncword_offset;
	buffer -= audio->frame_data_size;
	audio->syncword_offset = audio->frame_data_size;
    }
    audio->size -= buffer - audio->buffer;
    audio->buffer = buffer;

    return 0;
}


static void
desenchantee(struct Mylene1f4_audio *audio, unsigned char **buffer,
	     unsigned *size, unsigned *frame)
{
    unsigned this_frame;

    this_frame = *frame;
    if (this_frame == audio->last_frame) {
    } else {
	struct Mylene1f4_frame *frame_data;

	ADVANCE_FRAME(this_frame);
	*frame = this_frame;
	frame_data = audio->layer_data.III.frames + this_frame;
	*buffer = frame_data->buffer;
	*size = frame_data->size;
    }
}


static void
optimistique_moi(struct Mylene1f4_audio *audio, unsigned char **buffer,
		 unsigned *size, unsigned *frame)
{
    unsigned this_frame;

    this_frame = *frame;
    if (this_frame == audio->last_frame) {
	_Mylene1f4_abort_decoding
	    ((struct Mylene1f4_whatever *) audio, AUDIO_AUDIO_DATA_FAULT);
    } else {
	struct Mylene1f4_frame *frame_data;

	ADVANCE_FRAME(this_frame);
	*frame = this_frame;
	frame_data = audio->layer_data.III.frames + this_frame;
	*buffer = frame_data->buffer;
	*size = frame_data->size;
    }
}


static void
part2(struct Mylene1f4_audio *audio, unsigned char **buffer_in_out,
      unsigned *size_in_out, unsigned *frame, unsigned *cache_buffer_in_out,
      unsigned *cache_size_in_out, unsigned *scalefac,
      Mylene1f4_real * hybrid_in, struct Mylene1f4_granule *granule,
      unsigned sampling_frequency)
{
    unsigned *aea, cache_buffer, cache_size, size, slen1, slen2;
    unsigned char *buffer;

    aea = scalefac;
    buffer = *buffer_in_out;
    cache_buffer = *cache_buffer_in_out;
    cache_size = *cache_size_in_out;
    size = *size_in_out;
    slen1 = scalefac_compress_to_slen1[granule->scalefac_compress];
    slen2 = scalefac_compress_to_slen2[granule->scalefac_compress];

    if (granule->block_type == 2) {
	unsigned i, mask;

	mask = (1 << slen1) - 1;
	i = 17 + granule->switch_point;
	for (; i; i--) {
	    if (cache_size < slen1) {
		if (!size) {
		    optimistique_moi(audio, &buffer, &size, frame);
		}
		cache_buffer <<= 8;
		cache_buffer |= *buffer++;
		cache_size += 8;
		size--;
	    }
	    cache_size -= slen1;
	    *aea++ = (cache_buffer >> cache_size) & mask;
	}
	mask = (1 << slen2) - 1;
	for (i = 18; i; i--) {
	    if (cache_size < slen2) {
		if (!size) {
		    optimistique_moi(audio, &buffer, &size, frame);
		}
		cache_buffer <<= 8;
		cache_buffer |= *buffer++;
		cache_size += 8;
		size--;
	    }
	    cache_size -= slen2;
	    *aea++ = (cache_buffer >> cache_size) & mask;
	}
	*aea = 0;
	aea[1] = 0;
	aea[2] = 0;
	granule->part2_3_length -= part2_length___2_
	    [granule->switch_point << 4 | granule->scalefac_compress];
    } else {
	unsigned i, mask, scfsi;

	scfsi = granule->scfsi;
	if (~scfsi) {
	    mask = (1 << slen1) - 1;
	    if (scfsi & 8) {
		aea += 6;
	    } else {
		for (i = 6; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
	    }
	    if (scfsi & 4) {
		aea += 5;
	    } else {
		for (i = 5; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
	    }
	    mask = (1 << slen2) - 1;
	    if (scfsi & 2) {
		aea += 5;
	    } else {
		for (i = 5; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
	    }
	    if (scfsi & 1) {
		aea += 5;
	    } else {
		for (i = 5; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
	    }
	    *aea = 0;
	    granule->part2_3_length -= part2_length_01_3
		[scfsi << 4 | granule->scalefac_compress];
	} else {
	    mask = (1 << slen1) - 1;
	    for (i = 11; i; i--) {
		if (cache_size < slen1) {
		    if (!size) {
			optimistique_moi(audio, &buffer, &size, frame);
		    }
		    cache_buffer <<= 8;
		    cache_buffer |= *buffer++;
		    cache_size += 8;
		    size--;
		}
		cache_size -= slen1;
		*aea++ = (cache_buffer >> cache_size) & mask;
	    }
	    mask = (1 << slen2) - 1;
	    for (i = 10; i; i--) {
		if (cache_size < slen2) {
		    if (!size) {
			optimistique_moi(audio, &buffer, &size, frame);
		    }
		    cache_buffer <<= 8;
		    cache_buffer |= *buffer++;
		    cache_size += 8;
		    size--;
		}
		cache_size -= slen2;
		*aea++ = (cache_buffer >> cache_size) & mask;
	    }
	    *aea = 0;
	    granule->part2_3_length -=
		part2_length_01_3[granule->scalefac_compress];
	}
    }

    *buffer_in_out = buffer;
    *cache_buffer_in_out = cache_buffer;
    *cache_size_in_out = cache_size;
    *size_in_out = size;

    _Mylene1f4_part3
	(audio, buffer_in_out, size_in_out, frame, cache_buffer_in_out,
	 cache_size_in_out, scalefac, hybrid_in, granule, sampling_frequency);
}


void
_Mylene1f4_part3(struct Mylene1f4_audio *audio, unsigned char **buffer_in_out,
		 unsigned *size_in_out, unsigned *frame,
		 unsigned *cache_buffer_in_out, unsigned *cache_size_in_out,
		 unsigned *scalefac, Mylene1f4_real * hybrid_in,
		 struct Mylene1f4_granule *granule,
		 unsigned sampling_frequency)
{
    unsigned *aea, audio_data_size, cache_buffer, cache_size, lengths[3],
	length3, size;
    unsigned char *buffer;

    buffer = *buffer_in_out;
    cache_buffer = *cache_buffer_in_out;
    cache_size = *cache_size_in_out;
    size = *size_in_out;

    audio_data_size = granule->part2_3_length;

    {
	unsigned big_values, limit, region_address1;

	big_values = granule->big_values;
	limit = granule->block_type == 2
	    ? _Mylene1f4_table_3_B_8x_2[sampling_frequency][12]
	    : _Mylene1f4_table_3_B_8x_0[sampling_frequency][21];
	limit >>= 1;
	if (limit < big_values) {
	    big_values = limit;
	}
	length3 = (limit - big_values + 1) >> 1;
	region_address1 = granule->region_address1;
	if (big_values < region_address1 + 1) {
	    lengths[0] = big_values;
	    lengths[1] = 0;
	    lengths[2] = 0;
	} else {
	    unsigned region_address2;

	    lengths[0] = region_address1;
	    region_address2 = granule->region_address2;
	    if (big_values < region_address2 + 1) {
		lengths[1] = big_values - lengths[0];
		lengths[2] = 0;
	    } else {
		lengths[1] = region_address2 - lengths[0];
		lengths[2] = big_values - region_address2;
	    }
	}
    }

    aea = scalefac;

    if (granule->block_type == 2) {
	Mylene1f4_real v = 0, *yii = NULL;
	unsigned cb, countdown, lwin, i = 0, *map, max[4], mc = 0, shift, step;

	if (granule->switch_point) {
	    max[0] = max[1] = max[2] = max[3] = -1;

	    cb = 0;
	    countdown = 0;
	    lwin = ~0;
	    map = (unsigned *) 
		_Mylene1f4_table_3_B_8x_3[sampling_frequency];
	    step = 3;
	    yii = hybrid_in + (*map * 3 - 1);
	} else {
	    max[0] = max[1] = max[2] = 2;
	    max[3] = -1;

	    cb = ~0;
	    countdown = 8;
	    lwin = 3;
	    map = (unsigned *)
		_Mylene1f4_table_3_B_8x_1[sampling_frequency];
	    step = 1;
	    yii = hybrid_in;
	}
	granule->switch_point ^= 1;
	shift = 1 + granule->scalefac_scale;

	for (; i < 2; i++) {
	    unsigned lengthx, select, *table_3_B_7___;

	    lengthx = lengths[i];
	    select = granule->table_select[i];
	    table_3_B_7___ = _Mylene1f4_table_3_B_7__2[select];
	    select = _Mylene1f4_table_3_B_7__3[select];
	    if (!table_3_B_7___) {
		_Mylene1f4_abort_decoding((struct Mylene1f4_whatever *) audio,
					  AUDIO_AUDIO_DATA_FAULT);
	    } else if (select == 0) {
		for (; lengthx; lengthx--) {
		    if (!mc) {
			if (countdown) {
			    cb++;
			    countdown--;
			    mc = *map++;
			    v = granule->pow2gain[*aea++ << shift];
			} else if (lwin == 3) {
			    cb = 3;
			    lwin = 0;
			    map = (unsigned *) _Mylene1f4_table_3_B_8x_3
				[sampling_frequency] + 3;
			    mc = *map >> 1;
			    step = 3;
			    v = granule->full_gain[0][*aea++ << shift];
			} else {
			    lwin++;
			    if (lwin == 3) {
				cb++;
				lwin = 0;
				mc = *++map >> 1;
				yii -= 2;
			    } else {
				mc = *map;
				yii -= mc * 3 - 1;
				mc >>= 1;
			    }
			    v = granule->full_gain[lwin][*aea++ << shift];
			}
		    }
		    mc--;
		    *yii = 0;
		    yii += step;
		    *yii = 0;
		    yii += step;
		}
	    } else if (select < 9) {
		unsigned hcode, hlengthp2, hmask;

		hmask = ~(~0 << select);
		for (; lengthx; lengthx--) {
		    if (cache_size < select) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			} else {
			    cache_buffer <<= select - cache_size;
			    cache_size = select;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - select) & hmask];
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x23f;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			if (countdown) {
			    cb++;
			    countdown--;
			    mc = *map++;
			    v = granule->pow2gain[*aea++ << shift];
			} else if (lwin == 3) {
			    cb = 3;
			    lwin = 0;
			    map = (unsigned *) _Mylene1f4_table_3_B_8x_3
				[sampling_frequency] + 3;
			    mc = *map >> 1;
			    step = 3;
			    v = granule->full_gain[0][*aea++ << shift];
			} else {
			    lwin++;
			    if (lwin == 3) {
				cb++;
				lwin = 0;
				mc = *++map >> 1;
				yii -= 2;
			    } else {
				mc = *map;
				yii -= mc * 3 - 1;
				mc >>= 1;
			    }
			    v = granule->full_gain[lwin][*aea++ << shift];
			}
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii = 0;
			yii += step;
			*yii = 0;
			yii += step;
		    } else {
			max[lwin] = cb;
			*yii = _Mylene1f4_break_0[hcode >> 8] * v;
			yii += step;
			*yii = _Mylene1f4_break_0[hcode & 255] * v;
			yii += step;
		    }
		}
	    } else if (select < 10) {
		unsigned hcode, hlengthp2;

		for (; lengthx; lengthx--) {
		    if (cache_size < 9) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 9) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 9 - cache_size;
				    cache_size = 9;
				}
			    }
			} else {
			    cache_buffer <<= 9 - cache_size;
			    cache_size = 9;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 9) & 511];
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x23f;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			if (countdown) {
			    cb++;
			    countdown--;
			    mc = *map++;
			    v = granule->pow2gain[*aea++ << shift];
			} else if (lwin == 3) {
			    cb = 3;
			    lwin = 0;
			    map = (unsigned *) _Mylene1f4_table_3_B_8x_3
				[sampling_frequency] + 3;
			    mc = *map >> 1;
			    step = 3;
			    v = granule->full_gain[lwin][*aea++ << shift];
			} else {
			    lwin++;
			    if (lwin == 3) {
				cb++;
				lwin = 0;
				mc = *++map >> 1;
				yii -= 2;
			    } else {
				mc = *map;
				yii -= mc * 3 - 1;
				mc >>= 1;
			    }
			    v = granule->full_gain[lwin][*aea++ << shift];
			}
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii = 0;
			yii += step;
			*yii = 0;
			yii += step;
		    } else {
			max[lwin] = cb;
			*yii = _Mylene1f4_break_0[hcode >> 8] * v;
			yii += step;
			*yii = _Mylene1f4_break_0[hcode & 255] * v;
			yii += step;
		    }
		}
	    } else if (select < 11) {
		unsigned hcode, hlengthp2;

		for (; lengthx; lengthx--) {
		    if (cache_size < 10) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 10) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 10 - cache_size;
				    cache_size = 10;
				}
			    }
			} else {
			    cache_buffer <<= 10 - cache_size;
			    cache_size = 10;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 10) & 1023];
		    if (hlengthp2 & 4278190080u) {
			unsigned subselect, *table_3_B_7___;

			if (audio_data_size < 11) {
			    goto x23f;
			}
			cache_size -= hlengthp2 & 255;
			audio_data_size -= hlengthp2 & 255;
			subselect = hlengthp2 >> 24;
			table_3_B_7___ = _Mylene1f4_table_3_B_7__2[subselect];
			subselect = _Mylene1f4_table_3_B_7__3[subselect];
			if (cache_size < subselect) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < subselect) {
				    if (!size) {
					desenchantee
					    (audio, &buffer, &size, frame);
				    }
				    if (size) {
					cache_buffer <<= 8;
					cache_buffer |= *buffer++;
					cache_size += 8;
					size--;
				    } else {
					cache_buffer <<= subselect - cache_size;
					cache_size = subselect;
				    }
				}
			    } else {
				cache_buffer <<= subselect - cache_size;
				cache_size = subselect;
			    }
			}
			hlengthp2 = table_3_B_7___
			    [cache_buffer >> (cache_size - subselect)
			     & ((1 << subselect) - 1)];
		    }
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x23f;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			if (countdown) {
			    cb++;
			    countdown--;
			    mc = *map++;
			    v = granule->pow2gain[*aea++ << shift];
			} else if (lwin == 3) {
			    cb = 3;
			    lwin = 0;
			    map = (unsigned *) _Mylene1f4_table_3_B_8x_3
				[sampling_frequency] + 3;
			    mc = *map >> 1;
			    step = 3;
			    v = granule->full_gain[lwin][*aea++ << shift];
			} else {
			    lwin++;
			    if (lwin == 3) {
				cb++;
				lwin = 0;
				mc = *++map >> 1;
				yii -= 2;
			    } else {
				mc = *map;
				yii -= mc * 3 - 1;
				mc >>= 1;
			    }
			    v = granule->full_gain[lwin][*aea++ << shift];
			}
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii = 0;
			yii += step;
			*yii = 0;
			yii += step;
		    } else {
			max[lwin] = cb;
			*yii = _Mylene1f4_break_0[hcode >> 8] * v;
			yii += step;
			*yii = _Mylene1f4_break_0[hcode & 255] * v;
			yii += step;
		    }
		}
	    } else {
		unsigned hcode, hlengthp2, linbits;

		linbits = _Mylene1f4_table_3_B_7__4[granule->table_select[i]];
		for (; lengthx; lengthx--) {
		    if (cache_size < 10) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 10) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 10 - cache_size;
				    cache_size = 10;
				}
			    }
			} else {
			    cache_buffer <<= 10 - cache_size;
			    cache_size = 10;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 10) & 1023];
		    if (hlengthp2 & 4278190080u) {
			unsigned subselect, *table_3_B_7___;

			if (audio_data_size < 11) {
			    goto x23f;
			}
			cache_size -= hlengthp2 & 255;
			audio_data_size -= hlengthp2 & 255;
			subselect = hlengthp2 >> 24;
			table_3_B_7___ = _Mylene1f4_table_3_B_7__2[subselect];
			subselect = _Mylene1f4_table_3_B_7__3[subselect];
			if (cache_size < subselect) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < subselect) {
				    if (!size) {
					desenchantee
					    (audio, &buffer, &size, frame);
				    }
				    if (size) {
					cache_buffer <<= 8;
					cache_buffer |= *buffer++;
					cache_size += 8;
					size--;
				    } else {
					cache_buffer <<= subselect - cache_size;
					cache_size = subselect;
				    }
				}
			    } else {
				cache_buffer <<= subselect - cache_size;
				cache_size = subselect;
			    }
			}
			hlengthp2 = table_3_B_7___
			    [(cache_buffer >> (cache_size - subselect))
			     & ((1 << subselect) - 1)];
		    }
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x23f;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			if (countdown) {
			    cb++;
			    countdown--;
			    mc = *map++;
			    v = granule->pow2gain[*aea++ << shift];
			} else if (lwin == 3) {
			    cb = 3;
			    lwin = 0;
			    map = (unsigned *) _Mylene1f4_table_3_B_8x_3
				[sampling_frequency] + 3;
			    mc = *map >> 1;
			    step = 3;
			    v = granule->full_gain[lwin][*aea++ << shift];
			} else {
			    lwin++;
			    if (lwin == 3) {
				cb++;
				lwin = 0;
				mc = *++map >> 1;
				yii -= 2;
			    } else {
				mc = *map;
				yii -= mc * 3 - 1;
				mc >>= 1;
			    }
			    v = granule->full_gain[lwin][*aea++ << shift];
			}
		    }
		    mc--;
		    if (7680 < hcode) {
			if (30 < (hcode & 255)) {
			    if (audio_data_size < (linbits + 1) << 1) {
				goto x23f;
			    }
			    audio_data_size -= (linbits + 1) << 1;
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < linbits + 1) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				*yii = -*yii;
			    }
			    yii += step;
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < linbits + 1) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				*yii = -*yii;
			    }
			    yii += step;
			} else {
			    unsigned stream_flow;

			    stream_flow = linbits + 1;
			    if ((hcode & 255) - 15) {
				stream_flow++;
			    }
			    if (audio_data_size < stream_flow) {
				goto x23f;
			    }
			    audio_data_size -= stream_flow;
			    if (cache_size < stream_flow) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < stream_flow) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				*yii = -*yii;
			    }
			    yii += step;
			    *yii = _Mylene1f4_break_0[hcode & 255] * v;
			    if (*yii) {
				cache_size--;
				if ((cache_buffer >> cache_size) & 1) {
				    *yii = -*yii;
				}
			    }
			    yii += step;
			}
			max[lwin] = cb;
		    } else if (30 < (hcode & 255)) {
			if (audio_data_size < linbits + 1) {
			    goto x23f;
			}
			audio_data_size -= linbits + 1;
			*yii = _Mylene1f4_break_0[hcode >> 8] * v;
			yii += step;
			if (cache_size < linbits + 1) {
			    if (!size) {
				optimistique_moi(audio, &buffer, &size, frame);
			    }
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= linbits;
			*yii = III_break_0
			    [15 + ((cache_buffer >> cache_size)
				   & ((1 << linbits) - 1))] * v;
			cache_size--;
			if ((cache_buffer >> cache_size) & 1) {
			    *yii = -*yii;
			}
			yii += step;
			max[lwin] = cb;
		    } else if (hcode == 0x0f0f) {
			*yii = 0;
			yii += step;
			*yii = 0;
			yii += step;
		    } else {
			max[lwin] = cb;
			*yii = _Mylene1f4_break_0[hcode >> 8] * v;
			yii += step;
			*yii = _Mylene1f4_break_0[hcode & 255] * v;
			yii += step;
		    }
		}
	    }
	}

	if (granule->count1table_select) {
	    unsigned hcode, hlengthp2;

	    for (; length3; length3--) {
		if (cache_size < 8) {
		    if (!size) {
			desenchantee(audio, &buffer, &size, frame);
		    }
		    if (size) {
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    } else {
			cache_buffer <<= 8 - cache_size;
			cache_size = 8;
		    }
		}
		hlengthp2 = _Mylene1f4_table_3_B_7__1
		    [(cache_buffer >> (cache_size - 8)) & 255];
		hcode = hlengthp2 & 255;
		hlengthp2 >>= 8;
		if (audio_data_size < hlengthp2) {
		    goto x23f;
		}
		audio_data_size -= hlengthp2;
		cache_size -= hlengthp2;
		if (!mc) {
		    if (countdown) {
			cb++;
			countdown--;
			mc = *map++;
			v = granule->pow2gain[*aea++ << shift];
		    } else if (lwin == 3) {
			cb = 3;
			lwin = 0;
			map = (unsigned *) _Mylene1f4_table_3_B_8x_3
			    [sampling_frequency] + 3;
			mc = *map >> 1;
			step = 3;
			v = granule->full_gain[lwin][*aea++ << shift];
		    } else {
			lwin++;
			if (lwin == 3) {
			    cb++;
			    lwin = 0;
			    mc = *++map >> 1;
			    yii -= 2;
			} else {
			    mc = *map;
			    yii -= mc * 3 - 1;
			    mc >>= 1;
			}
			v = granule->full_gain[lwin][*aea++ << shift];
		    }
		}
		mc--;
		switch (hcode & 15) {
		case 0x0:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x1:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x2:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x4:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x5:
		    *yii = 0;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x6:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x8:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0x9:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0xa:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		}
		if (!mc) {
		    if (countdown) {
			cb++;
			countdown--;
			mc = *map++;
			v = granule->pow2gain[*aea++ << shift];
		    } else if (lwin == 3) {
			cb = 3;
			lwin = 0;
			map = (unsigned *) _Mylene1f4_table_3_B_8x_3
			    [sampling_frequency] + 3;
			mc = *map >> 1;
			step = 3;
			v = granule->full_gain[lwin][*aea++ << shift];
		    } else {
			lwin++;
			if (lwin == 3) {
			    cb++;
			    lwin = 0;
			    mc = *++map >> 1;
			    yii -= 2;
			} else {
			    mc = *map;
			    yii -= mc * 3 - 1;
			    mc >>= 1;
			}
			v = granule->full_gain[lwin][*aea++ << shift];
		    }
		}
		mc--;
		hcode >>= 4;
		switch (hcode & 15) {
		case 0x0:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x1:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x2:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x4:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x5:
		    *yii = 0;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x6:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x8:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0x9:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0xa:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		}
	    }
	} else {
	    unsigned hcode, hlengthp2;

	    for (; length3; length3--) {
		if (cache_size < 10) {
		    if (!size) {
			desenchantee(audio, &buffer, &size, frame);
		    }
		    if (size) {
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
			if (cache_size < 10) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
			    } else {
				cache_buffer <<= 10 - cache_size;
				cache_size = 10;
			    }
			}
		    } else {
			cache_buffer <<= 10 - cache_size;
			cache_size = 10;
		    }
		}
		hlengthp2 = _Mylene1f4_table_3_B_7__0
		    [(cache_buffer >> (cache_size - 10)) & 1023];
		hcode = hlengthp2 & 255;
		hlengthp2 >>= 8;
		if (audio_data_size < hlengthp2) {
		    goto x23f;
		}
		audio_data_size -= hlengthp2;
		cache_size -= hlengthp2;
		if (!mc) {
		    if (countdown) {
			cb++;
			countdown--;
			mc = *map++;
			v = granule->pow2gain[*aea++ << shift];
		    } else if (lwin == 3) {
			cb = 3;
			lwin = 0;
			map = (unsigned *) _Mylene1f4_table_3_B_8x_3
			    [sampling_frequency] + 3;
			mc = *map >> 1;
			step = 3;
			v = granule->full_gain[lwin][*aea++ << shift];
		    } else {
			lwin++;
			if (lwin == 3) {
			    cb++;
			    lwin = 0;
			    mc = *++map >> 1;
			    yii -= 2;
			} else {
			    mc = *map;
			    yii -= mc * 3 - 1;
			    mc >>= 1;
			}
			v = granule->full_gain[lwin][*aea++ << shift];
		    }
		}
		mc--;
		switch (hcode & 15) {
		case 0x0:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x1:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x2:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x4:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x5:
		    *yii = 0;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x6:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x8:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0x9:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0xa:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		}
		if (!mc) {
		    if (countdown) {
			cb++;
			countdown--;
			mc = *map++;
			v = granule->pow2gain[*aea++ << shift];
		    } else if (lwin == 3) {
			cb = 3;
			lwin = 0;
			map = (unsigned *) _Mylene1f4_table_3_B_8x_3
			    [sampling_frequency] + 3;
			mc = *map >> 1;
			step = 3;
			v = granule->full_gain[lwin][*aea++ << shift];
		    } else {
			lwin++;
			if (lwin == 3) {
			    cb++;
			    lwin = 0;
			    mc = *++map >> 1;
			    yii -= 2;
			} else {
			    mc = *map;
			    yii -= mc * 3 - 1;
			    mc >>= 1;
			}
			v = granule->full_gain[lwin][*aea++ << shift];
		    }
		}
		mc--;
		hcode >>= 4;
		switch (hcode & 15) {
		case 0x0:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x1:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x2:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = v;
		    yii += step;
		    break;
		case 0x4:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x5:
		    *yii = 0;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x6:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = 0;
		    yii += step;
		    break;
		case 0x8:
		    max[lwin] = cb;
		    *yii = v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0x9:
		    max[lwin] = cb;
		    *yii = 0;
		    yii += step;
		    *yii = -v;
		    yii += step;
		    break;
		case 0xa:
		    max[lwin] = cb;
		    *yii = -v;
		    yii += step;
		    *yii = -v;
		    yii += step;
		}
	    }
	}

      x23f:
	if (!~lwin) {
	    yii -= *map * 3 - 1;
	} else if (lwin < 3) {
	    while (lwin < 3) {
		for (; mc; mc--) {
		    *yii = 0;
		    yii += 3;
		    *yii = 0;
		    yii += 3;
		}
		lwin++;
		mc = *map;
		yii -= mc * 3 - 1;
		mc >>= 1;
	    }
	    yii += *map * 3 - 3;
	}
	{
	    unsigned quotient, remainder;

	    quotient = (Mylene1f4_real *) hybrid_in - yii;
	    quotient += 576;
	    remainder = quotient & 7;
	    for (; remainder; remainder--) {
		*yii++ = 0;
	    }
	    quotient >>= 3;
	    for (; quotient; quotient--) {
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
	    }
	}

	granule->maxband[0] = max[0] + 1;
	granule->maxband[1] = max[1] + 1;
	granule->maxband[2] = max[2] + 1;
	granule->maxbandl = max[3] + 1;
	{
	    int rmax;

	    rmax = max[0];
	    if (rmax < max[1]) {
		rmax = max[1];
	    }
	    if (rmax < max[2]) {
		rmax = max[2];
	    }
	    rmax++;
	    if (rmax) {
		granule->maxb = table_3_B_8x__1[sampling_frequency][rmax];
	    } else {
		granule->maxb =
		    table_3_B_8x__0[sampling_frequency][max[3] + 1];
	    }
	}
    } else {
	Mylene1f4_real v = 0, *yii;
	unsigned cb = ~0, i = 0, *map, max = ~0, mc = 0, *pretab, shift;

	map = (unsigned *) _Mylene1f4_table_3_B_8x_1[sampling_frequency];
	pretab = (unsigned *)
	    (granule->preflag ? table_3_B_6__0 : table_3_B_6__1);
	shift = 1 + granule->scalefac_scale;

	yii = hybrid_in;
	for (; i < 3; i++) {
	    unsigned lengthx, select, *table_3_B_7___;

	    lengthx = lengths[i];
	    select = granule->table_select[i];
	    table_3_B_7___ = _Mylene1f4_table_3_B_7__2[select];
	    select = _Mylene1f4_table_3_B_7__3[select];
	    if (!table_3_B_7___) {
		_Mylene1f4_abort_decoding((struct Mylene1f4_whatever *) audio,
					  AUDIO_AUDIO_DATA_FAULT);
	    } else if (select == 0) {
		for (; lengthx; lengthx--) {
		    *yii++ = 0;
		    *yii++ = 0;
		}
		lengthx = lengths[i];
		while (lengthx) {
		    if (lengthx < mc) {
			mc -= lengthx;
			lengthx = 0;
		    } else if (!mc) {
			mc = *map++;
			cb++;
			v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		    } else {
			lengthx -= mc;
			mc = 0;
		    }
		}
	    } else if (select < 9) {
		unsigned hcode, hlengthp2, hmask;

		hmask = ~(~0 << select);
		for (; lengthx; lengthx--) {
		    if (cache_size < select) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			} else {
			    cache_buffer <<= select - cache_size;
			    cache_size = select;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - select) & hmask];
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x240;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			mc = *map++;
			cb++;
			v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii++ = 0;
			*yii++ = 0;
		    } else {
			max = cb;
			*yii++ = _Mylene1f4_break_0[hcode >> 8] * v;
			*yii++ = _Mylene1f4_break_0[hcode & 255] * v;
		    }
		}
	    } else if (select < 10) {
		unsigned hcode, hlengthp2;

		for (; lengthx; lengthx--) {
		    if (cache_size < 9) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 9) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 9 - cache_size;
				    cache_size = 9;
				}
			    }
			} else {
			    cache_buffer <<= 9 - cache_size;
			    cache_size = 9;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 9) & 511];
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x240;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			mc = *map++;
			cb++;
			v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii++ = 0;
			*yii++ = 0;
		    } else {
			max = cb;
			*yii++ = _Mylene1f4_break_0[hcode >> 8] * v;
			*yii++ = _Mylene1f4_break_0[hcode & 255] * v;
		    }
		}
	    } else if (select < 11) {
		unsigned hcode, hlengthp2;

		for (; lengthx; lengthx--) {
		    if (cache_size < 10) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 10) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 10 - cache_size;
				    cache_size = 10;
				}
			    }
			} else {
			    cache_buffer <<= 10 - cache_size;
			    cache_size = 10;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 10) & 1023];
		    if (hlengthp2 & 4278190080u) {
			unsigned subselect, *table_3_B_7___;

			if (audio_data_size < 11) {
			    goto x240;
			}
			cache_size -= hlengthp2 & 255;
			audio_data_size -= hlengthp2 & 255;
			subselect = hlengthp2 >> 24;
			table_3_B_7___ = _Mylene1f4_table_3_B_7__2[subselect];
			subselect = _Mylene1f4_table_3_B_7__3[subselect];
			if (cache_size < subselect) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < subselect) {
				    if (!size) {
					desenchantee
					    (audio, &buffer, &size, frame);
				    }
				    if (size) {
					cache_buffer <<= 8;
					cache_buffer |= *buffer++;
					cache_size += 8;
					size--;
				    } else {
					cache_buffer <<= subselect - cache_size;
					cache_size = subselect;
				    }
				}
			    } else {
				cache_buffer <<= subselect - cache_size;
				cache_size = subselect;
			    }
			}
			hlengthp2 = table_3_B_7___
			    [cache_buffer >> (cache_size - subselect)
			     & ((1 << subselect) - 1)];
		    }
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x240;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			mc = *map++;
			cb++;
			v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		    }
		    mc--;
		    if (hcode == 0x0f0f) {
			*yii++ = 0;
			*yii++ = 0;
		    } else {
			max = cb;
			*yii++ = _Mylene1f4_break_0[hcode >> 8] * v;
			*yii++ = _Mylene1f4_break_0[hcode & 255] * v;
		    }
		}
	    } else {
		unsigned hcode, hlengthp2, linbits;

		linbits = _Mylene1f4_table_3_B_7__4[granule->table_select[i]];
		for (; lengthx; lengthx--) {
		    if (cache_size < 10) {
			if (!size) {
			    desenchantee(audio, &buffer, &size, frame);
			}
			if (size) {
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < 10) {
				if (!size) {
				    desenchantee(audio, &buffer, &size, frame);
				}
				if (size) {
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				} else {
				    cache_buffer <<= 10 - cache_size;
				    cache_size = 10;
				}
			    }
			} else {
			    cache_buffer <<= 10 - cache_size;
			    cache_size = 10;
			}
		    }
		    hlengthp2 = table_3_B_7___
			[cache_buffer >> (cache_size - 10) & 1023];
		    if (hlengthp2 & 4278190080u) {
			unsigned subselect, *table_3_B_7___;

			if (audio_data_size < 11) {
			    goto x240;
			}
			cache_size -= hlengthp2 & 255;
			audio_data_size -= hlengthp2 & 255;
			subselect = hlengthp2 >> 24;
			table_3_B_7___ = _Mylene1f4_table_3_B_7__2[subselect];
			subselect = _Mylene1f4_table_3_B_7__3[subselect];
			if (cache_size < subselect) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < subselect) {
				    if (!size) {
					desenchantee
					    (audio, &buffer, &size, frame);
				    }
				    if (size) {
					cache_buffer <<= 8;
					cache_buffer |= *buffer++;
					cache_size += 8;
					size--;
				    } else {
					cache_buffer
					    <<= subselect - cache_size;
					cache_size = subselect;
				    }
				}
			    } else {
				cache_buffer <<= subselect - cache_size;
				cache_size = subselect;
			    }
			}
			hlengthp2 = table_3_B_7___
			    [(cache_buffer >> (cache_size - subselect))
			     & ((1 << subselect) - 1)];
		    }
		    hcode = hlengthp2 & 65535;
		    hlengthp2 >>= 16;
		    if (audio_data_size < hlengthp2) {
			goto x240;
		    }
		    audio_data_size -= hlengthp2;
		    cache_size -= hlengthp2;
		    if (!mc) {
			mc = *map++;
			cb++;
			v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		    }
		    mc--;
		    if (7680 < hcode) {
			if (30 < (hcode & 255)) {
			    if (audio_data_size < (linbits + 1) << 1) {
				goto x240;
			    }
			    audio_data_size -= (linbits + 1) << 1;
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < linbits + 1) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii++ = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				yii[-1] = -yii[-1];
			    }
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < linbits + 1) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii++ = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				yii[-1] = -yii[-1];
			    }
			} else {
			    unsigned stream_flow;

			    stream_flow = linbits + 1;
			    if ((hcode & 255) - 15) {
				stream_flow++;
			    }
			    if (audio_data_size < stream_flow) {
				goto x240;
			    }
			    audio_data_size -= stream_flow;
			    if (cache_size < stream_flow) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
				if (cache_size < stream_flow) {
				    if (!size) {
					optimistique_moi
					    (audio, &buffer, &size, frame);
				    }
				    cache_buffer <<= 8;
				    cache_buffer |= *buffer++;
				    cache_size += 8;
				    size--;
				}
			    }
			    cache_size -= linbits;
			    *yii++ = III_break_0
				[15 + ((cache_buffer >> cache_size)
				       & ((1 << linbits) - 1))] * v;
			    cache_size--;
			    if ((cache_buffer >> cache_size) & 1) {
				yii[-1] = -yii[-1];
			    }
			    *yii++ = _Mylene1f4_break_0[hcode & 255] * v;
			    if (yii[-1]) {
				cache_size--;
				if ((cache_buffer >> cache_size) & 1) {
				    yii[-1] = -yii[-1];
				}
			    }
			}
			max = cb;
		    } else if (30 < (hcode & 255)) {
			if (audio_data_size < linbits + 1) {
			    goto x240;
			}
			audio_data_size -= linbits + 1;
			*yii++ = _Mylene1f4_break_0[hcode >> 8] * v;
			if (cache_size < linbits + 1) {
			    if (!size) {
				optimistique_moi(audio, &buffer, &size, frame);
			    }
			    cache_buffer <<= 8;
			    cache_buffer |= *buffer++;
			    cache_size += 8;
			    size--;
			    if (cache_size < linbits + 1) {
				if (!size) {
				    optimistique_moi
					(audio, &buffer, &size, frame);
				}
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= linbits;
			*yii++ = III_break_0
			    [15 + ((cache_buffer >> cache_size)
				   & ((1 << linbits) - 1))] * v;
			cache_size--;
			if ((cache_buffer >> cache_size) & 1) {
			    yii[-1] = -yii[-1];
			}
			max = cb;
		    } else if (hcode == 0x0f0f) {
			*yii++ = 0;
			*yii++ = 0;
		    } else {
			max = cb;
			*yii++ = _Mylene1f4_break_0[hcode >> 8] * v;
			*yii++ = _Mylene1f4_break_0[hcode & 255] * v;
		    }
		}
	    }
	}

	if (granule->count1table_select) {
	    unsigned hcode, hlengthp2;

	    for (; length3; length3--) {
		if (cache_size < 8) {
		    if (!size) {
			desenchantee(audio, &buffer, &size, frame);
		    }
		    if (size) {
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    } else {
			cache_buffer <<= 8 - cache_size;
			cache_size = 8;
		    }
		}
		hlengthp2 = _Mylene1f4_table_3_B_7__1
		    [(cache_buffer >> (cache_size - 8)) & 255];
		hcode = hlengthp2 & 255;
		hlengthp2 >>= 8;
		if (audio_data_size < hlengthp2) {
		    goto x240;
		}
		audio_data_size -= hlengthp2;
		cache_size -= hlengthp2;
		if (!mc) {
		    mc = *map++;
		    cb++;
		    v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		}
		mc--;
		switch (hcode & 15) {
		case 0x0:
		    max = cb;
		    *yii++ = v;
		    *yii++ = v;
		    break;
		case 0x1:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = v;
		    break;
		case 0x2:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = v;
		    break;
		case 0x4:
		    max = cb;
		    *yii++ = v;
		    *yii++ = 0;
		    break;
		case 0x5:
		    *yii++ = 0;
		    *yii++ = 0;
		    break;
		case 0x6:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = 0;
		    break;
		case 0x8:
		    max = cb;
		    *yii++ = v;
		    *yii++ = -v;
		    break;
		case 0x9:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = -v;
		    break;
		case 0xa:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = -v;
		}
		if (!mc) {
		    mc = *map++;
		    cb++;
		    v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		}
		mc--;
		hcode >>= 4;
		switch (hcode & 15) {
		case 0x0:
		    max = cb;
		    *yii++ = v;
		    *yii++ = v;
		    break;
		case 0x1:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = v;
		    break;
		case 0x2:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = v;
		    break;
		case 0x4:
		    max = cb;
		    *yii++ = v;
		    *yii++ = 0;
		    break;
		case 0x5:
		    *yii++ = 0;
		    *yii++ = 0;
		    break;
		case 0x6:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = 0;
		    break;
		case 0x8:
		    max = cb;
		    *yii++ = v;
		    *yii++ = -v;
		    break;
		case 0x9:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = -v;
		    break;
		case 0xa:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = -v;
		}
	    }
	} else {
	    unsigned hcode, hlengthp2;

	    for (; length3; length3--) {
		if (cache_size < 10) {
		    if (!size) {
			desenchantee(audio, &buffer, &size, frame);
		    }
		    if (size) {
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
			if (cache_size < 10) {
			    if (!size) {
				desenchantee(audio, &buffer, &size, frame);
			    }
			    if (size) {
				cache_buffer <<= 8;
				cache_buffer |= *buffer++;
				cache_size += 8;
				size--;
			    } else {
				cache_buffer <<= 10 - cache_size;
				cache_size = 10;
			    }
			}
		    } else {
			cache_buffer <<= 10 - cache_size;
			cache_size = 10;
		    }
		}
		hlengthp2 = _Mylene1f4_table_3_B_7__0
		    [(cache_buffer >> (cache_size - 10)) & 1023];
		hcode = hlengthp2 & 255;
		hlengthp2 >>= 8;
		if (audio_data_size < hlengthp2) {
		    goto x240;
		}
		audio_data_size -= hlengthp2;
		cache_size -= hlengthp2;
		if (!mc) {
		    mc = *map++;
		    cb++;
		    v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		}
		mc--;
		switch (hcode & 15) {
		case 0x0:
		    max = cb;
		    *yii++ = v;
		    *yii++ = v;
		    break;
		case 0x1:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = v;
		    break;
		case 0x2:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = v;
		    break;
		case 0x4:
		    max = cb;
		    *yii++ = v;
		    *yii++ = 0;
		    break;
		case 0x5:
		    *yii++ = 0;
		    *yii++ = 0;
		    break;
		case 0x6:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = 0;
		    break;
		case 0x8:
		    max = cb;
		    *yii++ = v;
		    *yii++ = -v;
		    break;
		case 0x9:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = -v;
		    break;
		case 0xa:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = -v;
		}
		if (!mc) {
		    mc = *map++;
		    cb++;
		    v = granule->pow2gain[(*aea++ + *pretab++) << shift];
		}
		mc--;
		hcode >>= 4;
		switch (hcode & 15) {
		case 0x0:
		    max = cb;
		    *yii++ = v;
		    *yii++ = v;
		    break;
		case 0x1:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = v;
		    break;
		case 0x2:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = v;
		    break;
		case 0x4:
		    max = cb;
		    *yii++ = v;
		    *yii++ = 0;
		    break;
		case 0x5:
		    *yii++ = 0;
		    *yii++ = 0;
		    break;
		case 0x6:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = 0;
		    break;
		case 0x8:
		    max = cb;
		    *yii++ = v;
		    *yii++ = -v;
		    break;
		case 0x9:
		    max = cb;
		    *yii++ = 0;
		    *yii++ = -v;
		    break;
		case 0xa:
		    max = cb;
		    *yii++ = -v;
		    *yii++ = -v;
		}
	    }
	}

      x240:
	{
	    unsigned quotient, remainder;

	    quotient = (Mylene1f4_real *) hybrid_in - yii;
	    quotient += 576;
	    remainder = quotient & 7;
	    for (; remainder; remainder--) {
		*yii++ = 0;
	    }
	    quotient >>= 3;
	    for (; quotient; quotient--) {
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
		*yii++ = 0;
	    }
	}

	max++;
	granule->maxbandl = max;
	granule->maxb = table_3_B_8x__0[sampling_frequency][max];
    }

    {
	unsigned quotient;

	quotient = audio_data_size;
	if (quotient < cache_size) {
	    cache_size -= quotient;
	} else {
	    unsigned remainder;

	    quotient -= cache_size;
	    cache_size = 0;
	    remainder = quotient & 7;
	    quotient >>= 3;
	    if (quotient < size) {
		size -= quotient;
		buffer += quotient;
	    } else {
		unsigned this_frame;

		this_frame = *frame;
		quotient -= size;
		size = 0;
		while (quotient) {
		    struct Mylene1f4_frame *frame_data;

		    if (this_frame == audio->last_frame) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    ADVANCE_FRAME(this_frame);
		    frame_data = audio->layer_data.III.frames + this_frame;
		    buffer = frame_data->buffer;
		    size = frame_data->size;
		    if (quotient < size) {
			buffer += quotient;
			size -= quotient;
			quotient = 0;
		    } else {
			quotient -= size;
			size = 0;
		    }
		}
		*frame = this_frame;
	    }
	    if (remainder) {
		if (!size) {
		    optimistique_moi(audio, &buffer, &size, frame);
		}
		cache_buffer = *buffer++;
		cache_size = 8;
		size--;
		cache_size -= remainder;
	    }
	}
    }

    *buffer_in_out = buffer;
    *cache_buffer_in_out = cache_buffer;
    *cache_size_in_out = cache_size;
    *size_in_out = size;
}
