/*
 * e1f4.7.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.3.h>
#include <e1f4.a.h>

void
_Mylene1f4_break_section(struct Mylene1f4_audio *audio, unsigned i)
{
#if 0
    unsigned phase;
#endif				/* 0 */

#if 0
    phase = i / ((96 << 0) << audio->sample_shift);
#endif				/* 0 */

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;

    _Mylene1f4_abort_decoding
	((struct Mylene1f4_whatever *) audio, AUDIO_SHORT_SAMPLES_SECTION);
}


void
_Mylene1f4_class_section(struct Mylene1f4_audio *audio, unsigned i)
{
#if 0
    unsigned phase;
#endif				/* 0 */

#if 0
    phase = i / ((96 << 1) << audio->sample_shift);
#endif				/* 0 */

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;

    _Mylene1f4_abort_decoding
	((struct Mylene1f4_whatever *) audio, AUDIO_SHORT_SAMPLES_SECTION);
}
