/*
 * e1f4.d.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.3.h>

#define COS004_0			((Mylene1f4_real)  .70710678118655)

#define COS010_0			((Mylene1f4_real)  .54119610014620)
#define COS010_1			((Mylene1f4_real) 1.30656296487638)

#define COS020_0			((Mylene1f4_real)  .50979557910416)
#define COS020_1			((Mylene1f4_real)  .60134488693505)
#define COS020_2			((Mylene1f4_real)  .89997622313642)
#define COS020_3			((Mylene1f4_real) 2.56291544774151)

#define COS040_0			((Mylene1f4_real)  .50241928618816)
#define COS040_1			((Mylene1f4_real)  .52249861493969)
#define COS040_2			((Mylene1f4_real)  .56694403481636)
#define COS040_3			((Mylene1f4_real)  .64682178335999)
#define COS040_4			((Mylene1f4_real)  .78815462345125)
#define COS040_5			((Mylene1f4_real) 1.06067768599035)
#define COS040_6			((Mylene1f4_real) 1.72244709823833)
#define COS040_7			((Mylene1f4_real) 5.10114861868916)

#define COS100_0			((Mylene1f4_real)  .50060299823520)
#define COS100_1			((Mylene1f4_real)  .50547095989754)
#define COS100_2			((Mylene1f4_real)  .51544730992262)
#define COS100_3			((Mylene1f4_real)  .53104259108978)
#define COS100_4			((Mylene1f4_real)  .55310389603444)
#define COS100_5			((Mylene1f4_real)  .58293496820613)
#define COS100_6			((Mylene1f4_real)  .62250412303566)
#define COS100_7			((Mylene1f4_real)  .67480834145501)
#define COS100_8			((Mylene1f4_real)  .74453627100230)
#define COS100_9			((Mylene1f4_real)  .83934964541553)
#define COS100_A			((Mylene1f4_real)  .97256823786196)
#define COS100_B			((Mylene1f4_real) 1.16943993343288)
#define COS100_C			((Mylene1f4_real) 1.48416461631417)
#define COS100_D			((Mylene1f4_real) 2.05778100995341)
#define COS100_E			((Mylene1f4_real) 3.40760841846872)
#define COS100_F			((Mylene1f4_real)10.19000812354803)

static void stupid_hack(Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *,
			Mylene1f4_real *, Mylene1f4_real *);

static void
stupid_hack(Mylene1f4_real *out0, Mylene1f4_real *out1, Mylene1f4_real *b1,
	    Mylene1f4_real *b2, Mylene1f4_real *samples)
{
    {
	b1[0x00] = samples[0x00] + samples[0x1f];
	b1[0x1f] = (samples[0x00] - samples[0x1f]) * COS100_0;

	b1[0x01] = samples[0x01] + samples[0x1e];
	b1[0x1e] = (samples[0x01] - samples[0x1e]) * COS100_1;

	b1[0x02] = samples[0x02] + samples[0x1d];
	b1[0x1d] = (samples[0x02] - samples[0x1d]) * COS100_2;

	b1[0x03] = samples[0x03] + samples[0x1c];
	b1[0x1c] = (samples[0x03] - samples[0x1c]) * COS100_3;

	b1[0x04] = samples[0x04] + samples[0x1b];
	b1[0x1b] = (samples[0x04] - samples[0x1b]) * COS100_4;

	b1[0x05] = samples[0x05] + samples[0x1a];
	b1[0x1a] = (samples[0x05] - samples[0x1a]) * COS100_5;

	b1[0x06] = samples[0x06] + samples[0x19];
	b1[0x19] = (samples[0x06] - samples[0x19]) * COS100_6;

	b1[0x07] = samples[0x07] + samples[0x18];
	b1[0x18] = (samples[0x07] - samples[0x18]) * COS100_7;

	b1[0x08] = samples[0x08] + samples[0x17];
	b1[0x17] = (samples[0x08] - samples[0x17]) * COS100_8;

	b1[0x09] = samples[0x09] + samples[0x16];
	b1[0x16] = (samples[0x09] - samples[0x16]) * COS100_9;

	b1[0x0a] = samples[0x0a] + samples[0x15];
	b1[0x15] = (samples[0x0a] - samples[0x15]) * COS100_A;

	b1[0x0b] = samples[0x0b] + samples[0x14];
	b1[0x14] = (samples[0x0b] - samples[0x14]) * COS100_B;

	b1[0x0c] = samples[0x0c] + samples[0x13];
	b1[0x13] = (samples[0x0c] - samples[0x13]) * COS100_C;

	b1[0x0d] = samples[0x0d] + samples[0x12];
	b1[0x12] = (samples[0x0d] - samples[0x12]) * COS100_D;

	b1[0x0e] = samples[0x0e] + samples[0x11];
	b1[0x11] = (samples[0x0e] - samples[0x11]) * COS100_E;

	b1[0x0f] = samples[0x0f] + samples[0x10];
	b1[0x10] = (samples[0x0f] - samples[0x10]) * COS100_F;
    }
    {
	b2[0x00] = b1[0x00] + b1[0x0f];
	b2[0x0f] = (b1[0x00] - b1[0x0f]) * COS040_0;
	b2[0x01] = b1[0x01] + b1[0x0e];
	b2[0x0e] = (b1[0x01] - b1[0x0e]) * COS040_1;
	b2[0x02] = b1[0x02] + b1[0x0d];
	b2[0x0d] = (b1[0x02] - b1[0x0d]) * COS040_2;
	b2[0x03] = b1[0x03] + b1[0x0c];
	b2[0x0c] = (b1[0x03] - b1[0x0c]) * COS040_3;
	b2[0x04] = b1[0x04] + b1[0x0b];
	b2[0x0b] = (b1[0x04] - b1[0x0b]) * COS040_4;
	b2[0x05] = b1[0x05] + b1[0x0a];
	b2[0x0a] = (b1[0x05] - b1[0x0a]) * COS040_5;
	b2[0x06] = b1[0x06] + b1[0x09];
	b2[0x09] = (b1[0x06] - b1[0x09]) * COS040_6;
	b2[0x07] = b1[0x07] + b1[0x08];
	b2[0x08] = (b1[0x07] - b1[0x08]) * COS040_7;

	b2[0x10] = b1[0x10] + b1[0x1f];
	b2[0x1f] = (b1[0x1f] - b1[0x10]) * COS040_0;
	b2[0x11] = b1[0x11] + b1[0x1e];
	b2[0x1e] = (b1[0x1e] - b1[0x11]) * COS040_1;
	b2[0x12] = b1[0x12] + b1[0x1d];
	b2[0x1d] = (b1[0x1d] - b1[0x12]) * COS040_2;
	b2[0x13] = b1[0x13] + b1[0x1c];
	b2[0x1c] = (b1[0x1c] - b1[0x13]) * COS040_3;
	b2[0x14] = b1[0x14] + b1[0x1b];
	b2[0x1b] = (b1[0x1b] - b1[0x14]) * COS040_4;
	b2[0x15] = b1[0x15] + b1[0x1a];
	b2[0x1a] = (b1[0x1a] - b1[0x15]) * COS040_5;
	b2[0x16] = b1[0x16] + b1[0x19];
	b2[0x19] = (b1[0x19] - b1[0x16]) * COS040_6;
	b2[0x17] = b1[0x17] + b1[0x18];
	b2[0x18] = (b1[0x18] - b1[0x17]) * COS040_7;
    }
    {
	b1[0x00] = b2[0x00] + b2[0x07];
	b1[0x07] = (b2[0x00] - b2[0x07]) * COS020_0;
	b1[0x01] = b2[0x01] + b2[0x06];
	b1[0x06] = (b2[0x01] - b2[0x06]) * COS020_1;
	b1[0x02] = b2[0x02] + b2[0x05];
	b1[0x05] = (b2[0x02] - b2[0x05]) * COS020_2;
	b1[0x03] = b2[0x03] + b2[0x04];
	b1[0x04] = (b2[0x03] - b2[0x04]) * COS020_3;

	b1[0x08] = b2[0x08] + b2[0x0f];
	b1[0x0f] = (b2[0x0f] - b2[0x08]) * COS020_0;
	b1[0x09] = b2[0x09] + b2[0x0e];
	b1[0x0e] = (b2[0x0e] - b2[0x09]) * COS020_1;
	b1[0x0a] = b2[0x0a] + b2[0x0d];
	b1[0x0d] = (b2[0x0d] - b2[0x0a]) * COS020_2;
	b1[0x0b] = b2[0x0b] + b2[0x0c];
	b1[0x0c] = (b2[0x0c] - b2[0x0b]) * COS020_3;

	b1[0x10] = b2[0x10] + b2[0x17];
	b1[0x17] = (b2[0x10] - b2[0x17]) * COS020_0;
	b1[0x11] = b2[0x11] + b2[0x16];
	b1[0x16] = (b2[0x11] - b2[0x16]) * COS020_1;
	b1[0x12] = b2[0x12] + b2[0x15];
	b1[0x15] = (b2[0x12] - b2[0x15]) * COS020_2;
	b1[0x13] = b2[0x13] + b2[0x14];
	b1[0x14] = (b2[0x13] - b2[0x14]) * COS020_3;

	b1[0x18] = b2[0x18] + b2[0x1f];
	b1[0x1f] = (b2[0x1f] - b2[0x18]) * COS020_0;
	b1[0x19] = b2[0x19] + b2[0x1e];
	b1[0x1e] = (b2[0x1e] - b2[0x19]) * COS020_1;
	b1[0x1a] = b2[0x1a] + b2[0x1d];
	b1[0x1d] = (b2[0x1d] - b2[0x1a]) * COS020_2;
	b1[0x1b] = b2[0x1b] + b2[0x1c];
	b1[0x1c] = (b2[0x1c] - b2[0x1b]) * COS020_3;
    }
    {
	const register Mylene1f4_real cos0 = COS010_0, cos1 = COS010_1;

	b2[0x00] = b1[0x00] + b1[0x03];
	b2[0x03] = (b1[0x00] - b1[0x03]) * cos0;
	b2[0x01] = b1[0x01] + b1[0x02];
	b2[0x02] = (b1[0x01] - b1[0x02]) * cos1;

	b2[0x04] = b1[0x04] + b1[0x07];
	b2[0x07] = (b1[0x07] - b1[0x04]) * cos0;
	b2[0x05] = b1[0x05] + b1[0x06];
	b2[0x06] = (b1[0x06] - b1[0x05]) * cos1;

	b2[0x08] = b1[0x08] + b1[0x0b];
	b2[0x0b] = (b1[0x08] - b1[0x0b]) * cos0;
	b2[0x09] = b1[0x09] + b1[0x0a];
	b2[0x0a] = (b1[0x09] - b1[0x0a]) * cos1;

	b2[0x0c] = b1[0x0c] + b1[0x0f];
	b2[0x0f] = (b1[0x0f] - b1[0x0c]) * cos0;
	b2[0x0d] = b1[0x0d] + b1[0x0e];
	b2[0x0e] = (b1[0x0e] - b1[0x0d]) * cos1;

	b2[0x10] = b1[0x10] + b1[0x13];
	b2[0x13] = (b1[0x10] - b1[0x13]) * cos0;
	b2[0x11] = b1[0x11] + b1[0x12];
	b2[0x12] = (b1[0x11] - b1[0x12]) * cos1;

	b2[0x14] = b1[0x14] + b1[0x17];
	b2[0x17] = (b1[0x17] - b1[0x14]) * cos0;
	b2[0x15] = b1[0x15] + b1[0x16];
	b2[0x16] = (b1[0x16] - b1[0x15]) * cos1;

	b2[0x18] = b1[0x18] + b1[0x1b];
	b2[0x1b] = (b1[0x18] - b1[0x1b]) * cos0;
	b2[0x19] = b1[0x19] + b1[0x1a];
	b2[0x1a] = (b1[0x19] - b1[0x1a]) * cos1;

	b2[0x1c] = b1[0x1c] + b1[0x1f];
	b2[0x1f] = (b1[0x1f] - b1[0x1c]) * cos0;
	b2[0x1d] = b1[0x1d] + b1[0x1e];
	b2[0x1e] = (b1[0x1e] - b1[0x1d]) * cos1;
    }
    {
	const register Mylene1f4_real cos0 = COS004_0;

	b1[0x00] = b2[0x00] + b2[0x01];
	b1[0x01] = (b2[0x00] - b2[0x01]) * cos0;
	b1[0x02] = b2[0x02] + b2[0x03];
	b1[0x03] = (b2[0x03] - b2[0x02]) * cos0;
	b1[0x02] += b1[0x03];

	b1[0x04] = b2[0x04] + b2[0x05];
	b1[0x05] = (b2[0x04] - b2[0x05]) * cos0;
	b1[0x06] = b2[0x06] + b2[0x07];
	b1[0x07] = (b2[0x07] - b2[0x06]) * cos0;
	b1[0x06] += b1[0x07];
	b1[0x04] += b1[0x06];
	b1[0x06] += b1[0x05];
	b1[0x05] += b1[0x07];

	b1[0x08] = b2[0x08] + b2[0x09];
	b1[0x09] = (b2[0x08] - b2[0x09]) * cos0;
	b1[0x0a] = b2[0x0a] + b2[0x0b];
	b1[0x0b] = (b2[0x0b] - b2[0x0a]) * cos0;
	b1[0x0a] += b1[0x0b];

	b1[0x0c] = b2[0x0c] + b2[0x0d];
	b1[0x0d] = (b2[0x0c] - b2[0x0d]) * cos0;
	b1[0x0e] = b2[0x0e] + b2[0x0f];
	b1[0x0f] = (b2[0x0f] - b2[0x0e]) * cos0;
	b1[0x0e] += b1[0x0f];
	b1[0x0c] += b1[0x0e];
	b1[0x0e] += b1[0x0d];
	b1[0x0d] += b1[0x0f];

	b1[0x10] = b2[0x10] + b2[0x11];
	b1[0x11] = (b2[0x10] - b2[0x11]) * cos0;
	b1[0x12] = b2[0x12] + b2[0x13];
	b1[0x13] = (b2[0x13] - b2[0x12]) * cos0;
	b1[0x12] += b1[0x13];

	b1[0x14] = b2[0x14] + b2[0x15];
	b1[0x15] = (b2[0x14] - b2[0x15]) * cos0;
	b1[0x16] = b2[0x16] + b2[0x17];
	b1[0x17] = (b2[0x17] - b2[0x16]) * cos0;
	b1[0x16] += b1[0x17];
	b1[0x14] += b1[0x16];
	b1[0x16] += b1[0x15];
	b1[0x15] += b1[0x17];

	b1[0x18] = b2[0x18] + b2[0x19];
	b1[0x19] = (b2[0x18] - b2[0x19]) * cos0;
	b1[0x1a] = b2[0x1a] + b2[0x1b];
	b1[0x1b] = (b2[0x1b] - b2[0x1a]) * cos0;
	b1[0x1a] += b1[0x1b];

	b1[0x1c] = b2[0x1c] + b2[0x1d];
	b1[0x1d] = (b2[0x1c] - b2[0x1d]) * cos0;
	b1[0x1e] = b2[0x1e] + b2[0x1f];
	b1[0x1f] = (b2[0x1f] - b2[0x1e]) * cos0;
	b1[0x1e] += b1[0x1f];
	b1[0x1c] += b1[0x1e];
	b1[0x1e] += b1[0x1d];
	b1[0x1d] += b1[0x1f];
    }

    out0[0x100] = b1[0x00];
    out0[0x0c0] = b1[0x04];
    out0[0x080] = b1[0x02];
    out0[0x040] = b1[0x06];
    out0[0x000] = b1[0x01];
    out1[0x000] = b1[0x01];
    out1[0x040] = b1[0x05];
    out1[0x080] = b1[0x03];
    out1[0x0c0] = b1[0x07];

    b1[0x08] += b1[0x0c];
    out0[0x0e0] = b1[0x08];
    b1[0x0c] += b1[0x0a];
    out0[0x0a0] = b1[0x0c];
    b1[0x0a] += b1[0x0e];
    out0[0x060] = b1[0x0a];
    b1[0x0e] += b1[0x09];
    out0[0x020] = b1[0x0e];
    b1[0x09] += b1[0x0d];
    out1[0x020] = b1[0x09];
    b1[0x0d] += b1[0x0b];
    out1[0x060] = b1[0x0d];
    b1[0x0b] += b1[0x0f];
    out1[0x0a0] = b1[0x0b];
    out1[0x0e0] = b1[0x0f];

    b1[0x18] += b1[0x1c];
    out0[0x0f0] = b1[0x10] + b1[0x18];
    out0[0x0d0] = b1[0x18] + b1[0x14];
    b1[0x1c] += b1[0x1a];
    out0[0x0b0] = b1[0x14] + b1[0x1c];
    out0[0x090] = b1[0x1c] + b1[0x12];
    b1[0x1a] += b1[0x1e];
    out0[0x070] = b1[0x12] + b1[0x1a];
    out0[0x050] = b1[0x1a] + b1[0x16];
    b1[0x1e] += b1[0x19];
    out0[0x030] = b1[0x16] + b1[0x1e];
    out0[0x010] = b1[0x1e] + b1[0x11];
    b1[0x19] += b1[0x1d];
    out1[0x010] = b1[0x11] + b1[0x19];
    out1[0x030] = b1[0x19] + b1[0x15];
    b1[0x1d] += b1[0x1b];
    out1[0x050] = b1[0x15] + b1[0x1d];
    out1[0x070] = b1[0x1d] + b1[0x13];
    b1[0x1b] += b1[0x1f];
    out1[0x090] = b1[0x13] + b1[0x1b];
    out1[0x0b0] = b1[0x1b] + b1[0x17];
    out1[0x0d0] = b1[0x17] + b1[0x1f];
    out1[0x0f0] = b1[0x1f];
}


void
Mylene1f4_dct64_1(Mylene1f4_real *a, Mylene1f4_real *b, Mylene1f4_real *c)
{
    Mylene1f4_real bufs[0x40];

    stupid_hack(a, b, bufs, bufs + 0x20, c);
}
