/*
 * e1f4.f.11172.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.2.h>
#include <e1f4.3.h>

#define SET_DATA__1___5___9___d___0(audio, process) \
    {									      \
	audio->audio_data[0x1] = process##_audio_data_III[0x0];		      \
	audio->audio_data[0x5] = process##_audio_data_III[0x1];		      \
	audio->audio_data[0x9] = process##_audio_data_III[0x2];		      \
	audio->audio_data[0xd] = process##_audio_data_III[0x3];		      \
    }

#define SET_DATA__1___5___9___d___1(audio, process) \
    {									      \
	audio->audio_data[0x1] = process##_audio_data_III[0x4];		      \
	audio->audio_data[0x5] = process##_audio_data_III[0x4];		      \
	audio->audio_data[0x9] = process##_audio_data_III[0x4];		      \
	audio->audio_data[0xd] = process##_audio_data_III[0x4];		      \
    }

extern void
 (*_Mylene1f4_4294967279_audio_data_III[]) (struct Mylene1f4_audio *),
    (*_Mylene1f4_4294967291_audio_data_III[]) (struct Mylene1f4_audio *);

void
_Mylene1f4_set_11172_audio_attributes(struct Mylene1f4_audio *audio)
{
    if (audio->audio_data[4] == (void (*)(struct Mylene1f4_audio *)) ID_mask) {
    } else {
	audio->audio_data[4] = (void (*)(struct Mylene1f4_audio *)) ID_mask;
	if (audio->audio_data[0x1]
	    == _Mylene1f4_4294967279_audio_data_III[0x0]) {
	    SET_DATA__1___5___9___d___0(audio, _Mylene1f4_4294967291);
	} else if (audio->audio_data[0x1]
		   == _Mylene1f4_4294967279_audio_data_III[0x4]) {
	    SET_DATA__1___5___9___d___1(audio, _Mylene1f4_4294967291);
	}
    }
}
