/*
 * h262.5.h
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_5_H__
#define __SEEK_H262_5_H__

#include <h262.0.h>

#if __DISPATCH_RESET__
# define RESET_ONE(coefficients)

# define RESET_SIXTY_THREE(coefficients)
#elif __SHORT_ENDED_ARITHMETIC__
# define RESET_ONE(coefficients) \
    {									      \
	*coefficients = 0;						      \
    }

# define RESET_SIXTY_THREE(coefficients) \
    {									      \
	unsigned *bull;							      \
									      \
	coefficients[1] = 0;						      \
	bull = (unsigned *) coefficients + 1;				      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
    }
#else
# define RESET_ONE(coefficients) \
    {									      \
	*coefficients = 0;						      \
    }

# define RESET_SIXTY_THREE(coefficients) \
    {									      \
	unsigned *bull;							      \
									      \
	bull = (unsigned *) coefficients + 1;				      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
	*bull++ = 0;							      \
    }
#endif				/* __DISPATCH_RESET__ */

#endif				/* __SEEK_H262_5_H__ */
