/*
 * h262.8.d4.h
 * Copyright (C) 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_8_D4_H__
#define __SEEK_H262_8_D4_H__

#define MAJOR_WIDE_REFERENCE_1_1(reference, line_size) \
    {									      \
	reference_0 = *(unsigned long *) (reference);			      \
    }

#define MINOR_WIDE_REFERENCE_1_1(reference, line_size) \
    {									      \
    }

#define WIDE_REFERENCE_1_1_0() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_X() \
    reference_0

#define WIDE_REFERENCE_1_1_decls \
    unsigned long reference_0

#define MAJOR_WIDE_REFERENCE_1_2(reference, line_size) \
    {									      \
	reference_0 = *(unsigned long *) (reference);			      \
	reference_1 = *(unsigned long *) ((reference) + (line_size));	      \
    }

#define MINOR_WIDE_REFERENCE_1_2(reference, line_size) \
    {									      \
    }

#define WIDE_REFERENCE_1_2_0() \
    {									      \
    }

#define WIDE_REFERENCE_1_2_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_2_X() \
    ((reference_0 | reference_1)					      \
     - (((reference_0 ^ reference_1) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_2_decls \
    unsigned long reference_0, reference_1

#define MAJOR_WIDE_REFERENCE_2_1(reference, line_size) \
    {									      \
	reference_0 = *(unsigned long *) (reference);			      \
    }

#define MINOR_WIDE_REFERENCE_2_1(reference, line_size) \
    {									      \
	reference_1 = *(unsigned long *) ((reference) + 1);		      \
    }

#define WIDE_REFERENCE_2_1_0() \
    {									      \
    }

#define WIDE_REFERENCE_2_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_2_1_X() \
    ((reference_0 | reference_1)					      \
     - (((reference_0 ^ reference_1) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_2_1_decls \
    unsigned long reference_0, reference_1

#define MAJOR_WIDE_REFERENCE_2_2(reference, line_size) \
    {									      \
	reference_0_2__0 = *(unsigned long *) (reference);		      \
	reference_0_2__1 = *(unsigned long *) ((reference) + (line_size));    \
	reference__1_3__ =						      \
	    ((((reference_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0002000200020002;					      \
    }

#define MINOR_WIDE_REFERENCE_2_2(reference, line_size) \
    {									      \
	reference_0_2__0 = *(unsigned long *) ((reference) + 1);	      \
	reference_0_2__1 =						      \
	    *(unsigned long *) ((reference) + (line_size) + 1);		      \
    }

#define WIDE_REFERENCE_2_2_0() \
    {									      \
	reference_0_2_ =						      \
	    (((reference_0_2__0 & 0x00ff00ff00ff00ff)			      \
	      + (reference_0_2__1 & 0x00ff00ff00ff00ff)			      \
	      + reference__1_3__) >> 2);				      \
    }

#define WIDE_REFERENCE_2_2_1() \
    {									      \
	reference__1_3 =						      \
	    (((reference_0_2__0 & 0xff00ff00ff00ff00) >> 2)		      \
	     + ((reference_0_2__1 & 0xff00ff00ff00ff00) >> 2)		      \
	     + (reference__1_3__ << 6));				      \
    }

#define WIDE_REFERENCE_2_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_2_decls \
    unsigned long reference_0_2_, reference_0_2__0, reference_0_2__1,	      \
	reference__1_3, reference__1_3__

#define MAJOR_WIDE_REFERENCE_1_1_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
    }

#define MINOR_WIDE_REFERENCE_1_1_1_1(reference_0, reference_1, line_size) \
    {									      \
    }

#define WIDE_REFERENCE_1_1_1_1_0() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_1_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_1_1_X() \
    ((reference_0_0 | reference_1_0)					      \
     - (((reference_0_0 ^ reference_1_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_1_1_1_decls \
    unsigned long reference_0_0, reference_1_0

#define MAJOR_WIDE_REFERENCE_1_1_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + (line_size));     \
    }

#define MINOR_WIDE_REFERENCE_1_1_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_x_0 = *(unsigned long *) (reference_0);		      \
    }

#define WIDE_REFERENCE_1_1_1_2_0() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_1_1_2_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_1_2_X() \
    ((reference_1_0 | reference_x_0)					      \
     - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_1_1_2_decls \
    unsigned long reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_1_1_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + 1);		      \
    }

#define MINOR_WIDE_REFERENCE_1_1_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_x_0 = *(unsigned long *) (reference_0);		      \
    }

#define WIDE_REFERENCE_1_1_2_1_0() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_1_2_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_1_2_1_X() \
    ((reference_1_0 | reference_x_0)					      \
     - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_1_2_1_decls \
    unsigned long reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_1_1_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2_ = *(unsigned long *) (reference_0);		      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size));		      \
	reference_1__1_3__ =						      \
	    ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
    }

#define MINOR_WIDE_REFERENCE_1_1_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0_2__0 = *(unsigned long *) ((reference_1) + 1);	      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_1_1_2_2_0() \
    {									      \
	reference_0_2_ =						      \
	    ((reference_0_0_2_ & 0x00ff00ff00ff00ff)			      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + (reference_1_0_2__1 & 0x00ff00ff00ff00ff)		      \
		  + reference_1__1_3__)					      \
		 >> 2) & 0x01ff01ff01ff01ff)) >> 1;			      \
    }

#define WIDE_REFERENCE_1_1_2_2_1() \
    {									      \
	reference__1_3 =						      \
	    (((reference_0_0_2_ & 0xff00ff00ff00ff00) >> 1)		      \
	     + ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 3)	      \
		 + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
		 + (reference_1__1_3__ << 5)) & 0xff80ff80ff80ff80));	      \
    }

#define WIDE_REFERENCE_1_1_2_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_1_1_2_2_decls \
    unsigned long reference_0_0_2_, reference_0_2_, reference_1_0_2__0,	      \
	reference_1_0_2__1, reference_1__1_3__, reference__1_3

#define MAJOR_WIDE_REFERENCE_1_2_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + (line_size));     \
    }

#define MINOR_WIDE_REFERENCE_1_2_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_x_0 = *(unsigned long *) (reference_1);		      \
    }

#define WIDE_REFERENCE_1_2_1_1_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_2_1_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_1_2_1_1_X() \
    ((reference_0_0 | reference_x_0)					      \
     - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_2_1_1_decls \
    unsigned long reference_0_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_1_2_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + (line_size));     \
    }

#define MINOR_WIDE_REFERENCE_1_2_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + (line_size));     \
    }

#define WIDE_REFERENCE_1_2_1_2_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_2_1_2_1() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_2_1_2_X() \
    ((reference_0_0 | reference_1_0)					      \
     - (((reference_0_0 ^ reference_1_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_2_1_2_decls \
    unsigned long reference_0_0, reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_1_2_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + (line_size));     \
    }

#define MINOR_WIDE_REFERENCE_1_2_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + 1);		      \
    }

#define WIDE_REFERENCE_1_2_2_1_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_2_2_1_1() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_1_2_2_1_X() \
    ((reference_0_0 | reference_1_0)					      \
     - (((reference_0_0 ^ reference_1_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_1_2_2_1_decls \
    unsigned long reference_0_0, reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_1_2_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size));		      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size));		      \
	reference_1__1_3__ =						      \
	    ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
    }

#define MINOR_WIDE_REFERENCE_1_2_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0_2__0 = *(unsigned long *) ((reference_1) + 1);	      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_1_2_2_2_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
	        + (reference_0_0_2__1 & 0x00ff00ff00ff00ff)		      \
		+ 0x0001000100010001) >> 0) & 0x01fe01fe01fe01fe)	      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + (reference_1_0_2__1 & 0x00ff00ff00ff00ff)		      \
		  + reference_1__1_3__) >> 1) & 0x03fe03fe03fe03fe)) >> 2;    \
    }

#define WIDE_REFERENCE_1_2_2_2_1() \
    {									      \
	reference__1_3 =						      \
	    ((((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 2)	      \
	        + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 2)	      \
		+ 0x0040004000400040)) & 0x7f807f807f807f80)		      \
	     + ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 3)	      \
		 + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
		 + (reference_1__1_3__ << 5)) & 0xff80ff80ff80ff80));	      \
    }

#define WIDE_REFERENCE_1_2_2_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_1_2_2_2_decls \
    unsigned long reference_0_0_2__0, reference_0_0_2__1, reference_0_2_,     \
	reference_1_0_2__0, reference_1_0_2__1, reference_1__1_3__,	      \
	reference__1_3

#define MAJOR_WIDE_REFERENCE_2_1_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + 1);		      \
    }

#define MINOR_WIDE_REFERENCE_2_1_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_x_0 = *(unsigned long *) (reference_1);		      \
    }

#define WIDE_REFERENCE_2_1_1_1_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_2_1_1_1_1() \
    {									      \
    }

#define WIDE_REFERENCE_2_1_1_1_X() \
    ((reference_0_0 | reference_x_0)					      \
     - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_2_1_1_1_decls \
    unsigned long reference_0_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_2_1_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + 1);		      \
    }

#define MINOR_WIDE_REFERENCE_2_1_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + (line_size));     \
    }

#define WIDE_REFERENCE_2_1_1_2_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_2_1_1_2_1() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_2_1_1_2_X() \
    ((reference_0_0 | reference_1_0)					      \
     - (((reference_0_0 ^ reference_1_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_2_1_1_2_decls \
    unsigned long reference_0_0, reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_2_1_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0 = *(unsigned long *) (reference_0);		      \
	reference_x_0 = *(unsigned long *) ((reference_0) + 1);		      \
    }

#define MINOR_WIDE_REFERENCE_2_1_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_1_0 = *(unsigned long *) (reference_1);		      \
	reference_x_0 = *(unsigned long *) ((reference_1) + 1);		      \
    }

#define WIDE_REFERENCE_2_1_2_1_0() \
    {									      \
	reference_0_0 = ((reference_0_0 | reference_x_0)		      \
	    - (((reference_0_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_2_1_2_1_1() \
    {									      \
	reference_1_0 = ((reference_1_0 | reference_x_0)		      \
	    - (((reference_1_0 ^ reference_x_0) & 0xfefefefefefefefe) >> 1)); \
    }

#define WIDE_REFERENCE_2_1_2_1_X() \
    ((reference_0_0 | reference_1_0)					      \
     - (((reference_0_0 ^ reference_1_0) & 0xfefefefefefefefe) >> 1))

#define WIDE_REFERENCE_2_1_2_1_decls \
    unsigned long reference_0_0, reference_1_0, reference_x_0

#define MAJOR_WIDE_REFERENCE_2_1_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0__1_3__ =						      \
	    (((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 8) >> 0)	      \
	    + 0x0001000100010001;					      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size));		      \
	reference_1__1_3__ =						      \
	    ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	      + 0x0006000600060006;					      \
    }

#define MINOR_WIDE_REFERENCE_2_1_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) ((reference_0) + 1);	      \
	reference_1_0_2__0 = *(unsigned long *) ((reference_1) + 1);	      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_2_1_2_2_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
		+ reference_0__1_3__) >> 0) & 0x01fe01fe01fe01fe)	      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + (reference_1_0_2__1 & 0x00ff00ff00ff00ff)		      \
		  + reference_1__1_3__) >> 1) & 0x03fe03fe03fe03fe)) >> 2;    \
    }

#define WIDE_REFERENCE_2_1_2_2_1() \
    {									      \
	reference__1_3 =						      \
	    (((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 2)		      \
	       + (reference_0__1_3__ << 6)) & 0x7f807f807f807f80)	      \
	     + ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 3)	      \
		 + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
		 + (reference_1__1_3__ << 5)) & 0xff80ff80ff80ff80));	      \
    }

#define WIDE_REFERENCE_2_1_2_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_1_2_2_decls \
    unsigned long reference_0_0_2__0, reference_0_2_, reference_0__1_3__,     \
	reference_1_0_2__0, reference_1_0_2__1, reference_1__1_3__,	      \
	reference__1_3

#define MAJOR_WIDE_REFERENCE_2_2_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size));		      \
	reference_0__1_3__ =						      \
	    ((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
	reference_1_0_2_ = *(unsigned long *) (reference_1);		      \
    }

#define MINOR_WIDE_REFERENCE_2_2_1_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) ((reference_0) + 1);	      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_2_2_1_1_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
	        + (reference_0_0_2__1 & 0x00ff00ff00ff00ff)		      \
		+ reference_0__1_3__) >> 2) & 0x01ff01ff01ff01ff)	      \
	     + (reference_1_0_2_ & 0x00ff00ff00ff00ff)) >> 1;		      \
    }

#define WIDE_REFERENCE_2_2_1_1_1() \
    {									      \
	reference__1_3 =						      \
	    (((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 3)		      \
	       + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
	       + (reference_0__1_3__ << 5)) & 0xff80ff80ff80ff80))	      \
	     + ((reference_1_0_2_ & 0xff00ff00ff00ff00) >> 1);		      \
    }

#define WIDE_REFERENCE_2_2_1_1_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_2_1_1_decls \
    unsigned long reference_0_0_2__0, reference_0_0_2__1, reference_0_2_,      \
	reference_0__1_3__, reference_1_0_2_, reference__1_3

#define MAJOR_WIDE_REFERENCE_2_2_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size));		      \
	reference_0__1_3__ =						      \
	    ((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size));		      \
    }

#define MINOR_WIDE_REFERENCE_2_2_1_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) ((reference_0) + 1);	      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_2_2_1_2_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
	        + (reference_0_0_2__1 & 0x00ff00ff00ff00ff)		      \
		+ reference_0__1_3__) >> 1) & 0x03fe03fe03fe03fe)	      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + (reference_1_0_2__1 & 0x00ff00ff00ff00ff)		      \
		  + 0x0001000100010001) >> 0) & 0x01fe01fe01fe01fe)) >> 2;    \
    }

#define WIDE_REFERENCE_2_2_1_2_1() \
    {									      \
	reference__1_3 =						      \
	    (((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 3)		      \
	       + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
	       + (reference_0__1_3__ << 5)) & 0xff80ff80ff80ff80)	      \
	     + (((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 2)	      \
	          + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 2)	      \
		  + 0x0040004000400040)) & 0x7f807f807f807f80));	      \
    }

#define WIDE_REFERENCE_2_2_1_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_2_1_2_decls \
    unsigned long reference_0_0_2__0, reference_0_0_2__1, reference_0_2_, \
	reference_0__1_3__, reference_1_0_2__0, reference_1_0_2__1,	      \
	reference__1_3

#define MAJOR_WIDE_REFERENCE_2_2_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size));		      \
	reference_0__1_3__ =						      \
	    ((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1__1_3__ =						      \
	    (((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 8) >> 0)	      \
	    + 0x0001000100010001;					      \
    }

#define MINOR_WIDE_REFERENCE_2_2_2_1(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) ((reference_0) + 1);	      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size) + 1);	      \
	reference_1_0_2__0 = *(unsigned long *) ((reference_1) + 1);	      \
    }

#define WIDE_REFERENCE_2_2_2_1_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
	        + (reference_0_0_2__1 & 0x00ff00ff00ff00ff)		      \
		+ reference_0__1_3__) >> 1) & 0x03fe03fe03fe03fe)	      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + reference_1__1_3__) >> 0) & 0x01fe01fe01fe01fe)) >> 2;    \
    }

#define WIDE_REFERENCE_2_2_2_1_1() \
    {									      \
	reference__1_3 =						      \
	    (((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 3)		      \
	       + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
	       + (reference_0__1_3__ << 5)) & 0xff80ff80ff80ff80)	      \
	    + ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 2)	      \
	        + (reference_1__1_3__ << 6)) & 0x7f807f807f807f80));	      \
    }

#define WIDE_REFERENCE_2_2_2_1_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_2_2_1_decls \
    unsigned long reference_0_0_2__0, reference_0_0_2__1, reference_0_2_, \
	reference_0__1_3__, reference_1_0_2__0, reference_1__1_3__,	      \
	reference__1_3

#define MAJOR_WIDE_REFERENCE_2_2_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) (reference_0);		      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size));		      \
	reference_0__1_3__ =						      \
	    ((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0002000200020002;					      \
	reference_1_0_2__0 = *(unsigned long *) (reference_1);		      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size));		      \
	reference_1__1_3__ =						      \
	    ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 8)		      \
	      + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 8)) >> 0)	      \
	    + 0x0006000600060006;					      \
    }

#define MINOR_WIDE_REFERENCE_2_2_2_2(reference_0, reference_1, line_size) \
    {									      \
	reference_0_0_2__0 = *(unsigned long *) ((reference_0) + 1);	      \
	reference_0_0_2__1 =						      \
	    *(unsigned long *) ((reference_0) + (line_size) + 1);	      \
	reference_1_0_2__0 = *(unsigned long *) ((reference_1) + 1);	      \
	reference_1_0_2__1 =						      \
	    *(unsigned long *) ((reference_1) + (line_size) + 1);	      \
    }

#define WIDE_REFERENCE_2_2_2_2_0() \
    {									      \
	reference_0_2_ =						      \
	    (((((reference_0_0_2__0 & 0x00ff00ff00ff00ff)		      \
	        + (reference_0_0_2__1 & 0x00ff00ff00ff00ff)		      \
		+ reference_0__1_3__) >> 0) & 0x03fc03fc03fc03fc)	      \
	     + ((((reference_1_0_2__0 & 0x00ff00ff00ff00ff)		      \
		  + (reference_1_0_2__1 & 0x00ff00ff00ff00ff)		      \
		  + reference_1__1_3__) >> 0) & 0x07fc07fc07fc07fc)) >> 3;    \
    }

#define WIDE_REFERENCE_2_2_2_2_1() \
    {									      \
	reference__1_3 =						      \
	    ((((reference_0_0_2__0 & 0xff00ff00ff00ff00) >> 3)		      \
	      + ((reference_0_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
	      + (reference_0__1_3__ << 5)) & 0x7f807f807f807f80)	      \
	     + ((((reference_1_0_2__0 & 0xff00ff00ff00ff00) >> 3)	      \
		 + ((reference_1_0_2__1 & 0xff00ff00ff00ff00) >> 3)	      \
		 + (reference_1__1_3__ << 5)) & 0xff80ff80ff80ff80);	      \
    }

#define WIDE_REFERENCE_2_2_2_2_X() \
    ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3)

#define WIDE_REFERENCE_2_2_2_2_decls \
    unsigned long reference_0_0_2__0, reference_0_0_2__1, reference_0_2_, \
	reference_0__1_3__, reference_1_0_2__0, reference_1_0_2__1,	      \
	reference_1__1_3__, reference__1_3

#define ADD_WIDE_REFERENCES(reference_0_2_, reference__1_3) \
    ((reference_0_2_ & 0x00ff00ff00ff00ff)				      \
     | (reference__1_3 & 0xff00ff00ff00ff00))

#endif				/* __SEEK_H262_8_D4_H__ */
