/*
 * h262.8.h
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_8_H__
#define __SEEK_H262_8_H__

#include <h262.0.h>
#include <h262.7.h>

#define block_0__x_0(predictions, references, stride, line_size, REFERENCE) \
    {									      \
	unsigned i = 16;						      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ = REFERENCE##_0(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions = REFERENCE##_3(references, line_size);	      \
	    predictions += stride - 15;					      \
	    references += stride - 15;					      \
	}								      \
    }

#define block_0__x_1(predictions, references, stride, line_size, REFERENCE) \
    {									      \
	unsigned i = 8;							      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ = REFERENCE##_0(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions = REFERENCE##_3(references, line_size);	      \
	    predictions += stride - 15;					      \
	    references += stride - 15;					      \
	}								      \
    }

#define block_0__x_2(predictions, references, stride, line_size, REFERENCE) \
    {									      \
	unsigned i = 16;							      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ = REFERENCE##_0(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions = REFERENCE##_3(references, line_size);	      \
	    predictions += stride - 7;					      \
	    references += stride - 7;					      \
	}								      \
    }

#define block_0__x_3(predictions, references, stride, line_size, REFERENCE) \
    {									      \
	unsigned i = 8;							      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ = REFERENCE##_0(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions++ = REFERENCE##_1(references, line_size);	      \
	    *predictions++ = REFERENCE##_2(references, line_size);	      \
	    *predictions = REFERENCE##_3(references, line_size);	      \
	    predictions += stride - 7;					      \
	    references += stride - 7;					      \
	}								      \
    }

#if __Berkeley_FUCK_UP__
# define Berkeley_block_x(predictions, references, stride, line_size, \
			  SELECTOR)					      \
    {									      \
	unsigned Berkeley_line_size;					      \
									      \
	Berkeley_line_size = line_size + 1;				      \
	block_0__x_##SELECTOR						      \
	    (predictions, references, stride, Berkeley_line_size,	      \
	     Berkeley_REFERENCE);					      \
    }

# define Berkeley_block_0(predictions, references, stride, line_size) \
    Berkeley_block_x(predictions, references, stride, line_size, 0)

# define Berkeley_block_1(predictions, references, stride, line_size) \
    Berkeley_block_x(predictions, references, stride, line_size, 1)

# define Berkeley_block_2(predictions, references, stride, line_size) \
    Berkeley_block_x(predictions, references, line_size, stride, 2)

# define Berkeley_block_3(predictions, references, stride, line_size) \
    Berkeley_block_x(predictions, references, line_size, stride, 3)
#endif				/* __Berkeley_FUCK_UP__ */

#define block_0_0_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	block_0__x_##SELECTOR						      \
	    (predictions, references, stride, 0, REFERENCE_1_1);	      \
    }

#define block_0_0_0(predictions, references, stride, line_size) \
    block_0_0_x(predictions, references, stride, line_size, 0)

#define block_0_0_1(predictions, references, stride, line_size) \
    block_0_0_x(predictions, references, stride, line_size, 1)

#define block_0_0_2(predictions, references, stride, line_size) \
    block_0_0_x(predictions, references, stride, line_size, 2)

#define block_0_0_3(predictions, references, stride, line_size) \
    block_0_0_x(predictions, references, stride, line_size, 3)

#define block_0_1_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	block_0__x_##SELECTOR						      \
	    (predictions, references, stride, line_size, REFERENCE_2_1);      \
    }

#define block_0_1_0(predictions, references, stride, line_size) \
    block_0_1_x(predictions, references, stride, line_size, 0)

#define block_0_1_1(predictions, references, stride, line_size) \
    block_0_1_x(predictions, references, stride, line_size, 1)

#define block_0_1_2(predictions, references, stride, line_size) \
    block_0_1_x(predictions, references, stride, line_size, 2)

#define block_0_1_3(predictions, references, stride, line_size) \
    block_0_1_x(predictions, references, stride, line_size, 3)

#define block_0_2_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	block_0__x_##SELECTOR						      \
	    (predictions, references, stride, line_size, REFERENCE_1_2);      \
    }

#define block_0_2_0(predictions, references, stride, line_size) \
    block_0_2_x(predictions, references, stride, line_size, 0)

#define block_0_2_1(predictions, references, stride, line_size) \
    block_0_2_x(predictions, references, stride, line_size, 1)

#define block_0_2_2(predictions, references, stride, line_size) \
    block_0_2_x(predictions, references, stride, line_size, 2)

#define block_0_2_3(predictions, references, stride, line_size) \
    block_0_2_x(predictions, references, stride, line_size, 3)

#define block_0_3_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	block_0__x_##SELECTOR						      \
	    (predictions, references, stride, line_size, REFERENCE_2_2);      \
    }

#define block_0_3_0(predictions, references, stride, line_size) \
    block_0_3_x(predictions, references, stride, line_size, 0)

#define block_0_3_1(predictions, references, stride, line_size) \
    block_0_3_x(predictions, references, stride, line_size, 1)

#define block_0_3_2(predictions, references, stride, line_size) \
    block_0_3_x(predictions, references, stride, line_size, 2)

#define block_0_3_3(predictions, references, stride, line_size) \
    block_0_3_x(predictions, references, stride, line_size, 3)

#define block_1__x_0(predictions, references_0, references_1, stride, \
		     line_size, REFERENCE)				      \
    {									      \
	unsigned i = 16;						      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ =						      \
		REFERENCE##_0(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions =						      \
		REFERENCE##_3(references_0, references_1, line_size);	      \
	    predictions += stride - 15;					      \
	    references_0 += stride - 15;				      \
	    references_1 += stride - 15;				      \
	}								      \
    }

#define block_1__x_1(predictions, references_0, references_1, stride, \
		     line_size, REFERENCE)				      \
    {									      \
	unsigned i = 8;							      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ =						      \
		REFERENCE##_0(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions =						      \
		REFERENCE##_3(references_0, references_1, line_size);	      \
	    predictions += stride - 15;					      \
	    references_0 += stride - 15;				      \
	    references_1 += stride - 15;				      \
	}								      \
    }

#define block_1__x_2(predictions, references_0, references_1, stride, \
		     line_size, REFERENCE)				      \
    {									      \
	unsigned i = 16;						      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ =						      \
		REFERENCE##_0(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions =						      \
		REFERENCE##_3(references_0, references_1, line_size);	      \
	    predictions += stride - 7;					      \
	    references_0 += stride - 7;					      \
	    references_1 += stride - 7;					      \
	}								      \
    }

#define block_1__x_3(predictions, references_0, references_1, stride, \
		     line_size, REFERENCE)				      \
    {									      \
	unsigned i = 8;							      \
									      \
	for (; i; i--) {						      \
	    REFERENCE##_decls;						      \
									      \
	    *predictions++ =						      \
		REFERENCE##_0(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_1(references_0, references_1, line_size);	      \
	    *predictions++ =						      \
		REFERENCE##_2(references_0, references_1, line_size);	      \
	    *predictions =						      \
		REFERENCE##_3(references_0, references_1, line_size);	      \
	    predictions += stride - 7;					      \
	    references_0 += stride - 7;					      \
	    references_1 += stride - 7;					      \
	}								      \
    }

#define block_1_0_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, 0,	      \
	     REFERENCE_1_1_1_1);					      \
    }

#define block_1_0_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_0_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_0_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_0_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_0_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_0_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_0_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_0_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_1_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, 0,	      \
	     REFERENCE_1_1_2_1);					      \
    }

#define block_1_1_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_1_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_1_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_1_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_1_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_1_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_1_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_1_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_2_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_1_1_2);					      \
    }

#define block_1_2_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_2_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_2_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_2_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_2_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_2_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_2_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_2_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_3_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_1_2_2);					      \
    }

#define block_1_3_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_3_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_3_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_3_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_3_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_3_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_3_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_3_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_4_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, 0,	      \
	     REFERENCE_2_1_1_1);					      \
    }

#define block_1_4_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_4_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_4_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_4_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_4_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_4_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_4_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_4_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_5_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, 0,	      \
	     REFERENCE_2_1_2_1);					      \
    }

#define block_1_5_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_5_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_5_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_5_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_5_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_5_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_5_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_5_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_6_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_1_1_2);					      \
    }

#define block_1_6_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_6_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_6_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_6_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_6_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_6_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_6_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_6_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_7_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_1_2_2);					      \
    }

#define block_1_7_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_7_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_7_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_7_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_7_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_7_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_7_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_7_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_8_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_2_1_1);					      \
    }

#define block_1_8_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_8_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_8_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_8_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_8_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_8_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_8_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_8_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_9_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_2_2_1);					      \
    }

#define block_1_9_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_9_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_9_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_9_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_9_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_9_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_9_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_9_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_a_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_2_1_2);					      \
    }

#define block_1_a_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_a_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_a_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_a_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_a_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_a_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_a_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_a_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_b_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_1_2_2_2);					      \
    }

#define block_1_b_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_b_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_b_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_b_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_b_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_b_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_b_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_b_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_c_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_2_1_1);					      \
    }

#define block_1_c_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_c_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_c_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_c_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_c_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_c_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_c_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_c_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_d_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_2_2_1);					      \
    }

#define block_1_d_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_d_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_d_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_d_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_d_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_d_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_d_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_d_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_e_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_2_1_2);					      \
    }

#define block_1_e_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_e_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_e_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_e_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_e_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_e_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_e_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_e_x(predictions, references_0, references_1, stride, line_size, 3)

#define block_1_f_x(predictions, references_0, references_1, stride, \
		    line_size, SELECTOR)				      \
    {									      \
	block_1__x_##SELECTOR						      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     REFERENCE_2_2_2_2);					      \
    }

#define block_1_f_0(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_f_x(predictions, references_0, references_1, stride, line_size, 0)

#define block_1_f_1(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_f_x(predictions, references_0, references_1, stride, line_size, 1)

#define block_1_f_2(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_f_x(predictions, references_0, references_1, stride, line_size, 2)

#define block_1_f_3(predictions, references_0, references_1, stride, \
		    line_size) 						      \
    block_1_f_x(predictions, references_0, references_1, stride, line_size, 3)

#endif				/* __SEEK_H262_8_H__ */
