/*
 * h262.a.l7.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_A_L7_H__
#define __SEEK_H262_A_L7_H__

#include <h262.3.d4.h>
#include <h262.c.l7.h>

#define wideblock_0__y_0(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	WIDE_REFERENCE##_decls;						      \
	unsigned i = 8, *prediction4s;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
									      \
	WIDE_REFERENCE##_init(references, line_size, stride);		      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_even(references, line_size, stride);	      \
									      \
	    _1st_##WIDE_REFERENCE(*prediction4s);			      \
	    _2nd_##WIDE_REFERENCE(prediction4s[1]);			      \
	    _3rd_##WIDE_REFERENCE(prediction4s[2]);			      \
	    _4th_##WIDE_REFERENCE(prediction4s[3]);			      \
									      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + stride);		      \
									      \
	    WIDE_REFERENCE##_odd(references, line_size, stride);	      \
									      \
	    _1st_##WIDE_REFERENCE(*prediction4s);			      \
	    _2nd_##WIDE_REFERENCE(prediction4s[1]);			      \
	    _3rd_##WIDE_REFERENCE(prediction4s[2]);			      \
	    _4th_##WIDE_REFERENCE(prediction4s[3]);			      \
									      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_0__y_1(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#define wideblock_0__y_2(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#define wideblock_0__y_3(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#undef wideblock_0_3_y

#define wideblock_0_3_y(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__y_##SELECTOR(predictions, references, stride, line_size, \
				  WIDE_REFERENCE_2_2_jane2);		      \
    }

#if 0
# undef block_0_3_0

# define block_0_3_0(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 0)
#endif				/* 0 */

#if 0
# undef block_0_3_1

# define block_0_3_1(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 1)
#endif				/* 0 */

#if 0
# undef block_0_3_2

# define block_0_3_2(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 2)
#endif				/* 0 */

#if 0
# undef block_0_3_3

# define block_0_3_3(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 3)
#endif				/* 0 */

#endif				/* __SEEK_H262_A_L7_H__ */
