/*
 * h262.b.l7.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_B_L7_H__
#define __SEEK_H262_B_L7_H__

#include <h262.3.d4.h>
#include <h262.c.l7.h>

#define wideblock_0__y_4(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#define wideblock_0__y_5(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	WIDE_REFERENCE##_jane_decls;					      \
	unsigned i = 2, *prediction4s;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
									      \
	WIDE_REFERENCE##_init(references, line_size, stride);		      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_even(references, line_size, stride);	      \
									      \
	    MAJOR_##WIDE_REFERENCE##_jane(*prediction4s);		      \
	    MINOR_##WIDE_REFERENCE##_jane(prediction4s[1]);		      \
									      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + stride);		      \
									      \
	    WIDE_REFERENCE##_odd(references, line_size, stride);	      \
									      \
	    MAJOR_##WIDE_REFERENCE##_jane(*prediction4s);		      \
	    MINOR_##WIDE_REFERENCE##_jane(prediction4s[1]);		      \
									      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_0__y_6(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#define wideblock_0__y_7(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
    }

#undef wideblock_0_3_y

#define wideblock_0_3_y(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__y_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_2_2); \
    }

#if 0
# undef block_0_3_4

# define block_0_3_4(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 4)
#endif				/* 0 */

#if 0
# undef block_0_3_5

# define block_0_3_5(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 5)
#endif				/* 0 */

#if 0
# undef block_0_3_6

# define block_0_3_6(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 6)
#endif				/* 0 */

#if 0
# undef block_0_3_7

# define block_0_3_7(predictions, references, stride, line_size) \
    wideblock_0_3_y(predictions, references, stride, line_size, 7)
#endif				/* 0 */

#endif				/* __SEEK_H262_B_L7_H__ */
